;spooler: @#$t0 c m10 L0; marg=10
title	Tall Tree Systems JINPUT
page	60,128
;********************************************************
;*		  JINPUT 1.11				*
;*  	Copyright (c) 1986 Tall Tree Systems		*
;* written for Tall Tree Systems by John Henderson	*
;*		Oct 30, 1986				*
;********************************************************
.radix 16 
cseg segment para
jprint	proc	far
	org	100
assume	cs:cseg,ds:cseg,es:cseg,ss:cseg
begin	equ	$
	jmp	firstcode
	db	'000000000000000'
serno	db	'000001',0
copyw	db	'Copyright(c)1986 Tall Tree Systems',0
verno	db	' Ver 1.11  Ser.#',0
msgjinput db	'JINPUT ',0
msgjpagername db 'EMMXXXX0',0

;--various control parameters

pagcnt	dw	63d	;image pages
procid	dw	0	;jpager process id
afseg	dw	0	;application frame segment
skipln	dw	4	;lines to skip at top
skipdot	dw	48d	;dots to skip at left
maxdot	dw	2416d	;dots/line
dmaln	dw	3213d	;cnt of lines to dma
fhandle	dw	0	;file handle

;--Setup Environment and Print Installing message
firstcode:
	push	cs		;ds=cs
	pop	ds
	mov	si,offset msgjinput
	call	tvprompt
	mov	si,offset verno	;ver#
	call	tvprompt
	mov	si,offset serno	;ser#
	call	tvprompt
	call	blank			;1 space
	mov	si,offset serno+7	;Copyright
	call	tvprompt
	call	crlf

;--obtain memory from expanded memory driver

	mov	ax,3d00		;device open call/read-only mode
	mov	dx,offset msgjpagername
	int	21
	jc	noaccess
	xchg	ax,bx		;dev handle from open
	mov	ax,4407		;issue ioctl/status req
	xor	cx,cx		;no bytes back
	int	21
	pushf
	push	ax
	mov	ah,3e		;device close call
	int	21
	pop	ax
	popf
	jc	noaccess
	cmp	al,0ff
	je	getmem
noaccess:
	mov	si,offset msgnojlaser
noac3:	call	errormsg
	int	20		;abort pgm
msgnojlaser: db	'missing JLASER.BIN in CONFIG.SYS',24
getmem:	mov	ah,40		;get memory status
	int	67
	or	ah,ah
	jnz	noaccess
	mov	ah,42		;get tot & unallocated pages
	int	67		;bx=unallocated pages
	or	ah,ah
	jnz	noaccess
	xchg	ax,bx
	mov	bx,[pagcnt]
	inc	bx		;one for the index
	cmp	bx,ax		;enuf room?
	jbe	gmem2		;yes
gmem1:	mov	si,offset msgnotenufpages
	jmp	short noac3
msgnotenufpages: db 'Not enough unallocated JPAGER memory',24
gmem2:	mov	ah,43		;allocated bx pages
	int	67
	or	ah,ah
	jnz	gmem1
	mov	[procid],dx	;process id
	mov	ah,41		;get segment adr
	int	67		; of application frame
	mov	[afseg],bx
	mov	ax,4401		;map logical page
	xor	bx,bx		; used for index
	int	67		; located in 2nd phy page

;--build index for all lines in image

	mov	ah,3dh
	mov	dx,[procid]
	mov	bx,[pagcnt]
	int	67
	or	ah,ah
	mov	[dmaln],bx	;ret value
	jnc	setup
	mov	si,offset msgnojlaser
	jmp	doer

;--set the scanner parameters into al,bx,cx,dx

setup:	mov	bx,82
	mov	ax,[bx]		;2 bytes typed after jinput<sp>
	sub	al,'0'		;1st char typed after jinput<sp>
	jb	norm
	cmp	al,3
	ja	norm
	shl	al,1		;mode(0-3) into bits 2-3
	shl	al,1
	and	ah,0dfh		;convert to upper case
	cmp	ah,'D'		;2nd char typed after jinput<sp>
	jne	setup1
	or	al,1		;dark density (01)
	jmp	short setem
setup1:	cmp	ah,'L'
	jne	setup2
	or	al,2		;light density (10)
	jmp	short setem
setup2:	or	al,0		;normal density (00)
	jmp	short setem
norm:	mov	al,0		;2 val normal mode(00)/normal density(00)

; mode values:	00 - 2 val normal
;		01 - 2 val or
;		10 - bayer dithering
;		11 - fatting dithering

setem:	mov	bx,[skipdot]	;skip 64 dots on left
	mov	cx,[maxdot]	;number of dots to read
	mov	dx,[skipln]	;skip 4 lines on top
	mov	ah,3bh		;set scanner parms function
	int	67
	or	ah,ah
	jnz	scbad

;--scan paper into image buffer

	mov	ah,3c		;scan in image
	int	67
	or	ah,ah
scbad:	mov	si,offset msgerscan
	jnz	doer
	mov	si,offset msgscan
	call	crlftvprompt

;--print image in buffer

	mov	ah,3f
	int	67
	or	ah,ah
	jz	thru
	cmp	ah,91		;parity error code
	mov	si,offset msgparity
	je	doer
	cmp	ah,92		;no cartridge
	mov	si,offset msgnocart
	je	doer
	cmp	ah,93		;toast & jam
	mov	si,offset msgjam
	je	doer
	cmp	ah,94		;test printing
	mov	si,offset msgtest
	je	doer
	cmp	ah,90		;paper out
	mov	si,offset msgpaper
	je	doer
	jmp	short noprint
doer:	call	errormsg
	jmp	short noprint

thru:	mov	ah,45		;deallocate memory
	mov	dx,[procid]
	int	67
	int	20		;pgm end

noprint:mov	si,offset msgnoprint
erthru:	call	errormsg
	jmp	short thru

msgparity	db	'Printer parity error',0dh,0a,24
msgnocart	db	'Printer cartridge missing',0dh,0a,24
msgjam		db	'Printer jam',0dh,0a,24
msgtest		db	'Printer busy test printing',0dh,0a,24
msgpaper	db	'Printer out of paper',0dh,0a,24
msgnoprint 	db	'Printer error - reprint',0dh,0a,24

msgerscan	db	'Scanner failure',0dh,0a,24
msgscan		db	'Image scanned',0dh,0a,24

TVPRIMMOD proc near
;--CRLFTV (crlf,msg,crlf)
crlftv:	call	crlf
;--TV (with  crlf)--
tv:	call	tvprompt	;si=message
;--CR Carriage return and lf--
crlf:	push	si
	mov	si,offset cseg:msgcrlf
	call	tvprompt
	pop	si
	ret
msgcrlf:
	db	0dh,0ah,24
;--CRLFTVPROMPT (crlf,message, no crlf)
crlftvprompt:
	call	crlf
;--TVPROMPT (no crlf, msg,no crlf)
;(tv out till null or "$")
; si=ptr message
tvprompt:
	cld
	push	ax
tvpr22:	lodsb		;al=(si),si+1
	call	tvbytechkend	;cy=0 or $
	jnc	tvpr22		;till done
tvpr99:	pop	ax
	ret

;--TV BYTE CHECK END (sends chr, tests for 0,$)
; al=chr, cy=0 or $, nc,z=cr, nc,nz=other
tvbytechkend:
	or	al,al		;null? (end?)
	jz	tvbt20		;yes
	cmp	al,"$"		;$?
	jz	tvbt20		;yes
	call	tvbyte		;send chr
	cmp	al,0Dh		;cr?
	clc
	ret			;nc, z=cr, nz=other
tvbt20: stc
	ret			;cy=0 or $ (end message)

;--ERROR message to TV (crlf,"ERROR",no crlf)
errortv:
	push	si
	mov	si,offset cseg:msgerror
	call	crlftvprompt
	pop	si
	ret
msgerror: db	07,"*ERROR*  ",24
;--ERRORMSG (si=message to follow "ERROR")
errormsg:
	call	errortv		;"error"
	jmp short tvprompt	; actual message

;--BEEP
beep:	mov	al,07h		;bell
	jmp short tvbyte
;--BLANK
blank:	mov	al,' '
;--TVBYTE (tvout)
; al=chr,   no mod all other regs
tvbyte:	push	dx
tvb30:	push	ax
	mov	dl,al
	mov	ah,2		;otcon
	int	21h		;tty output
	pop	ax
	pop	dx
	ret
TVPRIMMOD endp

;========STACK SEGMENT============================
if	($-begin) mod 10h
org	($-begin)+10h-(($-begin) mod 10h)
endif
	org	$+140h		;DOS man recommends this much
begsp =	$
;...............END OF STACK SEGMENT..............

jprint endp
cseg ends
end begin	;starting location=begin
