; OKCHECK looks at files and searches for valid file headers
; it is callable version of CHKPIC
dseg segment para public 'DATA'
     assume   cs:cseg,ds:dseg,es:dseg
;
;     MAC HEADER
;

MAC_VERSION    DB     0
MAC_LEN_FN     DB     6
MAC_FILE_NAME  DB     'OPTIKS'
     DB     57 DUP(0)
MAC_FILE_TYPE  DB     'PNTG'
MAC_FILE_CREAT DB     'MPNT'
MAC_FLAGS     DB     1
MAC_FILL1     DB     0
MAC_VERT     DW     0
MAC_HORIZ     DW     8001H
MAC_FOLDER     DW     0
MAC_PROT     DB     0
MAC_FILL2     DB     0
MAC_FORK     DD     0
MAC_R_FORK     DD     0
MAC_CRT_DATE   DB     9BH,41H,8CH,0FAH
MAC_LST_MOD    DB     9BH,41H,8CH,0FEH
MAC_FILL3     DB     27 DUP(0)
MAC_OS     DW     0
; mac body starts here
MAC_REV     DB     0,0,0,2
;
emess1   db  ' Bad or missing file name',0
emess1a  db  ' File not found',0
emess2   db  ' Error opening file',0
emess3   db  ' Error reading header or file too small',0
emess4   db  ' Unrecognizable file header',0
mess1    db  ' This is a MAC file, but the binary header is missing',0
mess2    db  ' Mac header found, name is: '
pname    db  11  dup(' ')
         db  0
mess3    db  ' Probably a Mac file, but binary header is zeroes',0
mess5    db  ' Looks like a Microsoft Paint file',0
mess6    db  ' This might be a GEM paint file',0
mess7    db  ' This must be an RLE file',0
mess8    db  ' Looks like a ZSOFT PC Paintbrush file',0
mess9    db  7,' This is an OPTIKS file',0
mess10   db  ' This is a CGA basic BLOAD/BSAVE file',0
mess11   db  ' This just might be Datacopy WIPS file',0
mess12   db  ' This could be a PC PAINT 1.50 PIC file',0
mess13   db  ' This could be a PC PAINT 2.00 PIC file',0
mess14   db  ' Could this be an IBM ISF file? I doubt it.',0
mess15   db  ' This is Lotus .PIC file.',0
mactype  db  0
filesi   dw  0
MSP     DB     'DanM'
gem     db     0,1,0,8
RLE     Db     27,'G'
PCB     db     0ah,02,01
PCR     Db     'KPG'
bas     db     0fdh
     DW     0b800h
DCOPY     DW     0FFFFH
PIC     DB     0FEH
     DW     0B800H
PC2     DW     1234H
ISF     db     70h
lotus     db     1,0,0,0,1,0,8,0,44h,0,0,0,0,0ch,7fh,9,6
extrn  strg:byte,buffer:word
extrn  curx:word,cury:word,left_margin:word
dseg  ends
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:dseg,es:dseg
extrn  reset_segs:near,open_in:near,close_file:near
extrn  read_file:near,prbox:near,list_file2:near
extrn  goback:near
bad_parse:
     lea    dx,emess1
     jmp    end_check
bad_parse2:
     call   goback
do_check:
public do_check
; get the file pattern into str
     call   list_file2
     cmp    al,27
     je     bad_parse2
     cmp    strg,0
     je     bad_parse2
     lea    dx,strg
     call   open_in
     jnc    ok_open
     lea    dx,emess2
     jmp    end_check
ok_open:
     mov    cx,132
     lea    dx,mac_version
     call   read_file
     jnc    good_128
     lea    dx,emess3
     jmp    end_check
good_128:
     call   mac_check
     jnc    its_a_mac
     call   other_types
     jnc    end_check
     lea    dx,emess4
     jmp    end_check
its_a_mac:
     lea     dx,mess1
     cmp     mactype,0
     je     end_check
     lea     dx,mess3
     cmp     mactype,2
     je     end_check
     lea     si,mac_file_name
     lea     di,pname
     mov     cx,11
     mov     al,' '
rep  stosb
     lea     di,pname
     mov     cx,11
pn_loop:
     lodsb
     cmp  al,0
     je   pn_loope
     stosb
     loop  pn_loop
pn_loope:
     lea     dx,mess2
end_check:
; see if its time to end
     mov    curx,20
     mov    left_margin,20
     mov    cury,32
     call   prbox
     call   close_file
     call   goback
mac_check:
;
; we will put the stuff for checking out the file here
; have to check and see what kind of thingy we got, we read in 128
; bytes, but we may have to read in either 384 more or 512 mode
;
; check to see if we have a binary zero header guy
     mov  mactype,0
     lea  di,mac_version+2
     mov  cx,64
     mov  al,0
     cld
repe  scasb
     jne  mac_check_more
     mov  mactype,2
     jmp  zero_head
mac_check_more:
; check for macbinary header
;
     cmp   mac_version,1
     jg    check_mp
     cmp   mac_file_name,'A'
     jl    check_mp
     cmp   mac_file_name,'z'
     jg    check_mp
     cmp   mac_file_type,'z'
     jg    check_mp
     cmp   mac_file_type,'A'
     jl    check_mp
     cmp   word ptr mac_r_fork,0
     jne   check_mp
     cmp   word ptr mac_r_fork+2,0
     jne   check_mp
; check version number
     cmp   byte ptr mac_rev,0
     jne   bad_mac
     cmp   byte ptr mac_rev+1,0
     jne   bad_mac
     cmp   byte ptr mac_rev+2,0
     jne   bad_mac
     cmp   byte ptr mac_rev+3,5
     jg    bad_mac
     cmp   byte ptr mac_rev+3,0
     jl    bad_mac
     mov   mactype,1
zero_head:
; it looks like we got the macbinary header assume that there
; is a 512 macpaint header
     clc
     ret
check_mp:
     cmp   byte ptr mac_version,0
     jne   bad_mac
     cmp   byte ptr mac_version+1,0
     jne   bad_mac
     cmp   byte ptr mac_version+2,0
     jne   bad_mac
     cmp   byte ptr mac_version+3,5
     jg    bad_mac
     cmp   byte ptr mac_version+3,0
     jl    bad_mac
     clc
     ret
bad_mac:
     stc
     RET
;

other_types  proc  near
; check for other types
     lea    dx,mess5
     mov    cx,4
     lea    di,msp
     call   compare_head
     jc     check_gem
     ret
check_gem:
     lea    dx,mess6
     mov    cx,4
     lea    di,gem
     call   compare_head
     jc     check_rle
     ret
check_rle:
     lea    dx,mess7
     mov    cx,2
     lea    di,rle
     call   compare_head
     jc     check_pcb
     ret
check_pcb:
     lea    dx,mess8
     mov    cx,3
     lea    di,pcb
     call   compare_head
     jc     check_pcr
     ret
check_pcr:
     lea    dx,mess9
     mov    cx,3
     lea    di,pcr
     call   compare_head
     jc     check_bas
     ret
check_bas:
     lea    dx,mess10
     mov    cx,4
     lea    di,bas
     call   compare_head
     jc     check_dcopy
     ret
check_dcopy:
     lea    dx,mess11
     mov    cx,2
     lea    di,dcopy
     call   compare_head
     jc     check_pic
     ret
check_pic:
     lea    dx,mess12
     mov    cx,3
     lea    di,pic
     call   compare_head
     jc     check_pc2
     ret
check_pc2:
     lea    dx,mess13
     mov    cx,2
     lea    di,pc2
     call   compare_head
     jc     check_isf
     ret
check_isf:
     lea    dx,mess14
     cmp    mac_version,70h
     jne    check_lot
     mov    bl,mac_version+1
     mov    bh,0
     add    bx,2
     cmp    byte ptr mac_version[bx],91h
     jne    check_lot
     clc
     ret
check_lot:
     lea    dx,mess15
     mov    cx,17
     lea    di,lotus
     call   compare_head
     jc     check_another
     ret
check_another:
     stc
     ret
compare_head:
     lea    si,mac_version
     cld
rep     cmpsb
     je     got_match
     stc
     ret
got_match:
     clc
     ret
other_types  endp
cseg     ends
     end
