;
;  reads ans writes wpg files
;
include f:\ok\okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   buffer:word,hash_segment:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
     EXTRN   WPG_HEADER:WORD
     EXTRN   WPG_HEADERo:WORD
     EXTRN   WIDTH_PIX:WORD
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
     extrn   handle:word
     extrn   planes:word
     extrn   plane_switch:byte

; header is first 16 bytes
; followed by 0f, start wpg data
wpg_header2 equ this byte
     db   15   ; start wpg data
     db   6,1,0
wpg_scr db   80,25,0e0h,2eh   ; version, flags, screen
     db   14   ; color map (for black and white
     db   10   ; length of map
     db   0    ; number of entries
     db   0,2,0,-1,-1,-1,0,0,0    ; primitive color table
     db   11   ; bitmap data
     db   0ffh  ; 38
wpg_length  dd  0   ; total length of data stuff
w11_width   dw   0
w11_height  dw   0
     dw 1       ;48
     dw 300
     dw 300
      header2_len equ 52
last_bytes db   16  ; end wpg data
     db   0
;
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   reset_segs:near
extrn   read_file:near
extrn   flush_buffer:near
extrn   next_wait:near
extrn   fill_buffer:near,write_file:near
extrn   calc_file_size:near
extrn   decomp:word
phase  dw  0
;
;

     PUBLIC  wpg_OUT
; writes out the WPG header information
wpg_OUT:
     call    reset_segs
     call  calc_file_size
     MOV     AX,WIDTH_BYTES  ;SAVE AS BYTES
     SHL     AX,1     ;MAKE INTO BYTES
     SHL     AX,1     ;
     SHL     AX,1     ;
     MOV     w11_WIDTH,AX
     MOV     AX,HEIGHT_PIX   ;SAVE AS PIXELS
     MOV     w11_HEIGHT,AX
;
; calculate virt screen size
     mov     ax,width_bytes
     shl     ax,1
     shl     ax,1
     mov     bx,height_pix
     shr     bx,1
     shr     bx,1
     shr     bx,1
     cmp     ax,256
     jl      ok_wout1
     shr     bx,1
     shr     ax,1
ok_wout1:
     mov     wpg_scr,al
     mov     wpg_scr+1,bl
;
     mov   cx,word ptr wpg_headero
     lea   dx,word ptr wpg_headero+2
     call  write_file
     jnc   write_header_2
     ret
write_header_2:
; have to fill in and write the second part of the header
     mov   cx,52-16
     lea   dx,wpg_header2
     call  write_file
     ret
; don't forget to reset the file at the point of the size and fix that
;

     PUBLIC  wpg_write
wpg_WRITE:
     call  reset_segs
; prime the pump by reading in a chunk of data
     mov    ax,buffer
     mov    es,ax
     mov    ds,ax
     call   fill_buffer
     jc     wpg_done
     cmp    cx,0
     jle    wpg_done
     mov    si,0
     jmp    wpg_top
wpg_done:
     jmp    wpg_bot
wpg_top:
     call   reset_segs
     push   cx  ; save the cx from the fill buffer
     mov    bp,width_bytes
     mov    es,buffer
     mov    ds,buffer
     mov    di,buffersize   ; start of data
;
     call   wpgpack
     call   wpg_line_out
;
;
     pop    cx
     jnc    wpg_loop
     jmp    leave_wpg
wpg_loop:
     call   reset_segs
     sub    cx,width_bytes
     cmp    cx,0
     jle    done_this_get
     jmp    wpg_top
done_this_get:
     jmp    wpg_write
;
wpgpack:
    cmp   bp,0
    jg    pack0
    clc
    ret
pack0:
;
;   first byte
;
    mov   dx,0
    mov   bx,di
    lodsb
    mov   ah,al
    dec   bp     ; used one byte
;
;  check to see if the first byte is a repeater
;
pack0a:
    cmp   bp,3
    jl    first_not_rep
    cmp   byte ptr ds:[si],al
    jne   first_not_rep
    cmp   byte ptr ds:[si+1],al
    jne   first_not_rep
    cmp   byte ptr ds:[si+2],al
    jne   first_not_rep
; first guy is a string
;
;  find out how long the string is
pack1:
    mov    cx,bp
    cmp    cx,124
    jle    ok_cx
    mov    cx,124
ok_cx:
    mov    dx,si
    mov   ah,al
    push   si
    push   di
    cld
    mov    di,dx
repe scasb
    sub    di,dx  ; count of bytes
    mov    dx,di
    pop    di
    pop    si
; dx has the length of the string
    add   si,dx
    dec   si
    sub   bp,dx
    inc   bp   ; we already subtracted one for the first
    or    dl,80h
    mov   al,dl
    xor   ah,0ffh
    stosw
    jmp    wpgpack
first_not_rep:
; al has the no-rep string
; have to find out how many are in non-rep string
    mov   bx,di  ; where to put results
    inc   di
    mov   dx,0
pack2:
    xor   al,0ffh
    stosb
    inc   dx
    cmp   bp,0
    jle   pack5
    lodsb
    mov   ah,al
    dec   bp
    cmp   dx,127
    jge   pack4
    cmp    bp,3
    jle   pack2
    cmp    byte ptr ds:[si],al
    jne   pack2
    cmp    byte ptr ds:[si+1],al
    jne   pack2
    cmp    byte ptr ds:[si+2],al
    jne   pack2
; here we have the start of another string
    mov   byte ptr es:[bx],dl
    mov   bx,di
    mov   dx,0
    jmp   pack1
pack4:
; ran out current string, start from top again
    mov   byte ptr es:[bx],dl
    mov   bx,di
    mov   dx,0
; we have a byte in al for checking, don't know if it repeats
    jmp   pack0a
pack5:
; done this line
    mov   byte ptr es:[bx],dl
    ret
;
;
;
wpg_bot:
     cmp    di,buffersize
     jle    leave_wpg
     call   reset_segs
     mov    cx,di
     mov    dx,buffersize
     sub    cx,dx
     mov    ds,buffer
     call   write_file
leave_wpg:
; have to write out the last 2 bytes
     call reset_segs
     mov   cx,2
     lea   dx,last_bytes
     call  write_file
; relocate fix the size of wpg data
      mov   ax,4201h ; relative to current location
      mov   cx,0
      mov   dx,0
      mov   bx,handle
      int   21h
;  seeked to where we are
;     cx:ax  has the location
      sub    ax,header2_len+4  ; extra stuff
      sbb    dx,0
      or     ah,80h
      mov    word ptr wpg_length,ax
      mov    word ptr wpg_length+2,dx
      mov    ax,4200h  ; relative to beg
; set cx:dx to location in file
      mov    cx,0
      mov    dx,38     ; location of guy to fix
      mov    bx,handle
      int    21h
      lea    dx,wpg_length
      mov    cx,4
      call   write_file
      stc
      ret
;
;
wpg_line_out: ; write out the line at di
; ds and es are laready set
     push  ds
     push  es
     call  reset_segs
     mov   ds,buffer
     mov   dx,buffersize
     mov   cx,di
     sub   cx,dx
     cmp   cx,0
     jle   leave_out
     call  write_file
     jc    leave_out
     mov   di,0
     pop   es
     pop   ds
     clc
     ret
leave_out:
     pop   es
     pop   ds
     stc
     ret
;
;

WPG_READ:
public wpg_read


wpg_line:
public wpg_line
; this decompressed one line of PCX file
; si and di are set
;
;  phase 0 means that we are reading a new line
;  phase 1 means copy last line from has_seg
;
;
;
    call    reset_segs
    mov    bx,width_bytes
    cmp    cs:phase,0
    je    phase0
    jmp   copy_phase
phase0:
    mov   ax,hash_segment
    mov   es,ax
    mov   ax,buffer
    mov   ds,ax
    push  di
    mov   di,0
    cld
wpg_loop0:
     cmp   bx,0
     jg   wpg_loop1
     pop   di
     inc   cs:phase
     jmp   copy_phase
wpg_loop1:
     lodsb
     cmp   al,0ffh
     je    repeat_ff
     cmp   al,0
     je    repeat_line
     jl    repeat_byte
     mov   cl,al
     mov   ch,0
    sub   bx,cx
     cld
wpg_loop3:
     lodsb
     xor   al,0ffh
     stosb
     loop  wpg_loop3
    jmp   wpg_loop0
repeat_ff:
     lodsb
     mov    cl,al
     mov    ch,0
     mov    al,0
     sub    bx,cx
rep   stosb
    jmp   wpg_loop0
repeat_line:
    pop   di
    lodsb
    mov   ah,0
    mov   cs:phase,ax
    jmp    copy_phase
repeat_byte:
    mov   cl,al
    and   cx,07fh
    lodsb
    xor   al,0ffh
    cld
    sub   bx,cx
rep stosb
    jmp   wpg_loop0
copy_phase:
    call    reset_segs
; there is a count in phase which means copy data from the
; previous line (hash_segment:0)
    push   si
    mov    cx,width_bytes
    mov    ax,buffer
    mov    es,ax
    mov    ax,hash_segment
    mov    ds,ax
    mov    si,0
    cld
rep   movsb
    pop   si
    call  reset_segs
    dec   cs:phase
    clc
    ret


;
WPG_IN:
     PUBLIC  WPG_IN
;
     call    reset_segs
     mov     cs:phase,0
; check the signature and see if it is for us
     lea    si,wpg_header+2
     lea    di,wpg_headero+2
     mov    cx,4
     cld
repe cmpsb
     je     good_wpg_head
bad_wpg_head:
     stc
     ret
good_wpg_head:
; seek to start of wpg header file
;
; dx:ax has the dword in it, which is offset from start of file
; we must position in file at this location
     mov     bx,handle
     mov     cx,word ptr wpg_header.wpg_start+2
     mov     dx,word ptr wpg_header.wpg_start
     mov     ax,4200h
     int     21h
     jc     bad_wpg_head
;
; cycle through the records
;
record_loop:
     call  get_word
     cmp  al,11
     je   bitmap_rec
;    cmp  al,14
;    je   colormap_dat
;
;
; ignore all others
;
; check to see the length to futs through
;
     cmp  ah,0ffh
     je   not_byte
     mov  al,ah
     mov  ah,0
     mov  dx,0
     jmp  is_word
not_byte:
; the data is not a byte
     call  get_word
;
     mov   dx,0
     cmp   ax,0
     jl    is_word
; got a dword
     mov   dx,ax
     and   dx,7fffh
     call  get_word
is_word:
; have a word of data to bypass
     mov   cx,4000h
     sub   ax,4000h
     sbb   dx,0
     cmp   dx,0
     jge   no_fix_dx
     add   cx,ax
     mov   dx,0
     mov   ax,0
no_fix_dx:
     push  ax
     push  dx
     push   ds
; read  cx worth of data into the buffer to bypass junk
     mov   dx,0
     mov   ax,buffer
     mov   ds,buffer
     call   read_file
     cmp   ax,cx
     jne    bad_junk
     clc
     jmp    good_junk
bad_junk:
     stc
good_junk:
     pop   ds
     pop   dx
     pop   ax
     jc    bad_wpg_head
     cmp   dx,0
     jg    is_word
     cmp   ax,0
     jg    is_word
     jmp   record_loop
bitmap_rec:
; have the bitmapped data record, I must fill in size data
;
; have the width in al
     cmp   ah,0ffh
     jne   by_length
     call  get_word
     cmp   ax,0
     jge   by_length
     call  get_word
by_length:
     call  get_word
     mov   width_pix,ax
     add   ax,7
     shr   ax,1
     shr   ax,1
     shr   ax,1
     mov   width_bytes,ax
     call  get_word
     mov   height_pix,ax
     call  get_word
;    bits per pixel in ax
     mov   planes,1
     cmp   plane_switch,1
     jne   no_planes
     mov   planes,ax
     jmp   is_planes
no_planes:
     mul   width_bytes
     mov   width_bytes,ax
is_planes:
;    next 4 are resolution
     call  get_word
     call  get_word
; rest is bit mapped data
     lea  ax,wpg_line
     mov  cs:decomp,ax
;
     clc
     ret

get_word:
     push   ds
     mov   ax,buffer
     mov    dx,0
     mov    cx,2
     call   read_file
     mov   ax,word ptr ds:[0]
     pop    ds
     ret
;colormap_dat:

;
;
;
;
;
;
;


CSEG     ENDS
     END
;
wpg_trailer equ this byte
; this is stuff that goes into the end of a file
