; OKFILE3.ASM has the read and write routines for various files
;
;    This is for GEM IMG files
;
;
include f:\ok\okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   vint:word,vphase:word,buffer:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
     EXTRN   GEM_HEADER:WORD
     EXTRN   GEM_HEADERo:WORD
     EXTRN   PEL_SIZE:WORD
     EXTRN   WIDTH_PIX:WORD
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
     extrn   hash_segment:word
     EXTRN   IFF_HEADER:WORD
     EXTRN   IFF_HEADERo:WORD
extrn  planes:word,plane_switch:byte
extrn color_map:byte
divisor  dw  0,1
ten     dw  10,100,1000,10000
grayshade equ 0
flags    dw  0
color   dw  0
gem_headerx db  0,1,0,8
IFF_headerx db  0,1,0,8
iff_bodyo db 'BODY'
iff_bleno dw 0,0
;
;
; *********  GRAY 16 SHADES MAP ***********************8
;
gray_map_16a db 0,7,56,63,0,7,56,63,0,7,56,63,0,7,56,63,0
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   reset_segs:near,write_file:near
EXTRN   calc_file_size:near
extrn   read_file:near,write_file:near,next_wait:near
extrn   flush_buffer:near,fill_buffer:near
extrn  decomp:word
iff_sw  db 0
hash   dw  0
pattern dw 0
public pattern


;
      PUBLIC  IFF_IN
IFF_IN     PROC    NEAR
     call    reset_segs
     mov     ax,hash_segment
     mov     cs:hash,ax
extrn unpack_line:near
     lea     ax,unpack_line
     mov     cs:decomp,ax
     mov     cs:iff_sw,1
     mov     cs:pattern,0
     cmp     word ptr iff_header.iff_chunk_id,'OF'
     je      iffi1
bad_iffi:
     stc
     ret
iffi1:
     cmp     word ptr iff_header.iff_chunk_id+2,'MR'
     jne     bad_iffi
     cmp     word ptr iff_header.iff_ilbm,'LI'
     jne     bad_iffi
     cmp     word ptr iff_header.iff_ilbm+2,'MB'
     jne     bad_iffi
     cmp     word ptr iff_header.iff_bmhd,'MB'
     jne     bad_iffi
     cmp     word ptr iff_header.iff_bmhd+2,'DH'
     jne     bad_iffi
     cmp     word ptr iff_header.iff_bmhd_len+2,1400h
     jne     bad_iffi
     cmp     word ptr iff_header.iff_cmap,'MC'
     jne     bad_iffi
     cmp     word ptr iff_header.iff_cmap+2,'PA'
     jne     bad_iffi
; header appears ok, grab the info
;
     mov     ax,IFF_header.IFF_width  ; in pixels
     xchg    al,ah
     MOV     WIDTH_pix,ax     ;SAVE AS bits
     add    ax,7
     shr    ax,1
     shr    ax,1
     shr    ax,1
     MOV     WIDTH_BYTES,ax     ;SAVE AS BYTES
     mov     cl,IFF_header.IFF_no_planes
     mov     ch,0
     cmp     plane_switch,1
     je      no_IFF_planes
     mov     planes,cx
no_iff_planes:
     MOV     WIDTH_BYTES,ax     ;SAVE AS BYTES
     mov     ax,IFF_header.IFF_length
     xchg    al,ah
     mul     planes
     MOV     HEIGHT_PIX,ax
; read in the color map
     mov     ax,iff_header.iff_cmap_len+2
     xchg    al,ah
     mov     cx,ax
     lea     dx,color_map
     call    read_file
     jnc     check_body
bad_cmap:
     stc
     ret
; read in the body information
check_body:
     cmp     ax,0
     je   bad_cmap
     lea   dx,iff_header.iff_body
     mov   cx,8
     call  read_file
     jc    bad_cmap
     cmp   ax,8
     jne   bad_cmap
     cmp   word ptr iff_header.iff_body,"OB"
     jne   not_body
     cmp   word ptr iff_header.iff_body+2,"YD"
     jne   not_body
; have got the body
     clc
     RET
not_body:
; have to check for different types of words
; have a length in bod_len, have to fake a read to bypass the
; chunk
     mov     ax,iff_header.iff_bod_len+2
     xchg    al,ah
     cmp     ax,0
     jle     bad_cmap
     mov     cx,ax
     cmp     cx,0
     je      check_body
     mov     dx,6000h
     push    ds
     mov     ds,buffer
     call    read_file
     pop     ds
     jc      bad_cmap
     jmp     check_body

IFF_IN     ENDP
;     IFF   OUT
     PUBLIC  IFF_OUT
IFF_OUT     PROC    NEAR
     call    reset_segs
     call    calc_file_size
     mov     ax,planes
     mov     IFF_headero.IFF_no_planes,al
     MOV     ax,WIDTH_BYTES
     shl   ax,1
     shl   ax,1
     shl   ax,1
     xchg    al,ah
     mov     IFF_headero.IFF_width,ax
     MOV     ax,HEIGHT_PIX
     xchg    al,ah
     mov     IFF_headero.IFF_length,ax
; write file routine
     mov    cx,IFF_headero
     add    cx,14  ; for body info
     lea    dx,IFF_headero+2
     call   write_file
; we must return, though for rest of stuff
     RET

IFF_OUT     ENDP


iff_read:
public IFF_read
    stc
    ret

IFF_write  proc near
public  IFF_write
; write a IFF file
        call  reset_segs
       call gem_write
; re set the file length
       stc
       ret
IFF_write endp
;

     PUBLIC  GEM_IN
GEM_IN:
     call    reset_segs
     mov     cs:iff_sw,0
     mov     ax,hash_segment
     mov     cs:hash,ax
     lea     ax,gem_line
     mov     cs:decomp,ax
     lea     si,gem_header+2
     lea     di,gem_headerx
     mov     cx,3
     cld
repe     cmpsb
     je     gem_ok
     stc
     ret
gem_ok:
     mov     ax,gem_header.gem_width_pix
     xchg    al,ah
     mov     width_pix,ax
     add    ax,7
     shr    ax,1
     shr    ax,1
     shr    ax,1
     mov     cx,gem_header.gem_planes
     xchg    cl,ch
     cmp     cx,1
     jle    no_gem_planes
     cmp     plane_switch,1
     je     no_gem_planes
     mov     planes,cx
     MOV     WIDTH_BYTES,ax     ;SAVE AS BYTES
     mov    ax,gem_header.gem_height
     xchg    al,ah
     mul     planes
     push    ax
     call  gray16
     pop     ax
     jmp    save_h
no_gem_planes:
     mul     cx
     MOV     WIDTH_BYTES,ax     ;SAVE AS BYTES
     mov     ax,gem_header.gem_height
     xchg    al,ah
save_h:
     MOV     HEIGHT_PIX,ax
; the next is the pattern match stuff
     mov     ax,gem_header.gem_pattern
     xchg    al,ah
     mov     cs:pattern,ax
     CLC
     RET


;  gem_line is the routine to decompress a line of gem data
gem_line:
public gem_line
    call  reset_segs
; bx has the count of bytes to put out before leaving
    mov   ax,buffer
    mov   ds,ax
    mov   es,ax
; must check for a repeating line
    push   si
    lodsw
;   cmp   cs:iff_sw,1
;   jne   by_x
;   xchg  al,ah
;y_x:
    cmp   ax,00
    jne   not_rep
    lodsb
    cmp   al,0ffh
    jne   not_rep
    lodsb
    mov  cl,al
    mov  ch,0
    pop  si
    add  si,4
; we have to do lines a few times
     push  bx
     push  cx
     push  ds
     push  es
     call  gem_loop0   ; get a line
     pop   es
     pop   ds
     pop   cx
     pop   bx
;
rep_loop:
     push  cx
     push  si
     mov   cx,bx
     mov   si,di
     sub   si,bx
rep  movsb
     pop   si
     pop   cx
     loop  rep_loop
     mov   bx,-1
     clc
     ret
not_rep:
    pop   si
gem_loop0:
    lodsw
;   cmp   cs:iff_sw,1
;   jne   by_x2
;   xchg  al,ah
;y_x2:
; the first byte is an encoding flag.
; encoding is done as follows:
;     00,nn    = pattern run. nn = repeat count
;     xx       = solid run. if bit 7 then black else white
;     80,nn    = non-encoded, nn = count
     cmp  al,80h     ; non-encoded
     je   gem_80
; here we have a pattern run
     mov  dl,0ffh
     cmp  al,0       ; pattern run
     je   gem_0
     jg   gem_rep0   ; white run
                     ; black run
     mov  dl,0
gem_rep0:
     dec  si         ; make up for word
     and  al,7fh
     mov  cl,al
     mov  ch,0
     mov  al,dl
     sub  bx,cx
     cld
rep    stosb
     jmp  gem_loope
gem_80: ; this is move a string
     mov  cl,ah
     mov  ch,0
     sub  bx,cx
gem_80L:
     lodsb
     xor  al,0ffh
     stosb
     loop gem_80L
     jmp  gem_loope
gem_0: ; this is where we read the line of data
; this is a pattern run length
; runs are a repeat of a pattern, the pattern length is a word or
; a byte.
     xchg al,ah
     mov  cx,ax
     cmp  cs:pattern,2
     jne  byte_pattern
     lodsw
     xor  ax,0ffffh
     sub  bx,cx
     sub  bx,cx
rep  stosw
    jmp  gem_loope
byte_pattern:
     sub  bx,cx
     lodsb
     xor   al,0ffh
rep  stosb
gem_loope:
     cmp  bx,0
     jle  gem_r_exit
     jmp  gem_loop0
gem_r_exit:
     call  reset_segs
     clc
     ret

;     GEM   OUT
     PUBLIC  GEM_OUT
GEM_OUT:
     call    reset_segs
     call    calc_file_size
     mov     ax,planes
     xchg    al,ah
     mov     gem_headero.gem_planes,ax
     MOV     ax,WIDTH_BYTES
     shl   ax,1
     shl   ax,1
     shl   ax,1
     xchg    al,ah
     mov     gem_headero.gem_width_pix,ax
     MOV     ax,HEIGHT_PIX
     xchg    al,ah
     mov     gem_headero.gem_height,ax
; write file routine
     mov    cx,gem_headero
     lea    dx,gem_headero+2
     call   write_file
     RET


; local data for gem read
gem_lines  dw  0
gem_read:
     stc
     ret
public gem_read


gem_write:
public  gem_write
; write a gem file
gemw_loop0:
     call  reset_segs
     call  next_wait
     call  reset_segs
     call  fill_buffer       ; cx returns bytes in buffer:0
     call  reset_segs
     cmp   cx,0
     jg    gemw1
     stc
     ret
gemw1:
; cx has the amount to send out the buff
     mov  ax,cx
     mov  dx,0
     div  width_bytes
     mov  cx,ax  ; number of lines to send
     mov  dx,width_bytes
     mov  ax,buffer
     mov  ds,ax
     mov  es,ax
     mov  di,buffersize
     mov  si,0
     cld
gemw_loop1:
; do this once for each line
     push cx
     push dx
     push si
; have to determine how to compress the next line
; DX has the line length
;
gemw_loop2:
; goto this point until the line is done
;
; dx has the bytes per line
;
    mov   bx,dx  ; bx has the length to do also - for byte_str
    cmp   dx,3   ; if dx is too low, we can't have a repeat string
    jg    no_byte_str
byte_strx:
    jmp   byte_str
no_byte_str:
    lodsw
    dec  dx  ; stole 2 from line
    dec  dx
; if al=ah=0 or ff then we are potentially in a solid run
;
    cmp   ax,0ffffh
    je    solid_run
    cmp   ax,0
    je    solid_run
;
; if ax=next word then we could be in a pattern run
;
; a pattern run must be 3 words long to pay
;
no_solid:
    cmp   word ptr ds:[si],ax
    jne   string_check
    cmp   word ptr ds:[si+2],ax
    jne   string_check
;
; here we have a repeating pattern (at least three long
;
    mov   bx,2    ; we have found 2 (really 3)
    add   si,2    ; past the first 4 words of pattern run
pat_loop:
; add another to pattern loop
    inc   si
    inc   si
    inc   bx
    dec   dx
    dec   dx
    cmp   bx,255
    jge   end_pat
    cmp   dx,2
    jl    end_pat
    cmp   word ptr ds:[si+2],ax
    jne   end_pat
    jmp   pat_loop
end_pat:
    push  ax
    mov   al,0
    stosb
    mov   al,bl
    stosb
    pop   ax
    stosw
; done this run
    jmp   bot_write
solid_run:
    cmp   byte ptr ds:[si],al
    jne   no_solid
; have a run, it is 3 bytes long at present of a solid
;
; start by saying 2 bytes long
;
    mov   bx,2
sol_loop:
; add another byte to the solid run
    inc   si
    inc   bx
    dec   dx
    cmp   bx,127
    jge   end_sol
    cmp   dx,0
    jle   end_sol
    cmp   byte ptr ds:[si],al
    jne   end_sol
    jmp   sol_loop
end_sol:
    xor   al,80h
    and   al,80h
    or    al,bl
    stosb
; done this run
    jmp   bot_write
string_check:
;
; here we have to find out how far before a string is different
;
; we know that ax does not equal the next word, but a non-repeat
; string can be only one byte and then the words start again
;
    dec   si
    mov   bx,1
    inc   dx
    inc   dx
    mov   ah,al
str_loop:
; add a byte to string of diffs
    lodsb  ; get next byte
    xchg  al,ah
;
    push  dx
    sub   dx,bx
    cmp   dx,4
    pop   dx
    jle   add_str
    cmp   ax,word ptr ds:[si]
    jne   add_str
; have a 2 word string
    cmp   ax,0
    je    solid_out
    cmp   ax,0ffffh
    je    solid_out
    cmp   ax,word ptr ds:[si+2]
    jne   add_str
; have a real pattern repetition
solid_out:
    dec   si
    jmp   byte_str
add_str:
    inc   bx
    cmp   bx,255
    jge   byte_str
    cmp   dx,bx
    jle   byte_str
    jmp   str_loop
byte_str:
; here we have a string, no repeats
; bx has the length odf the string to do
     mov  al,80h
     stosb
     mov  al,bl
     stosb
     mov  cx,bx
     sub  si,bx
gw1:
     lodsb
     xor   al,0ffh
     stosb
     loop  gw1
    sub   dx,bx
;    jmp   bot_write
bot_write:
;here we are after a run, do we need to do more?
     cmp   dx,0
     jle   done_w_line
     jmp   gemw_loop2
done_w_line:
; we have a line in buffer:0
     mov  cx,di
     sub  cx,buffersize
     mov  dx,buffersize
     call write_file
     pop  si
     pop  dx
     pop  cx
     jc   bad_gem_write
     add  si,dx
     mov  di,buffersize
     loop gemw_loop1x
     jmp  gemw_loop1y
gemw_loop1x:
     jmp gemw_loop1
gemw_loop1y:
     jmp gemw_loop0
     ret
bad_gem_write:
     stc
     ret

;
gray16:
public gray16
            call  reset_segs
           mov   ah,10h
            mov   al,2h
            mov   bx,0
            mov   cx,16
            lea   dx,gray_map_16a
            int   10h
            clc
            ret
;

CSEG     ENDS
     END
