; OKFIXED is the file of routines to do fixed processing of the image
; such as delete, xor, erase, mirror, flip and rotate.
;
dsbuff macro
	push	ds
	push	es
	call	reset_segs
	mov	ds,buffer
	pop	es
	endm
;
segmentsize equ 8000h
DSEG segment public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn	work_seg:word,work2_seg:word
extrn	p_xor:byte,vwid:word,debug:byte
extrn	height_pix:word,width_bytes:word
extrn	srow:word,scol:word,left_margin:word
extrn	curx:word,cury:word,lrow:word,lcol:word
extrn	maxlines:word,skew:byte
extrn	zcol:word,zrow:word
extrn	colori:word,colors:byte,appl_sw:byte
extrn	buffer:word,destroy:byte
; local data
;
diagin	db	16 dup(0)
diagout	db	16 dup(0)
rotcol	dw	0
function	db	0
cswitch	db	0
waitc	db	16
;lines	db 2048 dup(0)
;
; used by the sizing program
;
colx	dw	0
coly	dw	0
rowx	dw	0
rowy	dw	0
rowp	dw	0
;
dseg ends
;
cseg segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn	present:near,quit:near,get_next_seg:near,get_curr_seg:near
extrn	get_next2_seg:near,get_curr2_seg:near,get_prev2_seg:near
extrn	reset_segs:near,get_prev_seg:near
extrn	do_wait:near,next_wait:near
extrn	blop:near,calc_file_size:near
extrn	goback:near,set_range:near
; local data
skew_count	dw	0
crow	dw	0
destroyer db 0
public destroyer
;
do_clip:
public do_clip
; this is not part of the fixed loop, put it here because all
; of the externals are already provided.
	call reset_segs
; we must calculate the file size, best way is to use the file routines
;
	call	set_range
	cmp	al,13
	je	ok_clip
	stc
	ret
ok_clip:
	call	do_wait
	call	calc_file_size	; figures out the width and height
	cmp	height_pix,0
	jle	bad_clip
	cmp	width_bytes,0
	jle	bad_clip
	jmp	good_clip
bad_clip:
	call blop
	call present
	ret
good_clip:
;
; check for debug
;
	call reset_segs
	cmp	debug,9
	jne	no_debug2
	int	3	; debug break
no_debug2:
;
; srow,scol has starting point, lrow,lcol have the ending point
;
	mov	ax,srow
	mov	bx,lrow
	cmp	ax,bx
	jl	clip1
	jne	clip0
	stc
	ret
clip0:
	xchg	ax,bx
	mov	srow,ax
	mov	lrow,bx
clip1:
	mov	ax,scol
	mov	bx,lcol
	cmp	ax,bx
	jl	clip3
	jne	clip2
	stc
	ret
clip2:
	xchg	ax,bx
	mov	scol,ax
	mov	lcol,bx
clip3:
; set up to erase the stuff before the line
	mov	cx,srow
	cmp	cx,0
	jle	by_top_clip
	mov	work_seg,0
	mov	di,0
	mov	dx,vwid
	call	clipper

by_top_clip:
	call	reset_segs
; now we have to clip off the bottom from rrow+1 on down
; now calc the segment of the last line
	mov	dx,0
	mov	ax,segmentsize
	div	vwid
; ax has the lines in a segment
	mov	cx,ax
	mov	ax,lrow	;ending row
	mov	dx,0	; is zero anyway, but to be sure
	div	cx
; ax has the number of starting segment
; dx has the remainder line
	mov	work_seg,ax
	mov	ax,dx
	mul	vwid
	mov	di,ax	; di has the starting offset within work_seg
	mov	cx,maxlines
	sub	cx,lrow
	dec	cx
	cmp	cx,0
	jle	by_bot_clip
	mov	dx,vwid
	call	clipper
by_bot_clip:
; now do the left side
	call	reset_segs
	cmp	scol,0
	jle	by_left_clip
; find the first line segment
	mov	dx,0
	mov	ax,segmentsize
	div	vwid
; ax has the lines in a segment
	mov	cx,ax
	mov	ax,srow	;ending row
	mov	dx,0	; is zero anyway, but to be sure
	div	cx
; ax has the number of starting segment
; dx has the remainder line
	mov	work_seg,ax
	mov	ax,dx
	mul	vwid
	mov	di,ax	; di has the starting offset within work_seg
	mov	cx,lrow
	sub	cx,srow
	mov	dx,scol
	call	clipper
;
by_left_clip:
; now do the right side
	call	reset_segs
	mov	ax,vwid
	cmp	lcol,ax
	jge	by_right_clip
; find the first line segment
	mov	dx,0
	mov	ax,segmentsize
	div	vwid
; ax has the lines in a segment
	mov	cx,ax
	mov	ax,srow	;ending row
	mov	dx,0	; is zero anyway, but to be sure
	div	cx
; ax has the number of starting segment
; dx has the remainder line
	mov	work_seg,ax
	mov	ax,dx
	mul	vwid
	mov	di,ax	; di has the starting offset within work_seg
	add	di,lcol
	mov	cx,lrow
	sub	cx,srow
	mov	dx,vwid
	sub	dx,lcol
	call	clipper
by_right_clip:
	ret

clipper:
	call	get_curr_seg
	mov	es,ax
top_clip:
	push	cx
	push	di
	mov	cx,dx
	mov	al,0
rep	stosb
	pop	di
	pop	cx
	add	di,vwid
	cmp	di,0
	jge	bot_top_clip
	sub	di,segmentsize
	inc	work_seg
	call	get_curr_seg
	mov	es,ax
bot_top_clip:
	loop	top_clip
	ret



ffscale:
; this routine does the scaling, it is executed for every line
;
	call	reset_segs
; first check to see if it is time to do a line
	cmp	rowp,0
	jl	rowp_lt_zero
; here rowp_gt_zero
;	jmp	exit_scale
exit_scale:
	ret
rowp_lt_zero:
	jmp	rowscale
scale_di:
	push	ds
	push	es
	call	reset_segs
	cmp	rowp,0
	jl	rowp_lt_zero2
	mov	ax,rowy
	sub	rowp,ax
	call	set_back	; next si line
	pop	es
	pop	ds
	ret
rowp_lt_zero2:
	mov	ax,rowx
	add	rowp,ax
	call	prevdi	; next di line
	pop	es
	pop	ds
	ret
scale_di22:
	push	ds
	push	es
	call	reset_segs
	cmp	rowp,0
	jl	rowp_lt_zero3
	mov	ax,rowy
	sub	rowp,ax
; erase current ds:[si]
        cmp    cs:destroyer,1
        jne    cs_1
        push   ax
        push   cx
        push   di
        push   es
	call get_curr2_seg
        mov    es,ax
        mov    di,si
        mov    cx,width_bytes
        mov    al,0
        cld
        inc    cx
rep     stosb
        pop    es
        pop    di
        pop    cx
        pop    ax
cs_1:
	call	set_nline	; next si line
	pop	es
	pop	ds
	ret
rowp_lt_zero3:
	mov	ax,rowx
	add	rowp,ax
	call	nextdi	; next di line
	pop	es
	pop	ds
	ret
rowscale:
; this rescles the who row
; check to see if we are expanding or shrinking
;	colx is the original, coly is the new size
; this is a shrink for the scal colx, coly
;	ds:di points to where it goes
;	bp:si points to where is comes from
	push	si
	push	di
	push	bp
; cx has the number of bytes to compress
	mov	bx,colx
	mov	dx,coly
	mov	bp,0
	call	get_curr_seg
	push	ax
	call get_curr2_seg
	push	ax
	cld
	mov	cx,bx
	cmp	dx,bx
	jle	row_shrink
	jmp	row_expand
row_shrink:
	pop	ds
	pop	es
	lodsb
        cmp    cs:destroyer,1
        jne    rs_1
        mov    byte ptr ds:[si-1],0
rs_1:
	mov	ah,1
rs_loop:
	push	cx
	mov	cx,8
rs_loop2:
	cmp	bp,0
	jle	bp_lt_0
; bp gt 0 so we subtract dx and shift left the al
	sub	bp,dx
	shl	al,1
	loop	rs_loop2
	lodsb
        cmp    cs:destroyer,1
        jne    rs_2
        mov    byte ptr ds:[si-1],0
rs_2:
	pop	cx
	loop	rs_loop
	jmp	exit_rowscale
bp_lt_0:
; bp is less than 0 so we bump the next target location
	add	bp,bx
	clc
	rcl	ah,1
	jnc	no_storb
	clc
	test	al,80h
	jz	no_new_bit1
	or	ah,1
no_new_bit1:
	push	ax
	mov	al,ah
	stosb
	pop	ax
	mov	ah,1
	jmp	no_new_bit
no_storb:
	clc
	test	al,80h
	jz	no_new_bit
	or	ah,1
no_new_bit:
	jmp	rs_loop2
;
exit_rowscale:
; there may be something left in ah
	clc
	rcl	ah,1
	jnc	exit_rowscale
	mov	byte ptr es:[di],ah
	cld
	pop	bp
	pop	di
	pop	si
	call	reset_segs
	ret
;
;
;
;
row_expand:
	add	di,dx
	add	si,bx
	std
	pop	ds
	pop	es
	lodsb
	mov	ah,80h
re_loop:
	push	cx
	mov	cx,8
re_loop2:
	cmp	bp,0
	jle	bp_lt_0e
; bp gt 0 so we subtract dx and shift left the al
	sub	bp,dx
	shr	al,1
	loop	re_loop2
	lodsb
	pop	cx
	loop	re_loop
	jmp	exit_rowscalee
bp_lt_0e:
; bp is less than 0 so we bump the next target location
	add	bp,bx
	clc
	rcr	ah,1
	jnc	no_storbe
	clc
	test	al,1
	jz	no_new_bit1e
	or	ah,80h
no_new_bit1e:
	push	ax
	mov	al,ah
	stosb
	pop	ax
	mov	ah,80h
	jmp	no_new_bite
no_storbe:
	clc
	test	al,1
	jz	no_new_bite
	or	ah,80h
no_new_bite:
	jmp	re_loop2
;
exit_rowscalee:
; there may be something left in ah
	clc
	rcr	ah,1
	jnc	exit_rowscalee
	mov	byte ptr es:[di],ah
	cld
	pop	bp
	pop	di
	pop	si
	call	reset_segs
	ret
;
;

frotate2:
; ok keith, talk it out and it will come to you
;
; at this point rotcol has a number indicating the col (starting
; with 0) that we worked on last.
;
; cx should have the column width in it
        push    es
        call    reset_segs
        pop     es
	inc	rotcol	; move over to next column
	sub	cx,rotcol
	cmp	cx,0
	jg	cont_r2
	ret
cont_r2:
	mov	ax,work_seg
	push ax
	push	cx
	add	di,rotcol
; have to set up the "to" column which is down the same number
; of rotcol times 8
;	ds:si is always 8 below es:di and one to left
	mov	ax,work_seg
	mov	work2_seg,ax
	call get_curr2_seg
	mov	bp,ax
	mov	si,di
	dec	si
	mov	cx,8
	mov	ax,vwid
r3_loop:
	push	ax
	push	cx
	add	si,ax
	cmp	si,0
	jge	ok_r3_si
	sub	si,segmentsize
	call	get_next2_seg
	mov	bp,ax
ok_r3_si:
	pop	cx
	pop	ax
	loop	r3_loop
	call	get_curr_seg
; bp:si has the starting location
	pop	cx
r2_loop:
	push cx
; save the current stuff so we can move on to next box
	mov	ax,work_seg
	push ax
	mov	ax,work2_seg
	push ax
	push di
	push si
; here we xchg the 8 current lines
	mov	cx,8
r2_loop2:
	push ds
	mov	ds,bp
	mov	al,byte ptr es:[di]
	mov	bl,byte ptr ds:[si]
	mov	byte ptr ds:[si],al
	mov	byte ptr es:[di],bl
; inc the si and di
	pop	ds
	add	di,vwid
	cmp	di,0
	jge	ok_r2_di
	sub	di,segmentsize
	call	get_next_seg
	mov	es,ax
ok_r2_di:
	add	si,vwid
	cmp	si,0
	jge	ok_r2_si
	sub	si,segmentsize
	call	get_next2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
ok_r2_si:
	loop	r2_loop2
; done all of the move stuff, reset all and move to next box
	pop	si
	pop	di
	pop	ax
	mov	work2_seg,ax
	pop	ax
	mov	work_seg,ax
	call get_curr_seg
	mov	es,ax
	call get_curr2_seg
	mov	bp,ax
; now inc the di
	inc	di	; one to right
; si gets 8 vwids added to it
	mov	ax,vwid
	mov	cx,8
r2_loopa:
	push	ax
	push	cx
	add	si,ax
	cmp	si,0
	jge	ok_rsi2
	sub	si,segmentsize
	call	get_next2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
ok_rsi2:
	pop	cx
	pop	ax
	loop	r2_loopa
	pop	cx
	loop	r2_loop
; reset the es:segment so that it is correct at restart
	pop	ax
	mov	work_seg,ax
	call get_curr_seg
	mov	es,ax
	mov	bp,ds
	ret

frotate1:
; at entry the es:di points to the current line head
; rotcol has the column number to tab over
; first thing is to rotate the current box
; es:di point to the upper corner of the 8x8 box to rotate
        push    es
        call    reset_segs
        pop     es
fr1_loop:
; cx has the number of 8 bit horizontal boxes to flip
	push	cx
	call	flip_box
	call	esbox	; puts diagout into the es:di
	pop	cx
	inc	di
	loop	fr1_loop
; this is phase 1 when done we have to do phase 2
	ret
esbox:
; puts the box at es:di assume ds is ok
	mov	ax,work_seg
	push	ax
	push	di
	push	si
	push	cx
	lea	si,diagout
	mov	cx,8
esbox_loop:
	cld
	lodsb
	mov	byte ptr es:[di],al
	add	di,vwid
	cmp	di,0
	jge	ok_esb
	sub	di,segmentsize
	call	get_next_seg
	mov	es,ax
ok_esb:
	loop	esbox_loop
; exit the es:box routine
	pop	cx
	pop	si
	pop	di
	pop	ax
	mov	work_seg,ax
	call	get_curr_seg
	mov	es,ax
	ret

flip_box:
; this is the procedure to flip a box on the diagonal
; save the work seg and stuff
	push	cx
	push	si
	push	di
	push	ds
	mov	ax,work_seg
	push	ax
	mov	si,di
 	push	es
 	call	reset_segs
 	pop	ds
	lea	di,diagin
	mov	cx,8
	cld
diag_loop1:
	mov	al,byte ptr ds:[si]
	stosb
	add	si,es:vwid
	cmp	si,0
	jge	good_dlsi
	sub	si,segmentsize
	call	get_next_seg
	mov	ds,ax
good_dlsi:
	loop	diag_loop1
	call	reset_segs
; diag has the 8 bytes to swap
;
	lea	si,diagin
	lea	di,diagout
	mov	cx,8
swap_loop1:
	push	si
	push	cx
	mov	al,byte ptr ds:[si]
	mov	cx,8
swap_loop:
	mov	ah,byte ptr ds:[si]
	clc
	rcl	ax,1
	jnc	no_c_1
	or	ax,1
no_c_1:
	mov	byte ptr	ds:[si],ah
	inc	si
	loop	swap_loop
	pop	cx
	pop	si
	stosb
	loop	swap_loop1
;
exit_flip:
	pop	ax
	mov	work_seg,ax
	call	get_curr_seg
	mov	es,ax
	pop	ds
	pop	di
	pop	si
	pop	cx
	ret
; at the end of this diagout has the flipped box of 8


; fixedlines is do one line
fixedlines dw	fdelete,frotate1,fmirror,fxor_mem,fblank,fflip,fsmooth,fbound
;	8	9	10	11	12	13	14
	dw	fgray,froll,frotate2,fvshrink,fclean,fhshrink,fhshrink
;	15	16	17	18	19	20
	dw	fhexpand,fvexpand,fhexpand,funstep,flskew,frskew
;	21	22	23	24	25	26	27
	dw	ffscale,ffscale,fxorl,fbfill,ffade,fshade,ferode
;	28
	dw	fdepos
; inc si is how to find the next si
incsi	dw	dret,dret,dret,dret,dret,set_back,set_nline,set_nline
;		8	9	10	11	12	13
	dw	set_nline,set_nline,dret,set_nline2,set_nline,set_nline
;		14	15	16	17	18
	dw	set_nline2,set_nline,set_nlineb,set_nlineb,set_nline
;		19	20	21	22	23	24	25	26	27	28	29
	dw	dret,dret,dret,dret,set_nline,dret,dret,dret,set_nline,set_nline,dret,dret
; incdi is how to find the next line
incdi	dw	nextdi,nex8di,nextdi,nextdi,nextdi,nextdi,nextdi ;0-6
	dw	nextdi,nextdi,nextdi,nex8di,nextdi,nextdi,nextdi ;7-13
	dw	nextdi,nextdi,prevdi,prevdi,nextdi,nextdi,nextdi ;14-20
	dw	scale_di,scale_di22,nextdi,nextdi,nextdi,nextdi,nextdi;27
	dw	nextdi,nextdi,nextdi
dret: ret
set_back:
; this sets the si back a line
	sub	si,vwid
	cmp	si,0
	jge	ok_bsi
	add	si,segmentsize
	call	get_prev2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
ok_bsi:
	ret
set_nline:
; this sets the si next line
	add	si,vwid
	cmp	si,0
	jge	ok_nsi
	sub	si,segmentsize
	call	get_next2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
ok_nsi:
	ret
set_nlineb:
; this sets the si prev (if cx is odd)
	test	cx,1
	jnz	b_back
	ret
b_back:
	sub	si,vwid
	cmp	si,0
	jge	ok_psi
	add	si,segmentsize
	call	get_prev2_seg
	mov	bp,ax
ok_psi:
	call	get_curr_seg
	mov	es,ax
	ret
set_nline2:
; cx has the width bytes in it
; this sets the si next line
	add	si,vwid
	cmp	si,0
	jge	ok_nsi2a
	sub	si,segmentsize
	call	get_next2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
ok_nsi2a:
; if destroyer is on then this line must be erased
        cmp    cs:destroyer,1
        jne    ns_2
        push   ax
        push   cx
        push   di
        push   es
        mov    cx,width_bytes
        mov    es,bp
        mov    di,si
        cld
        mov    al,0
rep     stosb
        pop    es
        pop    di
        pop    cx
        pop    ax
ns_2:
	add	si,vwid
	cmp	si,0
	jge	ok_nsi2
	sub	si,segmentsize
	call	get_next2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
ok_nsi2:
	ret
;
; these are the entries for the fixed procedures
do_lskew1:
public do_lskew1
	mov	skew,0
	jmp	do_lskew
do_lskew2:
public do_lskew2
	mov	skew,1
	jmp	do_lskew
do_lskew3:
public do_lskew3
	mov	skew,2
	jmp	do_lskew
do_rskew1:
public do_rskew1
	mov	skew,0
	jmp	do_rskew
do_rskew2:
public do_rskew2
	mov	skew,1
	jmp	do_rskew
do_rskew3:
public do_rskew3
	mov	skew,2
	jmp	do_rskew
;
fdo macro string,cnt
do_&string:
public do_&string
	mov	function,cnt
	jmp	do_fixed
	endm
;
;
fdo delete,0
fdo mirror,2
fdo xor_mem,3
fdo blank,4
fdo flip,5
fdo smooth,6
fdo bound,7
fdo gray,8
fdo roll,9
fdo vshrink,11
fdo clean,12
fdo hshrink,13
fdo bshrink,14
fdo hexpand,15
fdo vexpand,16
fdo bexpand,17
fdo unstep,18
fdo lskew,19
fdo rskew,20
fdo xorl,23
fdo bfill,24
fdo fade,25
fdo shade,26
fdo erode,27
fdo depos,28
;
do_scale:
extrn set_srange:near
public do_scale
	call reset_segs
	call	set_srange
	cmp	al,13
	je	ok_range3
	stc
	ret
ok_range3:
	call	calc_file_size	; figures out the width and height
	cmp	height_pix,0
	jle	bad_range3
	cmp	width_bytes,0
	jle	bad_range3
	jmp	good_range3
bad_range3:
	call blop
	call present
	ret
good_range3:
	mov	ax,width_bytes
	mov	colx,ax
	mov	ax,scol
	sub	ax,zcol
	cmp	ax,0
	je	bad_range3
	jg	ok_z1
	neg	ax
ok_z1:
	mov	coly,ax
; now do the length
;
	mov	ax,height_pix
	mov	rowx,ax
	mov	ax,srow
	sub	ax,zrow
	cmp	ax,0
	je	bad_range3
	jg	ok_z2
	neg	ax
ok_z2:
	mov	rowy,ax
;
	mov	rowp,0
	mov	function,21
	mov	bp,ds
	call	do_wait
	jmp	good_range
;
;
do_rotate:
public do_rotate
	call reset_segs
	call	set_range
	cmp	al,13
	je	ok_range2
exit_range2:
	stc
	ret
ok_range2:
	call	do_wait
	call	calc_file_size	; figures out the width and height
	cmp	height_pix,0
	jle	bad_range2
	cmp	width_bytes,0
	jle	bad_range2
	jmp	good_range2
bad_range2:
	call blop
	call present
	ret
good_range2:
	mov	function,1
	call	setup_start
	mov	cx,width_bytes
	mov	height_pix,cx
	mov	rotcol,0
	mov	bp,ds
	call	drop_in_do
	call	reset_segs
	mov	function,10
	call	setup_start
	mov	cx,width_bytes
	mov	rotcol,0
	mov	bp,ds
	jmp	drop_in_do
;
;
;
ssetline	dw	sset0,sset1,sset2,sset3,sset4  ;0-4
	dw	sset5,sset6,sset7,sset8,sset9          ;5-9
	dw	sset10,sset11,sset12,sset13,sset14     ;10-14
	dw	sset15,sset16,sset17,sset18,sset19     ;15-19
	dw	sset20,sset21,sset22,sset23
	dw	sset24,sset25,sset26,sset27,sset28

second_setup:
	push	es
	call	reset_segs
	pop	es
	mov	bp,ds
	mov	bl,function
	mov	bh,0
	shl	bx,1
	jmp	cs:ssetline[bx]
sset21:
sset22:
	call	reset_segs
	mov	cx,rowx
	add	cx,rowy
	dec	cx
	ret
sset0:
sset2:
sset3:
sset4:
sset24:
sset25:
sset26:
	ret
sset19:
	mov	cs:skew_count,0
	ret
sset20:
	mov	ax,height_pix
	cmp	skew,0
	je	add_skew
	shl	ax,1
	cmp	skew,1
	je	add_skew
	shr	ax,1
	shr	ax,1
add_skew:
	mov	cs:skew_count,ax
	ret
;
;
;
sset1:
sset10:
	push	es
	call	reset_segs
	pop	es
	mov	cx,width_bytes
	ret
sset5:
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	shr	cx,1
	ret

sset15:
sset16:
sset17:
; the expansion could go beyond vwid
        push    ds
	push	es
	call	reset_segs
	pop	es
	push	cx
	mov	cx,width_bytes
	mov	bx,cx
	shl	cx,1
	add	cx,scol
	cmp	cx,vwid
	jl	ok_sset15
	mov	bx,vwid
	sub	bx,scol
	dec	bx
	shr	bx,1
ok_sset15:
	mov	width_bytes,bx
	pop	cx
; from here its a normal setup
        pop     ds
        ret
sset6:
sset7:
sset13:
sset23:
sset27:
sset28:
	push	es
	call	reset_segs
	pop	es
	mov	cswitch,0
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	mov	si,di
	call	set_nline
	ret
sset8:
	mov	cswitch,1
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	ret
sset9:
	mov	cswitch,2
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	ret
sset11:
sset14:
	call get_curr2_seg
	shr	cx,1
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	ret
sset12:
	mov	cswitch,3
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	ret
sset18:
	mov	cswitch,4
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	ret

;
;
;
setline	dw	set0,set1,set2,set3,set4
	dw	set5,set6,set7,set8,set9
	dw	set10,set11,set12,set13,set14
	dw	set15,set16,set17,set18,set19,set20,set21,set22,set23
	dw	set24,set25,set26,set27,set28
;
setup_second:
; this sets up a second register for rotate,mirror, flip and smooth
; 1,2,5 and 6
       call    reset_segs
	mov	bl,function
	mov	bh,0
	shl	bx,1
	jmp	cs:setline[bx]
set0:
set2:
set3:
set4:
set19:
set20:
set24:
set25:
set26:
	ret
; on entry to the sets, es:di is pointint to the upper left
; cx has the number of lines to process
;
set1:
set10:
; this sets up rotate
	mov	rotcol,0
	ret
set5:
; flip
	push	cx
; now calc the segment of the last line
	mov	dx,0
	mov	ax,segmentsize
	div	vwid
; ax has the lines in a segment
	mov	cx,ax
	mov	ax,lrow	;ending row
	dec	ax	; added this because we were going 1 too far
	mov	dx,0	; is zero anyway, but to be sure
	div	cx
; ax has the number of starting segment
; dx has the remainder line
	mov	work2_seg,ax
	mov	bp,ax	; save the end work seg in bp
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	si,ax	; di has the starting offset within work_seg
; done flip start
	pop	cx
;
; es:di points to the top
; bp:si points to the end
; cx has the number of lines to do
	ret
set6:
set8:
set9:
set12:
set18:
; this gets the first lines (in es:di) to lines
	push	cx
	push	di
	push	ds
	mov	ax,work_seg
	push	ax
	mov	ax,ds
	mov	bx,es
	mov	es,ax
	mov	ds,bx
	mov	si,di
	cld
;	lea	di,lines
	mov	di,1
	mov	bx,cx
	push	es
	push	ds
	call	reset_segs
	mov	es,buffer
	pop	ds
rep	movsb
	pop	es
	add	si,es:vwid
	cmp	si,0
	jge	ok_lsi
	sub	si,segmentsize
	call	get_next_seg
	mov	ds,ax
ok_lsi:
	mov	cx,bx
rep	movsb
	pop	ax
	pop	ds
	mov	work_seg,ax
	call	get_curr_seg
	mov	es,ax
	pop	di
	pop	cx
; same as bound from here on out
set7:
set23:
set27:
set28:
; bound setup and smooth setup
; sets up next line as the second segment
	push	cx
	mov	ax,work_seg
	mov	work2_seg,ax
	mov	si,di
	add	si,vwid
	cmp	si,0
	jge	good_bsi
	sub	si,segmentsize
	inc	work2_seg
good_bsi:
	pop	cx
;
	ret

; from here on out its like working on same line (set11)
set11:
set13:
set14:
set15:
; sets up same ds:si as es:di
	push	cx
	mov	ax,work_seg
	mov	work2_seg,ax
	mov	si,di
	pop	cx
;
	ret
set21:
set22:
	push	cx
; this sets up the second location for rowx+rowy down the screen
	call reset_segs
; we have to decide which way we are going, the biggest one is the
; from guy and the smallest is to
	mov	si,srow
	add	si,height_pix
	dec	si	; added this because we were going 1 too far
	mov	di,srow
	add	di,rowy
	dec	di	; added this because we were going 1 too far
	cmp	si,di
	jle	no_swap_21
	mov	function,22	; this is shrinks only
	mov	ax,segmentsize
	mov	dx,0
	div	vwid
	mov	cx,ax	; lines per seg
	mov	ax,srow
	mov	dx,0
	div	cx
	mov	work2_seg,ax
	mov	work_seg,ax
	mov	bp,ax	; save the end work seg in bp
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	si,ax
	mov	di,ax
	pop	cx
	ret
no_swap_21:
; ax has the address of the last line
; this is for expands only
	mov	ax,segmentsize
	mov	dx,0
	div	vwid
	mov	cx,ax	; lines per seg
	mov	ax,si
	mov	dx,0
	div	cx
	mov	work2_seg,ax
	mov	bp,ax	; save the end work seg in bp
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	si,ax
; thats the from column work2:si
; now calc the segment of the last line
	mov	dx,0
	mov	ax,segmentsize
	div	vwid
; ax has the lines in a segment
	mov	cx,ax
	mov	ax,di
	mov	dx,0	; is zero anyway, but to be sure
	div	cx
; ax has the number of starting segment
; dx has the remainder line
	mov	work_seg,ax
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	di,ax	; di has the starting offset within work_seg
	pop	cx
	ret
set16:
set17:
; this has to set up the es and ds stuff for the v exapnd
; es:di has to point to twice the height_pix down from scol
; ds:si has to point to end
; es is already screwed up so get rid of it
	call reset_segs
	mov	ax,height_pix
	shl	ax,1
	add	ax,srow
	cmp	ax,maxlines
	jl	ok_max
	mov	ax,maxlines
	sub	ax,srow
	dec	ax
	shr	ax,1
	mov	height_pix,ax
	shl	ax,1
	add	ax,srow
ok_max:
; ax has the line no of the last line
	mov	bx,ax
	mov	ax,segmentsize
	mov	dx,0
	div	vwid
	mov	cx,ax	; lines per seg
	mov	ax,bx
	mov	dx,0
	div	cx
	mov	work_seg,ax    ; ax has the segment, dx has the line
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	di,ax
	call get_curr_seg
	mov	es,ax
; now the same thing again for the ds:si stuff
; this has to point to the actual end of the file
	mov	ax,srow
	add	ax,height_pix
	mov	bx,ax
	mov	ax,segmentsize
	mov	dx,0
	div	vwid
	mov	cx,ax
	mov	ax,bx
	mov	dx,0
	div	cx
	mov	work2_seg,ax
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	si,ax
	call get_curr2_seg
	mov	bp,ax
	call	get_curr_seg
	mov	es,ax
	shl	height_pix,1
	mov	cx,height_pix
	ret

setup_start:
public setup_start
; sets the segments for the srow scol in absolutes for screen
; used by fixed,type and others
;
; have to figure out the start positions of the thing
; this calculates the start position
;
        mov     al,destroy
        mov     cs:destroyer,al
	mov	work2_seg,0
	mov	dx,0
	mov	ax,segmentsize
	div	vwid
; ax has the lines in a segment
	mov	cx,ax
	mov	ax,srow	;starting row
	mov	cs:crow,ax
	mov	dx,0	; is zero anyway, but to be sure
	div	cx
; ax has the number of starting segment
; dx has the remainder line
	mov	work_seg,ax
	mov	ax,dx
	mul	vwid
	add	ax,scol
	mov	di,ax	; di has the starting offset within work_seg
;
; things are set up
;
; have to adjust cx as per lines per byte
; now we can start off by setting the current segment in the pic
;
	call	get_curr_seg
	mov	es,ax
	ret

do_fixed:
;
; check for debug
;
	call reset_segs
; we must calculate the file size, best way is to use the file routines
;
	call	set_range
	cmp	al,13
	je	ok_range
	stc
	ret
ok_range:
        call    reset_segs
	call	do_wait
        call    reset_segs
	call	calc_file_size	; figures out the width and height
	cmp	height_pix,0
	jle	bad_range
	cmp	width_bytes,0
	jle	bad_range
	jmp	good_range
bad_range:
	call blop
	call present
	ret
;
; The DS register will always be set correctly so that we can do away
; the this CX and DX crap.
; The ES register is altered, but we will reset_segs when we leave
;
good_range:
;
; check for debug
;
	call reset_segs
	cmp	debug,9
	jne	no_debug
        mov     al,function
	int	3	; debug break
no_debug:
;
	call	setup_start
; here we have to set up the second stuff for mirror, flip etc
	call	setup_second    ; sets up the di
	mov	cx,height_pix
	call	second_setup ; sets up ds if neccessary also fixes up cx
drop_in_do:
	mov	waitc,16
; make sure that we have at least than 1 guy in the CX register
	cmp	cx,1
	jg	fix_loop
	mov	cx,1
fix_loop:
	push	cx
	mov	dx,cx	;so apps can have access to the current line number
	mov	cx,width_bytes
	mov	bl,function
	mov	bh,0
	shl	bx,1
	push	si
	push	di
	push	ds
	push	bx
        push    dx
	call	get_curr_seg
	mov	es,ax
	call	get_curr2_seg
        pop     dx
	mov	cx,width_bytes
	mov	ds,ax
        pop     bx
        push    bx
	call	cs:fixedlines[bx]
	pop	bx
	pop	ds
	pop	di
	pop	si
	pop	cx
	push	cx
	push	bx
	call	cs:incsi[bx]
	pop	bx
        pop     cx
        push    cx
	call	cs:incdi[bx]
	pop	cx
;	dec	waitc
;	jnz	ok_wait
;	mov	waitc,16
;	call	next_wait
ok_wait:
	loop	fix_loop
	call	present
	call	reset_segs
	ret
;
;

;
;
prevdi:
	sub	di,vwid
	cmp	di,0
	jge	ok_dip
	add	di,segmentsize
	call	get_prev_seg
	mov	es,ax
ok_dip:
	ret

;
nex8di:
	mov	ax,vwid
	mov	cl,3
	shl	ax,cl
	add	di,ax
	cmp	di,0
	jge	ok_8i
	sub	di,segmentsize
	call	get_next_seg
	mov	es,ax
ok_8i:
	ret

;
nextdi:
	add	di,vwid
	cmp	di,0
	jge	ok_di
	sub	di,segmentsize
	call	get_next_seg
	mov	es,ax
ok_di:
	ret

fvexpand:
      cld
rep   movsb
      ret
fvshrink:
        cld
        lodsb
        cmp    cs:destroyer,1
        jne    vs_2
        dec    si
        mov    byte ptr ds:[si],0
        inc    si
vs_2:
       stosb
       loop   fvshrink
       ret

fxor_mem:
; this is one of the easiest to do
dx_loop:
	xor	byte ptr es:[di],0ffh
	inc	di
	loop	dx_loop
	ret

fbfill:
; colori is the index into colors
	push	ds
	push	es
	call	reset_segs
	pop	es
	push	si
	mov	si,colori
	shl	si,1
	shl	si,1
	shl	si,1
	shl	si,1
; si has the start of the color
	mov	ax,cs:crow
	inc	cs:crow
	and	ax,14
	add	si,ax
	mov	ax,word ptr colors[si]
	cmp	appl_sw,3
	jle	dfb_loop
	xor	ax,0ffffh
;
dfb_loop:
	cmp	appl_sw,0
	je	dfb_punch
	cmp	appl_sw,3
	je	dfb_punch
	cmp	appl_sw,1
	je	dfb_xor
	cmp	appl_sw,4
	je	dfb_xor
	or	byte ptr es:[di],al
	jmp	dfb_loope
dfb_xor:
	xor	byte ptr es:[di],al
	jmp	dfb_loope
dfb_punch:
	mov	byte ptr es:[di],al
dfb_loope:
	inc	di
	xchg	al,ah
	loop	dfb_loop
;
	pop	si
	pop	ds
	ret

ffade:
df_loop:
	and	byte ptr es:[di],10101010b
	inc	di
	loop	df_loop
	ret


fshade:
ds_loop:
	or	byte ptr es:[di],01010101b
	inc	di
	loop	ds_loop
	ret


flskew:
; this offsets each byte skew_count to left
; actually the thing is moving right but it tilts down to right
; making it appear that it is leaning left
; the thing starts with skew_count being equal to 0
; di points to start, have to set up end
        push es
        call reset_segs
        pop  es
	mov	ax,cs:skew_count
	inc	cs:skew_count
	cmp	skew,0
	je	cont_skew
	inc	cs:skew_count
	cmp	skew,1
	je	cont_skew
	dec	cs:skew_count
	test	dx,1
	jz	cont_skew
	dec	cs:skew_count
	jmp	cont_skew
frskew:
        push es
        call reset_segs
        pop  es
	mov	ax,cs:skew_count
	dec	cs:skew_count
	cmp	skew,0
	je	cont_skew
	dec	cs:skew_count
	cmp	skew,1
	je	cont_skew
	inc	cs:skew_count
	test	dx,1
	jz	cont_skew
	inc	cs:skew_count
cont_skew:
	add	di,width_bytes
	dec	di
	mov	si,di
	push	cx
	mov	dx,0
	mov	cx,8
	div	cx
	add	di,ax	; move right in di
; dx has the bits left over
; calculate the mask for the right byte
	mov	bl,0ffh
	mov	cl,dl
	shr	bl,cl	; bl has the mask to zero out the existing byte
	mov	bh,bl	; bh has the mask to zero out the byte to right
	xor	bh,0ffh
	pop	cx
	mov	al,0
ls_loop:
	push	cx
	mov	ah,byte ptr es:[si]
        cmp    cs:destroyer,1
        jne    ls_1
        mov    byte ptr es:[si],0
ls_1:
	mov	dh,ah
; shift ax to the right
	mov	cl,dl
	shr	ax,cl
; mask out the target byte
	cmp	di,0
	jl	ls_by
	and	byte ptr es:[di+1],bl
	and	al,bh
	or	byte ptr es:[di+1],al
; next 3 ok?
	and	byte ptr es:[di],bh	;
	or	byte ptr es:[di],ah
ls_by:
	dec	di
	dec	si
	mov	al,dh
	pop	cx
	loop	ls_loop
	ret



fmirror:
; mirror may have an even or an od number of bytes
; if its odd, the last byte will be flipped separately
	mov	bx,cx
	dec	bx
	mov	dx,0
	push	dx
	clc
	rcr	cx,1
	jnc	mi_loop
; its an odd number
	pop	dx
	mov	dx,1
	push dx
mi_loop:
	push	cx
	mov	al,byte ptr es:[di]
; shift the al,byte
	mov	cx,8
	clc
	mov	ah,0
mi_loop2:
	rcr	al,1
	rcl	ah,1
	loop	mi_loop2
	mov	dl,ah
	mov	al,byte ptr es:[di+bx]
	mov	cx,8
	clc
	mov	ah,0
mi_loop3:
	rcr	al,1
	rcl	ah,1
	loop	mi_loop3
	mov	byte ptr es:[di+bx],dl
	mov	byte ptr es:[di],ah
	inc	di
	dec	bx
	dec	bx
	pop	cx
	loop	mi_loop
	pop	dx
	cmp	dl,1
	je	last_mir
	ret
last_mir:
	mov	al,byte ptr es:[di]
	mov	cx,8
	clc
	mov	ah,0
mi_loop4:
	rcr	al,1
	rcl	ah,1
	loop	mi_loop4
	mov	byte ptr es:[di],ah
	ret


fhexpand:
	add	si,cx
	mov	ax,cx
	shl	ax,1
	add	di,ax
	dec	si
	dec	di
	dec	di
fhex_loop:
	push	cx
	mov	al,byte ptr ds:[si]
	mov	cx,4
fhex_loop1:
	mov	bl,al
	shl	ax,1
	mov	al,bl
	shl	ax,1
	loop	fhex_loop1
	mov	byte ptr es:[di],ah
	inc	di
	mov	cx,4
fhex_loop2:
	mov	bl,al
	shl	ax,1
	mov	al,bl
	shl	ax,1
	loop	fhex_loop2
	mov	byte ptr es:[di],ah
	dec	di
	dec	di
	dec	di
	dec	si
	pop	cx
	loop	fhex_loop
	ret



fdelete:
; this is one of the easiest to do
dl_loop:
	mov	byte ptr es:[di],0h
	inc	di
	loop	dl_loop
	ret


fflip:
; this is one flips the bytes
fp_loop:
	mov	al,byte ptr es:[di]
	mov	bl,byte ptr ds:[si]
	mov	byte ptr ds:[si],al
	mov	byte ptr es:[di],bl
	inc	di
	inc	si
	loop	fp_loop
	ret

; local cs data for smoothing
line1	dw	0
line2	dw	0
line3	dw	0
funstep:
;	jmp	fsmooth
fclean:
;	jmp	fsmooth
froll:
;	jmp	fsmooth
fgray:
;	jmp	fsmooth

fsmooth:
; this will do work on a set of lines, and move in results
; cx has line width
; es:di is where we are pointing
; ds:si is where we get the next line
; first step is move back the guys in lines

        push es
        call reset_segs
        pop  es
	push	es
	push	di
	push	ds
	push	si
	push	cx
	call	reset_segs
;	lea	si,lines
	mov	si,1
	mov	di,si
	add	si,cx
	shl	cx,1
	cld
	push	ds
	push	es
	call	reset_segs
	mov	es,buffer
	mov	ds,buffer
rep	movsb
	pop	es
	pop	ds
; now move the current line into the lines stuff
	pop	cx
	pop	si
	pop	ds
	push	cx
;	lea	di,lines
	mov	di,1
	add	di,cx
	add	di,cx
	push	es
	push	ds
	call	reset_segs
	mov	es,buffer
	pop	ds
	cld
        mov     ds,bp
rep	movsb
	pop	es
; now the lines are ready to massage and place results in es:di
	pop	cx
	push	es
	pop	ds
	pop	di
	pop	es
; stack is clean
	mov	dx,cx	; the line width
;	lea	si,lines
	mov	si,1
	push	bp	; counter
	mov	bp,0
sm_loop:
	push	dx
	push	es
	push	di
	push	si
	push	cx
; get the bits into ax
	dsbuff
	mov	bl,0
	mov	bh,byte ptr ds:[si]-1
	shr	bx,1
	mov	ax,word ptr ds:[si]
	xchg	al,ah
	shr	ax,1
	or	ah,bl
	pop	ds
; ax has the guy to inspect
	mov	line1,ax
	add	si,dx
	dsbuff
	mov	bl,0
	mov	bh,byte ptr ds:[si]-1
	shr	bx,1
	mov	ax,word ptr ds:[si]
	xchg	al,ah
	shr	ax,1
	or	ah,bl
	pop	ds
	mov	line2,ax
	add	si,dx
	dsbuff
	mov	bl,0
	mov	bh,byte ptr ds:[si]-1
	shr	bx,1
	mov	ax,word ptr ds:[si]
	xchg	al,ah
	shr	ax,1
	or	ah,bl
	pop	ds
	mov	line3,ax
; line1 - 3 have the three lines of data to inspect
;	have to inspect 8 times
	mov	cx,8
	mov	dl,0	; results
sm_loop1:
	push	cx
	mov	bl,0
	shl	dl,1
	mov	al,byte ptr line1+1
	test	al,80h
	jz	nl11
	inc	bp
nl11:
	test	al,40h
	jz	nl12
	inc	bp
nl12:
	test	al,20h
	jz	nl13
	inc	bp
nl13:
	mov	al,byte ptr line2+1
	test	al,80h
	jz	nl21
	inc	bp
nl21:
	test	al,40h
	jz	nl22
	mov	bl,1
	inc	bp
	inc	bp
	inc	bp
nl22:
	test	al,20h
	jz	nl23
	inc	bp
nl23:
	mov	al,byte ptr line3+1
	test	al,80h
	jz	nl31
	inc	bp
nl31:
	test	al,40h
	jz	nl32
	inc	bp
nl32:
	test	al,20h
	jz	nl33
	inc	bp
nl33:

;
; bp has the count of this pass for the point
	cmp	cswitch,1
	jne	no_gray
; this does shades, 0-2 black 3,4 5 left 6,7,8 right 9,10 11 white
	cmp	bp,2
	jle	no_dot
	cmp	bp,9
	jge	is_dot
	cmp	bp,5
	jle	cl_dot
	test	cl,1
	jz	no_dot
	jmp	is_dot
cl_dot:
	test	cl,1
	jnz	no_dot
	jmp	is_dot
no_gray:
	cmp	cswitch,3
	jne	no_clean
	cmp	bp,3
	jle	no_dot
	cmp	bp,7
	jg	is_dot
	cmp	bl,0
	je	check_no_dot
; there is a dot here, should we consider it?
	cmp	bp,5
	jle	no_dot
	jmp	is_dot
check_no_dot:
; there is no dot here, should we consider one
	cmp	bp,6
	jg	is_dot
	jmp	no_dot
no_clean:
	cmp	cswitch,4
	jne	no_unstep
; do the step stuff here
	cmp	bp,5
	jne	not_step1
	jmp	is_dot
not_step1:
	cmp	bp,6
	jne	not_step2
	jmp	no_dot
not_step2:
	cmp	bl,1
	je	is_dot
	jmp	no_dot
no_unstep:
; must be zero or 2 which is simple contrast
	cmp	bp,6
	jl	no_dot
;	jmp	is_dot
is_dot:
	or	dl,1
	cmp	cswitch,2
	jne	no_dot
	sub	bp,11
	jmp	by_dot
no_dot:
; move to next 3 dots
	cmp	cswitch,2
	je	by_dot
	mov	bp,0
by_dot:
	shl	line1,1
	shl	line2,1
	shl	line3,1
	pop	cx
	loop	sm_loopx1
	jmp	exit_sm1
sm_loopx1:
	jmp	sm_loop1
exit_sm1:
	pop	cx
	pop	si
	pop	di
	pop	es
	mov	byte ptr es:[di],dl	; the result of all this study
	pop	dx
	inc	di
	inc	si
	loop	sm_loopx
	jmp	exit_sm
sm_loopx:
	jmp	sm_loop
exit_sm:
	pop	bp
	ret


fhshrink:
; gets every other dot and stores it into es:di,
	shr	cx,1
fhs_loop:
	lodsb
        cmp    cs:destroyer,1
        jne    fhs_1
        mov    byte ptr ds:[si-1],0
fhs_1:
	shl	ax,1
	shl	al,1
	shl	ax,1
	shl	al,1
	shl	ax,1
	shl	al,1
	shl	ax,1
	shl	al,1
	lodsb
        cmp    cs:destroyer,1
        jne    fhs_2
        mov    byte ptr ds:[si-1],0
fhs_2:
	shl	ax,1
	shl	al,1
	shl	ax,1
	shl	al,1
	shl	ax,1
	shl	al,1
	shl	ax,1
	shl	al,1
	mov	al,ah
	stosb
	loop fhs_loop
	ret



fblank:
; this is one of the easiest to do
er_loop:
	mov	byte ptr es:[di],0ffh
	inc	di
	loop	er_loop
	ret

fxorl:
; es:di points to the current point and ds:si points
; the same point on the next line
; cx has the width of the line
	mov	al,byte ptr ds:[si]
	xor	byte ptr es:[di],al
	inc	di
	inc	si
	loop	fxorl
	ret

fdepos:
; same as ferode with the xor of data before working
; es:di points to the current point and ds:si points
; the same point on the next line
; cx has the width of the line
	mov	ax,word ptr es:[di]
	mov	bx,word ptr ds:[si]
	xor	ax,0ffffh
	xor	bx,0ffffh
	mov	dl,al
	mov	dh,bl
;
fde_loop:
; dl has current line previous byte
; al has current byte
; ah has next byte
; do current line stuff
	xor	byte ptr es:[di],0ffh
	push	ax
	shr	dl,1
	rcr	al,1
	and	byte ptr es:[di],al
	pop	ax
	push	ax
	shl	ah,1
	rcl	al,1
	and	byte ptr es:[di],al
	pop	ax
	mov	dl,al	; set for next
	mov	al,ah
	push	bx
	and	byte ptr es:[di],bl
	shl	bh,1
	rcl	bl,1
	and	byte ptr es:[di],bl
	pop	bx
	push	bx
	shr	dh,1
	rcr	bl,1
	and	byte ptr es:[di],bl
	pop	bx
	mov	dh,bl
	mov	bl,bh
; get next
	xor	byte ptr es:[di],0ffh
	inc	si
	inc	di
	mov	ah,byte ptr es:[di+1]
	mov	bh,byte ptr ds:[si+1]
	xor	ah,0ffh
	xor	bh,0ffh
	loop	fde_loop
	ret
ferode:
; same as fbound with the anding of stuff
; es:di points to the current point and ds:si points
; the same point on the next line
; cx has the width of the line
	mov	ax,word ptr es:[di]
	mov	bx,word ptr ds:[si]
	mov	dl,al
	mov	dh,bl
;
fe_loop:
; dl has current line previous byte
; al has current byte
; ah has next byte
; do current line stuff
	push	ax
	shr	dl,1
	rcr	al,1
	and	byte ptr es:[di],al
	pop	ax
	push	ax
	shl	ah,1
	rcl	al,1
	and	byte ptr es:[di],al
	pop	ax
	mov	dl,al	; set for next
	mov	al,ah
	push	bx
	and	byte ptr es:[di],bl
	shl	bh,1
	rcl	bl,1
	and	byte ptr es:[di],bl
	pop	bx
	push	bx
	shr	dh,1
	rcr	bl,1
	and	byte ptr es:[di],bl
	pop	bx
	mov	dh,bl
	mov	bl,bh
; get next
	inc	si
	inc	di
	mov	ah,byte ptr es:[di+1]
	mov	bh,byte ptr ds:[si+1]
	loop	fe_loop
	ret

fbound:
; in bound, es:di points to the current point and ds:si points
; the same point on the next line
; cx has the width of the line
	mov	al,0
bn_loop:
	mov	ax,word ptr ds:[si]
	mov	bl,byte ptr es:[di]
	xchg	al,ah
	mov	dl,bl
	xor	dl,ah
	mov	dh,dl
	shl	ax,1
	mov	dl,bl
	xor	dl,ah
	or	dh,dl
; dot above and dot to right are xored need dot to left
	mov	ax,0
	cmp	si,0
	jle	by_bnload
	mov	ax,word ptr ds:[si-1]
by_bnload:
	xchg	al,ah
	shr	ax,1
	xor	bl,al
	or	dh,bl
	mov	byte ptr es:[di],dh
;
	inc	di
	inc	si
	loop	bn_loop
	ret
cseg ends
	end
