get_bytem macro string
local by_swap
     push  ds
     mov   ds,buffer
     lodsb
     pop   ds
     cmp   tif_fillorder,2
     jne   by_swap
     push  bx
     mov   bl,al
     mov   bh,0
     mov   al,filltable[bx]
     pop   bx
by_swap:
     endm
get_wordm macro string
local by_swap
     push  ds
     mov   ds,buffer
     lodsw
     pop   ds
     cmp   tif_fillorder,2
     jne   by_swap
     push  bx
     mov   bl,al
     mov   bh,0
     mov   al,filltable[bx]
     mov   bl,ah
     mov   ah,filltable[bx]
     pop   bx
by_swap:
     endm
; OKHUFF is an alternative to reading the fax modified huffman
; I will try it instead of the CCITTR program.
dseg segment para public 'DATA'
curr_color  db 1
savecx   dw 0
savesi   dw 0
savedi   dw 0
savees   dw 0
thisline  dw 0
outbytes  dw  0
max_bits  dw  0
extrn  width_bytes:word,width_pix:word
extrn  filltable:byte,tif_fillorder:word
lastline  db 4098 dup(0);
dseg ends

CSEG segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn  reset_segs:near
;xtrn  flush_buffer:near
;
;
; These are 2d coding support routines
findb2:
; this is like findb1 execpt that the color is reversed
findb1:
; this finds the first change element to the right of a0
; a0 is determined by outbytes and lastline
;
     mov   saveax,ax
     mov   savecx,cx
     mov   savedx,dx
     mov   savesi,si
     mov   savedi,di
     mov   savees,es
     mov  si,outbytes
     add  si,offset lastline
     mov  bx,0 ; use bx as the count of bits we have found
     cld
     lodsb
; the color we are looking for is first white and then black
; but only if we are in white color
; if current color is black we are looking for a change to black
     cmp  dh,1
;    je   fb1_b
; searching the ax for a 1
     xor  al,0ffh
fb1_w1:
; al can be treated as though we are searching for white bits then blk
     mov  cx,8
     sub  cx,last_bits
     cmp  cx,0
     mov  di,cx
     je   fb1_w2
fb1_wloop:
     test  al,80h
     jnz   fb1_w2
     shl   al,1
     inc   bx
     loop  fb1_wloop
fb1_w2:
; bx has the number of bits searched but not found
; zero means it was 1 bit
     cmp   bx,di
     je    fb1_byte_search
     mov   cx,bx
     inc   cx
     jmp   fb1_exit
fb1_byte_search:
; the search for the bits was not successful, now check the bytes
     mov   cx,width_bytes
     sub   cx,outbytes
     dec   cx
     cmp   cx,0
     jle   fb1_exit
; search for the next off color byte
fb1_byte_loop:
     cld
     lodsb
     cmp   dh,1
     je    fb1_1b1
     xor   al,0ffh
fb1_1b1:
     cmp   al,0
     je    fb1_1b2
     add   bx,8
     loop  fb1_byte_loop
fb1_1b2:
; now have to do the remaining bits
     mov   cx,8
fb1_lastbits_loop:
     test  al,80h
     jnz   fb1_last_bits_done
     shl   al,1
     inc   bx
     loop  fb1_lastbits_loop
fb1_last_bits_done:
     mov   cx,bx
fb1_exit:
     mov   dx,savedx
     mov   di,savedi
     mov   si,savesi
     mov   es,savees
     mov   ax,saveax
     ret
;
;
;
string_it:
; try again at stringit
; cx has the guys to string
    sub   max_bits,cx
    cmp   cx,0
    jg   string0
stringx:
    clc
    ret
string0:
;   cmp  di,5000h
;   ja   stringx
    call reset_segs
;   mov   ax,cx
;   shr   ax,1
;   shr   ax,1
;   shr   ax,1
;   cmp   ax,width_bytes
;   jle   okwid
;   ret
okwid:
    push  es
    mov   es,buffer
;   cx has the length of bits to string, last_bits has the number
;   of bits already sent down
    mov   bl,0ffh
    mov   bh,curr_color
    cmp    bh,0
    jne   not_black
    mov   bl,0
not_black:
    cmp   last_bits,0
    jne   finish_last_bits
string_zero_bits:
; here we are on a even bit boundary
    mov   ax,cx
    mov   dx,0
    mov   cx,8
    div   cx
    mov   cx,ax
    mov   al,bl
    add   outbytes,cx
    cmp   cx,0
    je    no_reps
    cld
rep  stosb
no_reps:
    mov    last_bits,dx
    mov    byte ptr es:[di],al
    jmp  good_string
finish_last_bits:
; the last bits have to be finished up
    push  cx
    mov   ah,byte ptr es:[di]
    mov   al,bl
    mov   cx,8
    sub   cx,last_bits
    shr   ah,cl
    shl   ax,cl
    mov   byte ptr es:[di],ah
    pop   cx
    add   last_bits,cx
    cmp   last_bits,8
    jl    more_string_bits
    je    one_string_byte
    mov   cx,last_bits
    sub   cx,8
    inc   di
    jmp   string_zero_bits
more_string_bits:
;  no increment or anything
     jmp  good_string
one_string_byte:
;  finished off a string
     mov   last_bits,0
     inc   di
;    jmp  good_string
good_string:
    pop   es
    clc
    ret

;
; entry points are huffr1 which sets up the first read of a line
; and huffr which reads a line
huffr1:
public huffr1
; set up stuff
     push  ax
     push  cx
     mov saveax,0
     mov  dh,0
     mov  dl,16
     mov savedx,dx     ; save the color ind
     mov last_bits,0
     mov curr_color,1
     pop  cx
     pop  ax
     ret
get_byte:
; this assures the segments are good when we get a new byte
     get_bytem
     ret
get_word:
     get_wordm
     ret
;
huffr:
public huffr
; read a line
; ax has the max bytes we are allowed to read
; cx has the length of line to read
; di has where it goes
     mov   outbytes,0
     mov   cx,width_bytes
     push  es
     push  di
    mov   es,buffer
     cld
     mov   al,0
rep  stosb
     pop   di
     pop   es
     mov   cx,width_bytes
     mov   last_bits,0
     mov   max_byte,cx
     shl   cx,1
     shl   cx,1
     shl   cx,1
     mov   max_bits,cx
     mov   dx,savedx
     mov   dh,0
     mov   savedx,dx
     cld
huffr2:  ; entry without force white
public huffr2
     mov   outbytes,0
huffr2a:
     mov  ax,saveax
     mov  dx,savedx
     cmp  max_bits,0
     jg   not_last
done_line:
     clc
     ret
not_last:
     call  next_byte
     jc    bad_huff
; returns with the number of bits to string in cx
;    dh has a 1 or a 0 depending on the color
;    carry is set if a bad read
; if ch is 254 then it is an eol character
     cmp   cx,254
     jne   not_a_eol
; what to do with an eol. If it is the first guy, we ignore it
     cmp   max_bits,0
     jle   done_this_line
     mov   cx,width_pix
     sub   cx,max_bits
     cmp   cx,0
     je    not_last
     je    done_this_line
     jmp   not_a_eol
done_this_line:
     mov   dh,0
     clc
     ret
not_a_eol:
; cx has the count of characters
; dh has a 1 or a zero, 1 for black, 0 for white
     cmp   cx,0
     je   huffr2a
     push  cx
     call  string_it
     pop   cx
     jc    good_huffx
     jmp   huffr2a
good_huffx:
     clc
     ret
bad_huff:
     stc
     ret
;
;
next_byte:
;
     call reset_segs
     call check_dl
; something less than 8 shifted so far
; here there are at least 9 bits to check
; there is still some more than 8 bits of information so we go on
;
;  there may be an EOL which is the same for both black and white
     cmp  al,0  ; eol is 11 zeroes and a 1 there are no 8 zero
     jne  nb_1
; we have an eol   eol
     mov   cl,dl
     shr   ah,cl
     get_bytem
     shl   ax,cl
     xchg  al,ah
; here we know we have an eol, but we need 0001xxxx in ah
check_for_eolb:  ; check for last bit of eol, some formats
                 ; byte or word justify the eol characters
     push  ax
     and   al,11110000b
     cmp   al,10h  ; the last of the eol
     pop   ax
     je    nb_2
     xchg  al,ah
     shl   ax,1
     xchg  al,ah
     inc   dl
     call  check_dl
     jmp   check_for_eolb
nb_2: ;found the eol bit now get rid of it
; have shifted 8, now the other 4
     mov   cl,4
     xchg  al,ah
     shl   ax,cl
     add   dl,4
     xchg  al,ah
     mov   dh,0
     mov   saveax,ax
     mov   savedx,dx
     mov   cx,254  ; eof flag for calling procedures
     clc
     ret
; all done, leave with an eol
nb_1:
     mov  curr_color,1
     cmp  dh,0  ; white/black indicator, 0 is white
     je   do_white
     jmp  do_black
do_white:
; find the match to the guy in al
     mov    curr_color,0
     mov    dh,1    ; next is black
; look up in table to get the next
     mov    bh,0
     mov    bl,al   ; al has the sig bits
     mov    ch,white_tab1[bx]    ; number
     mov    cl,white_tabl[bx]    ; length
do_lookup: ; same for black and white after here
     cmp    ch,255
     jne    good_w1
leave_look:
     stc
     ret
good_w1:
;
     cmp    ch,253
     jne    not_long
; the long character has been identified
; we must do the shift
     call  fix_bits  ; fixes up the bits
     mov   bl,al
     mov   cl,4
     shr   bl,cl
     mov    ch,long_tab1[bx]    ; number
     mov    cl,long_tabl[bx]    ; length
; got the long string in cx now - good for tiff
not_long:
     cmp    cl,9
     jne    w_not_9
; white 9's have a 0 in next byte if they are
     test   ah,80h
     jz     w_not_9
     inc    ch
     cmp    ch,89
     jne    w_not_9
     inc    ch
w_not_9:
; cl has the amount to shift
; ch has the string count
     cmp   cl,8
     jl    w_lt_8
; here we have to shift 8 or more bytes, dl is always less than 8
     mov   al,ah
     add   dl,8
     sub   cl,8
     push  cx
     call  check_dl ; since we did a 9, we might have had a 7 in dl
     pop   cx
     cmp   cl,0
     je    w_by_8x
     jmp   w_not_9
w_lt_8:
     xchg  al,ah
     shl   ax,cl
     xchg  al,ah
     add   dl,cl
w_by_8x:
; check to see if ch>64
     mov   cl,ch
     mov   ch,0
     cmp   cx,63     ; cx has the unstring length
     jg    cx_gt_64
     jmp   do_save
cx_gt_64:
     sub   cx,63
     xor   dh,1
ok_cx_l:
     push  ax
     mov   ax,cx
     mov   cl,6
     shl   ax,cl
     mov   cx,ax
     pop   ax
do_save:
     clc
; this is the area where we have a length in cx and we can return
     mov   saveax,ax
     mov   savedx,dx
;
     ret
;
;
; these guys are by brute force
;  db 00010000b      ; 9     6    000100
;  db 00010100b      ; 8     6    000101
;  db 00011000b      ; 7     5    00011
;  db 00100000b      ; 6     4    0010
;  db 00110000b      ; 5     4    0011
;  db 01000000b      ; 1     3    010
;  db 01100000b      ; 4     3    011
;  db 10000000b      ; 3     2    10
;  db 11000000b      ; 2     2    11
;
;
do_black:
     mov    dh,0    ; next is white
; black strategy is sligthly different than white.
; almost all black strings are 12 bits long.
; we have to identify the short ones and do them by hand
; check for eol
     test al,0f0h
     jnz  black_short
     jmp  black_long
black_short:
; here we have one of the short strings
; there are 9  of them
; length of 6
     test  al,80h
     jz    not_2_3
;  2 is 11
;  3 is 10
     test  al,40h
     jnz   got_2
; got a 11  in al
     mov   cl,2
     mov   ch,3
     jmp   black_s_hit
got_2:
; got a 10  in al
     mov   cl,2
     mov   ch,2
     jmp   black_s_hit
not_2_3:
; high bit is not on
     test  al,40h
     jz    not_1_4
; got either 010 for 1 or 011 for 4
     test  al,20h
     jnz   got_4
; got 010 in al
     mov   cl,3
     mov   ch,1
     jmp   black_s_hit
got_4:
; got 011 in al
     mov   cl,3
     mov   ch,4
     jmp   black_s_hit
not_1_4:
; first two bits are 00
     test  al,20h
     jz   not_5_6
     test  al,10h
     jz    got_6
; got 0011 in al
     mov   cl,4
     mov   ch,5
     jmp   black_s_hit
got_6:
; got 0011 in al
     mov   cl,4
     mov   ch,6
     jmp   black_s_hit
not_5_6:
; have 0001 in al
     test  al,08h
     jz    got_8_9
; got 00011 in al
     mov   cl,5
     mov   ch,7
     jmp   black_s_hit
got_8_9:
; can have 8=000101
;          9=000100
     test  al,04h
     jnz   got_8
; got 000100 in al
     mov   cl,6
     mov   ch,9
     jmp   black_s_hit
got_8:
; got 000101 in al
     mov   cl,6
     mov   ch,8
;    jmp   black_s_hit
black_s_hit:
; got a short hit on one of the 14
; dl has the length
    xchg  al,ah
    shl   ax,cl
    xchg  al,ah
    add   dl,cl
    mov   cl,ch
    mov   ch,0
; di has the hit in it
    jmp   do_save
;
black_long:
; these are long strings
; black long strings have to be shifted
   xchg  al,ah
   mov   cl,4
   shl   ax,cl
   add   dl,4
   xchg  al,ah
   call check_dl
; the ax has been shifted right 4
; more or less mimic the white lookup
; look up in table to get the next
     mov    bh,0
     mov    bl,al   ; al has the sig bits
     mov    ch,black_tab1[bx]
     mov    cl,black_tabl[bx]
     jmp    do_lookup
check_dl:
; on entry, dl has the total of all shifts made so far.
; if dl is greater equal to 8 we have to get a new byte
; if dl is greater than 8 we have to shift into the existing byte
     cmp  dl,16   ; dl has the amount we have shifted since the last lod
     jne  no_new_word
new_word:
; get a new word from the input stream - first time though
     mov   dl,0
     get_wordm
; al has the first byte of word
     ret
no_new_word:
     cmp  dl,8
     je   new_byte
     jl   do_lowshift
; more than 8 bits shifted
     mov   ah,al
     get_bytem
     sub  dl,8
     mov  cl,dl
     shr  ah,cl
     shl  ax,cl
; now we have to shift ah to the right
     xchg al,ah
     jmp  do_lowshift
new_byte:
; last guy was exactly 8 bytes long
; have to get a new byte
     mov  ah,al
     get_bytem
     xchg al,ah
     mov  dl,0
do_lowshift:
      ret
;
;
g4dcode:
; this looks up the code for the current guy
     call check_dl
; something less than 8 shifted so far
; here there are at least 9 bits to check
; there is still some more than 8 bits of information so we go on
; find the match to the guy in al
; look up in table to get the next
     mov    bh,0
     mov    bl,al   ; al has the sig bits
     mov    ch,g4tab[bx]    ; number
     mov    cl,g4len[bx]    ; length
; have to shift the guyes in ax out of the picture
     call   fix_bits
     ret
fix_bits:
     cmp   cl,8
     jl    l_lt_8
     mov   al,ah
     add   dl,8
     sub   cl,8
     cmp   cl,0
     je    w_by_8
l_lt_8:
     xchg  al,ah
     shl   ax,cl
     xchg  al,ah
     add   dl,cl
; shifted the guy now do the rest of the lookup
w_by_8:
   call check_dl  ; make sure we have a good guy in al
     ret
;
g4init:
public g4init
     mov   savees,es
     mov   savedi,di
     call  reset_segs
     mov   cx,2048
     mov   di,offset lastline
     mov   ax,0
     cld
rep  stosw
     mov   di,width_bytes
     mov   lastline[di],-1
     mov    di,savedi
     mov    es,savees
     clc
     ret
g4save:
     mov   savees,es
     mov   savedi,di
     call  reset_segs
     mov   di,offset lastline
     push  si
     mov   si,thisline
     mov   cx,width_bytes
     cld
rep  movsb
     pop    si
     mov    di,savedi
     mov    es,savees
     clc
     ret
g4_vertical:
; vertical is the worste, I have to scan the old line
; to find the first non-white bit, starting from where I am
; in the last_line
     call  check_dl
     call  white_search
; cx has the length to string out as a white bit
     ret
white_search:
     mov   saveax,ax
     mov   savecx,cx
     mov   savedx,dx
     mov   savedi,di
     mov   savesi,di
     mov   savees,es
; where are we in the output line?
;    outbytes points to location in the lastline
;    last_bits is how much is left in bits
     mov  si,outbytes
     add  si,offset lastline
     cld
     lodsb
     mov  cx,last_bits
     cmp  cx,0
     je   not_in_last
     shl  al,cl
;  ax has the bits we haven't seen yet
     mov  bl,80h
     mov  cl,8
     sub  cx,last_bits
     jle  not_in_last
     mov  bl,80h
     mov  ch,0
     mov  dx,cx
bit_loop1:
     test al,bl
     jnz  got_last_bit
     shr  bl,1
     loop  bit_loop1
     jmp  not_in_last
zero_last_bits:
     mov  cx,0
     mov  dx,0
got_last_bit:
; got the number of bits to string white space
     sub  dx,cx
exit_white_search:
     mov   ax,saveax
     mov   cx,savecx
     mov   cx,dx
     mov   dx,savedx
     mov   di,savedi
     mov   si,savesi
     mov   es,savees
     ret
not_in_last:
; the current bit does not have a bit on
    mov    dh,0
    mov    dl,8
    sub    dx,last_bits
; scan for a non-zero byte
    mov    cx,width_bytes
    inc    cx
    sub    cx,outbytes
    cmp    cx,0
    jle    zero_last_bits
    mov    di,si
    mov    al,0
repne  scasb
; points to byte after the last guy
    dec    di
    mov    ax,di
    sub    ax,si
    shl    ax,1
    shl    ax,1
    shl    ax,1
    add    dx,ax   ; number of bits so far
; now find how many bits of the last byte are white
    mov    si,di
    cld
    lodsb
    mov    bl,80h
    mov    cx,8
bit_loop2:
    test   al,bl
    jnz    got_bit
    inc    dx
    shr    bl,1
    loop   bit_loop2
got_bit:
    jmp    exit_white_search
;
;
;
g4line:
; this takes the current line and decodes it against last_line
; read a line
; ax has the max bytes we are allowed to read
; cx has the length of line to read
; di has where it goes
     mov   outbytes,0
     mov   cx,width_bytes
     mov   thisline,di
     push  es
     push  di
     push  si
    mov   es,buffer
    mov   si,offset lastline
     cld
rep  movsb
     pop   si
     pop   di
     pop   es
     mov   cx,width_bytes
     mov   last_bits,0
     mov   max_byte,cx
     shl   cx,1
     shl   cx,1
     shl   cx,1
     mov   max_bits,cx
     mov   dx,savedx
     mov   dh,0
     mov   savedx,dx
; at all times:
;   di points to next byte to read
;   ax has the current bits
;   dl has the count of bytes shifted in ax
;   16-dl = bits in ax
;   dh has the color
;   max_byte has the bytes left to read in line
;
g4_next:
     mov  ax,saveax
     mov  dx,savedx
     cmp  max_byte,0
     jg   not_last1
     cmp  dl,4       ; how much left in ax
     jl   not_last1
     clc
     ret
not_last1:
    call  g4dcode
; returns ch = code, cl = length of code
; 80 = error, 81 = extensiion (abort)
; 82 = pass, 83 = horizontal
; otherwise the codewords length
    cmp  ch,80
    jne  no_g4_err1
g4_err1:
    stc
    ret
no_g4_err1:
    cmp ch,81
    je  g4_err1
    cmp cl,0
    jle g4_err1
    cmp ch,82
    je  g4_passmode
    cmp ch,83
    je  g4_horizontal
;  group 4 vertical mode
    jmp  g4_vertical
g4_passmode:
;
g4_horizontal:
;
; horizontal mode is the same as the old ccitt3 stuff
   mov   dh,0      ;force a white
   call  next_byte  ; for a black and a white
     jc    bad_g4b
; returns with the number of bits to string in cx
;    dh has a 1 or a 0 depending on the color
;    carry is set if a bad read
; if ch is 254 then it is an eol character
     cmp   cx,254
     jne   not_a_g4eol
     mov   dh,0
     clc
     ret
not_a_g4eol:
; cx has the count of characters
; dh has a 1 or a zero, 1 for black, 0 for white
     cmp   cx,0
     je   g4_nextx
     push  cx
     call  string_it
     pop   cx
     jc    good_huffg4b
g4_nextx:
; now do a black
   mov   dh,1      ;force a white
   call  next_byte  ; for a black and a white
     jc    bad_g4b
; returns with the number of bits to string in cx
;    dh has a 1 or a 0 depending on the color
;    carry is set if a bad read
; if ch is 254 then it is an eol character
     cmp   cx,254
     jne   not_a_g4eolb
     mov   dh,0
     clc
     ret
not_a_g4eolb:
; cx has the count of characters
; dh has a 1 or a zero, 1 for black, 0 for white
     cmp   cx,0
     je   g4_nextxb
     push  cx
     call  string_it
     pop   cx
     jc    good_huffg4b
g4_nextxb:
     jmp   g4_next
good_huffg4b:
     clc
     ret
bad_g4b:
     stc
     ret
CSEG ends
DSEG segment public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn  buffer:word,width_bytes:word,vwid:word
;
saveax  dw  0  ; contains the code we are working with
savedx  dw  0  ; saves length informations
last_bits dw 0 ; number of bits left over from last fill
max_byte dw 0
;
;
;
; the lookup is to white_tab1
; if there is number less than 65 then it is a good number
; if its greater than 64 then subtract 63 and mult by 64
; if length is 9 then next bit is added to length
; exception is white 88, if next bit is on then add 2 to length
; 254 is the eol character
; 255 is an error due to phase
; white_tabl has the length
; black table rules are similar, except that if first 4
; bits are zero then do a left shift 4 to bypass them
; the 9 items where first 4 bits have a 1 are done brute force
; no 88 exception on black
;
white_tab1  equ  this byte
  db 254,253,29,30,45,46,22,22,23,23,47,48,13,13,13,13
  db 20,20,33,34,35,36,37,38,19,19,31,32,1,1,1,1
  db 12,12,12,12,53,54,26,26,39,40,41,42,43,44,21,21
  db 28,28,61,62,63,00,68,69,10,10,10,10,10,10,10,10
  db 11,11,11,11,11,11,11,11,27,27,59,60,86,88,18,18
  db 24,24,49,50,51,52,25,25,55,56,57,58,66,66,66,66
  db 89,89,89,89,70,71,74,73,72,76,78,80,82,84,67,67
  db 16 dup(2)
  db 16 dup(3)
  db 8 dup(65),8 dup(8)
  db 8 dup(9),4 dup(16),4 dup(17)
  db 16 dup(4)
  db 16 dup(5)
  db 4 dup(14),4 dup(15),8 dup(64)
  db 16 dup(6)
  db 16 dup(7)
white_tabl equ this byte
  db 12,8,8,8,8,8,7,7,7,7,8,8,6,6,6,6
   db 7,7,8,8,8,8,8,8,7,7,8,8,6,6,6,6
   db 6,6,6,6,8,8,7,7,8,8,8,8,8,8,7,7
   db 7,7,8,8,8,8,8,8,5,5,5,5,5,5,5,5
   db 5,5,5,5,5,5,5,5,7,7,8,8,9,9,7,7
   db 7,7,8,8,8,8,7,7,8,8,8,8,6,6,6,6
   db 6,6,6,6,8,8,9,8,8,9,9,9,9,9,7,7
   db 16 dup(4)
   db 16 dup(4)
   db 16 dup(5)
   db 8 dup(5),8 dup(6)
   db 16 dup(4)
   db 16 dup(4)
   db 8 dup(6),8 dup(5)
   db 16 dup(4)
   db 16 dup(4)
black_tab1  equ  this byte
   db 16 dup(254)
   db 16 dup(253)
   db 18,18,18,18,52,73,75,55,56,83,85,59,60,87,24,24
   db 25,25,89,68,69,70,71,53,54,77,79,81,64,64,64,64
   db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13
   db 23,23,50,51,44,45,46,47,57,58,61,67,16,16,16,16
   db 17,17,17,17,48,49,62,63,30,31,32,33,40,41,22,22
   db 16 dup(14)
   db 16 dup(10)
   db 16 dup(10)
   db 16 dup(11)
   db 16 dup(11)
   db 15,15,15,15,15,15,15,15,65,66,26,27,28,29,19,19
   db 20,20,34,35,36,37,38,39,21,21,42,43,00,00,00,00
   db 32 dup(12)
black_tabl equ this byte
   db 0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0
   db 16 dup(4)
   db 6,6,6,6,8,9,9,8,8,9,9,8,8,9,7,7
   db 7,7,9,8,8,8,9,8,8,9,9,9,6,6,6,6
   db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
   db 7,7,8,8,8,8,8,8,8,8,8,8,6,6,6,6
   db 6,6,6,6,8,8,8,8,8,8,8,8,8,8,7,7
   db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
   db 16 dup(3)
   db 16 dup(3)
   db 16 dup(3)
   db 16 dup(3)
   db 5,5,5,5,5,5,5,5,8,8,8,8,8,8,7,7
   db 7,7,8,8,8,8,8,8,7,7,8,8,6,6,6,6
   db 32 dup(3)
;
; the long table is when the first 7 bits are zero (black and white)
; when we detect 1 in white mode or xlate a 253 in black we come here
; to further decode
;
long_tab1 equ this byte
     db  91,91,94,95,96,97,98,99,92,92,93,93,100,101,102,103
long_tabl equ this byte
     db  3,3,4,4,4,4,4,4,3,3,3,3,4,4,4,4
;
; group 4 table.
;
; 80 = error, 81 = extensiion (abort)
; 82 = pass, 83 = horizontal
g4tab db 80,80,81,81,3,3,-3,-3
      db 2,2,2,2,-2,-2,-2,-2
      db 16 dup(82)
      db 32 dup(83)
      db 32 dup(1)
      db 32 dup(-1)
      db 128 dup(0)
g4len db 0,0,10,10,7,7,7,7
      db 8 dup(6)
      db 16 dup(4)
      db 96 dup(3)
      db 128 dup(1)
public black_tabl,black_tab1
public white_tabl,white_tab1
public long_tabl,long_tab1
dseg  ends
      end
