; OKIO.ASM has the input output routines for disk files. This provides
; low level service for file reads,writes, opens and closes
;
; public routines are:
;
;  OPEN_IN
;  READ_FILE
;  CREATE_FILE
;  CLOSE_FILE
;  OPEN_IO
;  WRITE_FILE
;  STATE_FILE
;  GET_FIRST
;  GET_NEXT
;  LISTFILES
;  DISPLAY_DIR
;  CHANGE_DIR
;  CRIT_ERR
;
PUBLIC     open_in,read_file,create_file,open_io,close_file,write_file
PUBLIC     state_file,get_first,get_next
public     crit_err
extrn  gstring:near,highlight:near


dseg     SEGMENT PARA PUBLIC 'DATA'
     assume     CS:cseg,DS:dseg,ES:dseg
EXTRN     handle:WORD,strg:BYTE,curx:word,cury:word
extrn     file_name:byte,cdisk:byte
extrn     left_margin:word,buffer:word,str_len:word
extrn     fdate:word,fsize:word,cdir:byte,cwidth:word
extrn     sdisk:byte,fattrib:byte,wr_switch:word
overwrite  db ' already exists. Write over it? (y/n)',0
crit_mess  db 'An error has occurred while OPTIKS was trying to',10
     db 'access a disk. Please correct the problem and',10
     db '   press   1  -  Cancel current task',10
     db '   press   2  -  Retry the operation',10
     db '   press   3  -  Leave Optiks',0
nofiles  db 'No files found',0
last_open db 64 dup(0)
public last_open
filebox  db '      Use Up and Down Arrows to View Files',10
         db '         Return to Select, Esc to exit',10
         db 10
         db 48 dup ('')
         db 10
         db '             No Matching Files',10
 db 10 dup(10)
   db  '      Free disk space: '
free_space db '          ',10
   db  'Press F10 to change Disk, Directory or Filespec'
read_end db 0
public read_end
   db  '      Press F9 to create a new file',0
dircount   dw  0  ; count of dirs
tdir    db 32 dup(0)
edir     dw 0
pzero    db 0
mousex   db 0
chigh    dw 0ffh
public     dircount,tdir
;
;
dconfirm db 'Confirm Delete, Return=Delete, Esc=Abort',0
;
kline   db 0,1ch,1,35h,53h,44h
        db 47h,48h,49h,4fh,50h,51h,43h
;
dseg     ENDS


cseg    segment PARA PUBLIC 'CODE'
     assume     CS:cseg,DS:dseg,ES:dseg
extrn     present:near
extrn     getkey:near,printline:near,reset_segs:near,print_string:near
extrn     goback:near,exit_prog:near,prbox:near
;
pr_file: ; this is used to print out ten files, bx has the
         ; file to begin with
;
     mov   chigh,0ffh
     mov   ax,cwidth
     shl   ax,1
     shl   ax,1
     add   ax,cwidth
     add   ax,32
     mov   cury,ax
     push  bx
     mov   cx,10
prf_loop0:
     push  cx
     push  bx
     mov   cl,5
     shl   bx,cl
     mov   si,bx
     mov   cx,32
     mov   curx,128
     push  es
     mov   es,buffer
     call   printline
     pop   es
     pop   bx
     inc   bx
     pop   cx
     mov   ax,cwidth
     add   cury,ax
     cmp   bx,dircount
     jge   done_prf
     loop  prf_loop0
done_prf:
     cmp    cx,0
     je     no_sprf
; print out the spaces
prf_loop:
     push  cx
     lea   si,pzero
     mov   cx,32
     mov   curx,128
     call   printline
     mov   ax,cwidth
     add   cury,ax
     pop   cx
     loop  prf_loop
no_sprf:
     pop   bx
     ret

un_high_guy:
    cmp   chigh,0ffh
    jne   uhg_1
    ret
uhg_1:
    push  dx
    mov   dx,chigh
    mov   chigh,0ffh
    jmp   hg_2
high_guy:
; highlight the current selection
; this has cx for length to highlight
; curx and cury have the current location
     cmp   chigh,dx
     jne   hg_1
     ret
hg_1:
     mov   chigh,dx
     push  dx
hg_2:
     mov   ax,cwidth
     shl   ax,1
     shl   ax,1
     add   ax,cwidth
     add   ax,32
     mov   cury,ax
     mov   ax,dx
     mul   cwidth
     add   cury,ax
     mov   curx,128
     mov   cx,32
     call  highlight
     pop   dx
     ret

check_dir:
; this looks to see if the current guy is a dir. If it is it fixes
; strg
      push   es
      push   bx
      mov    es,buffer
; bx has the file name offset
     mov   cl,5
     shl   bx,cl
     add   bx,24
     cmp   byte ptr es:[bx],"<"
     jne   no_dir
is_dir:
; got a dir, fix the strg
     sub    bx,24
     mov    di,bx
     pop     bx
     pop     es
     lea    si,strg
     mov    cx,64
     mov    bx,si
id_1:
     lodsb
     cmp    al,0
     je    id_3
     cmp   al,'\'
     jne  id_2
     mov   bx,si
id_2:
     loop  id_1
id_3:
     mov   si,di
     mov   di,bx
     push  ds
     mov   ds,buffer
id_4:
     lodsb
     cmp   al,' '
     je    id_5
     stosb
     jmp   id_4
id_5:
     mov   al,'\'
     stosb
; add the file type
    mov  ax,".*"
    stosw
    mov  ah,0
    stosw
     pop   ds
     stc
     ret
no_dir:
      pop   bx
      pop   es
      clc
      ret

move_strg:
; this moves the completed disk dir and file back into strg
     lea  di,strg
     mov  al,cdisk
     stosb
     mov  al,':'
     stosb
     lea  si,cdir
ms_loop0:
     lodsb
     cmp  al,0
     je   ms_loop1
     stosb
     jmp  ms_loop0
ms_loop1:
    cmp  byte ptr es:[di-1],'\'
    je   s_cmov
    mov  al,'\'
    stosb
s_cmov:
; bx has the file name offset
     mov   cl,5
     shl   bx,cl
     push  ds
     mov  ds,buffer
     mov  si,bx
ms_loop2:
     lodsb
     cmp   al,20h
     je   ms_loop3
     stosb
     jmp  ms_loop2
ms_loop3:
     pop   ds
     mov   ax,0
     stosw
     ret

;
list_filep:
public list_filep
; list files for printer
    call  reset_segs
    mov   wr_switch,1
    mov   word ptr strg,'.*'
    mov   word ptr strg+2,'RP'
    mov   strg+4,'N'
    mov   strg+5,0
;
    jmp   list_file1
list_file2:
public list_file2
    call  reset_segs
    mov   word ptr strg,'.*'
    mov   strg+2,'*'
    mov   strg+3,0
list_file1:
    call  reset_segs
    lea   si,strg
    lea   di,tdir
    cld
    mov   cx,32
rep  movsb
list_files:
public list_files
    lea  di,strg
    mov  al,cdisk
    stosb
    mov  al,':'
    stosb
    lea  si,cdir
m_cdir:
    lodsb
    cmp  al,0
    je   e_cdir
    stosb
    jmp  m_cdir
e_cdir:
    cmp  byte ptr es:[di-1],'\'
    je   s_cdir
    mov  al,'\'
    stosb
s_cdir:
    mov  edir,di
    lea  si,tdir
s_tdir:
    lodsb
    cmp  al,0
    je   e_tdir
    stosb
    jmp  s_tdir
e_tdir:
    mov   ah,0
    stosw
    stosw
    call  d_dir2
    cmp   dircount,0
    jg    list_dir
    lea   si,strg
    mov   dircount,0
wc_loop:
    cld
    lodsb
    cmp   al,'?'
    je    list_dir
    cmp   al,'*'
    je    list_dir
    cmp   al,0
    jne   wc_loop
    cmp   wr_switch,0
    je    bad_first
    mov   ax,0d1ch
    mov   bx,1
    ret
bad_first:
    jmp   do_f10
list_dir:
; get the free space on the diks
;
    call  reset_segs
    mov   dl,cdisk
    sub   dl,40h
    mov   ah,36h
    int   21h
; bx has allocs, cx bytes/cluster, ax sectors
    lea   di,free_space
    mul   cx    ; dx,ax has the bytes per cluster
    mov   cx,bx
    mul   cx
    add   ax,512
    adc   dx,0
; rather than divide we will shift to right 10 bits
;   mov   cx,1000
;   div   cx
;   mov   dx,0
    mov   al,ah
    mov   ah,dl
    mov   dl,dh
    mov   dh,0
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
;  dx,ax has K
    mov   cx,10000
    div   cx
    mov   cx,100
    div   cl
    push  ax
    mov   ah,0
    mov   cl,10
    div   cl
    or    ax,3030h
;   stosw
    pop   ax
    mov   al,ah
    mov   ah,0
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   cx,100
    div   cl
    push  ax
    mov   ah,0
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    pop   ax
    mov   al,ah
    mov   ah,0
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   al,'K'
    stosb
    lea   si,free_space
    mov   di,si
fs1:
    lodsb
    cmp   al,'0'
    jne   fs2
    mov   al,20h
    stosb
    jmp   fs1
fs2:
;
;
    lea   dx,filebox
    mov   left_margin,64
    mov   curx,64
    mov   cury,32
    call  prbox
    call  reset_segs
; move the curr_dir into the box
    lea   si,strg
    mov   curx,80
    mov   ax,32
    add   ax,cwidth
    add   ax,cwidth
    add   ax,cwidth
    mov   cury,ax
    mov   cx,46
    call  printline
; now we have to display ten of the guys out there
    mov    bx,0
    cmp    dircount,0
    jne    more_file1
    jmp    do_f10
more_file1:
    call   pr_file
    mov   mousex,0
    mov    bx,0
    mov    dx,0
ld_top:
; check here for bad lines
check_top:
    cmp    bx,0
    jg     not_top
    mov    bx,0
    call   pr_file
    mov   mousex,0
    mov    bx,0
    mov    dx,0
    jmp    not_bot
not_top:
    cmp  bx,dircount
    jl   not_bot
    mov  ax,dircount
    sub  ax,10
    mov  bx,ax
    mov  dx,10
    cmp  bx,0
    jl   check_top
    push bx
    push dx
    call   pr_file
    pop  dx
    pop  bx
not_bot:
    cmp    dx,0
    jl     re_pr
    cmp    dx,10
    jl     by_pr
re_pr:
    push   bx
    push   dx
    call  pr_file
    mov   mousex,0
    pop   dx
    pop   bx
    mov   dx,0
    jmp   by_pr
ld_no_disp:
    push   bx
    push   dx
    call  getkey
    pop   dx
    pop   bx
    jmp   by_disp
by_pr:
    push   bx
    push   dx
    call  un_high_guy   ; un_highlights
    call  high_guy   ; highlights the currently selected line
    call  getkey
    pop   dx
    pop   bx
by_disp:
    call  reset_segs
    mov   di,offset kline
    cld
    mov   cx,13
    xchg  al,ah
repne scasb
    jne   d_func
    xchg  al,ah
    sub   di,offset kline
    dec   di
    shl   di,1
    jmp   cs:fline[di]
fline   dw ld_top,d_return,d_esc,do_f10,do_delete,do_f10
        dw  do_home,do_up,do_pgup,do_end,do_dn,do_pgdn
        dw  do_f9
d_func:
ld_topz:
    jmp  ld_no_disp
d_esc:
    push  ax
    call  present
    pop   ax
    clc
    ret
d_return:
    push  bx
    call  present
    pop  bx
    push  bx
    call  reset_segs
; here we have to get the file into str
; if the file is a DIR then we have to change to it
    call  check_dir
    pop   bx
    jnc   do_mstrg
    clc
    jmp   do_fix
do_mstrg:
    call  reset_segs
    call  move_strg
    mov   ax,1c0dh
    clc
    ret
do_end:
    mov  ax,dircount
    sub  ax,10
    mov  bx,ax
    mov  dx,10
    jmp  ld_top
do_pgup:
   sub  bx,10
   sub  dx,10
    jmp  ld_top
do_up:
    cmp  bp,'KG'
    jne  do_up1
    inc  mousex
    cmp  mousex,8
    jl   ld_topz
    mov  mousex,0
do_up1:
    dec  bx
    dec  dx
    cmp  dx,0
    jge  ld_topy
    inc   bx
    inc   dx
    jmp  do_pgup
do_home:
    mov  bx,-1
ld_topy:
    jmp  ld_top
do_pgdn:
   add  bx,10
   add  dx,10
    jmp  ld_top
do_dn:
    cmp  bp,'KG'
    jne  do_dn1
    inc  mousex
    cmp  mousex,8
    jl   ld_topx
    mov  mousex,0
do_dn1:
    inc  bx
    inc  dx
    jmp  ld_top
ld_topx:
    jmp  ld_top
do_f9:
; same as do_f10 except strip off *.mac
; find where the file is in strg
    call  reset_segs
    lea  di,strg
    mov   cx,32
    mov   al,0
    cld
repne scasb
    dec  di
    dec  di
; now find the backslash
f9_1:
    cmp  byte ptr ds:[di],':'
    je   got_f9e
    cmp  byte ptr ds:[di],'\'
    je   got_f9e
    dec  di
    jmp  f9_1
got_f9e:
    inc  di
    mov   ax,0
    stosw
do_f10:
    call  reset_segs
    lea   si,strg
     mov   curx,80
     mov   ax,32
     add   ax,cwidth
     add   ax,cwidth
     add   ax,cwidth
     mov   cury,ax
    mov    cx,45
     mov  str_len,45
     call gstring
    cmp   al,27
    jne   do_fix
    call  fix_strg
    call  present
    mov   al,27
    ret
do_fix:
    call  fix_strg
    jmp   list_file1
do_delete:
; this deletes a file
    push  bx
    lea   dx,dconfirm
    mov   left_margin,32
    mov   curx,32
    mov   cury,100
    call  prbox
    pop   bx
notdel:
    push  bx
    call  getkey
    pop   bx
    cmp   al,13
    je    delete_it
    cmp   al,27
    jne   notdel
    call  present
    jmp   list_dir
delete_it:
; this deletes the file, set it up in strg and go
    push  ax
    push  bx
    call  present
    pop   bx
; here we have to get the file into str
    call  move_strg
    pop   ax
; strg has the guy to delete
    lea   dx,strg
    mov   ah,41h
    int   21h
    jmp list_files

fix_strg:
; analyze strg for changes
    lea  si,strg
    lea  di,cdir
    mov  bx,si
    mov  dx,si
    cmp  strg+1,':'
    jne  no_new_disk
    mov  al,strg
    or   al,60h
    sub  al,32
    mov  cdisk,al
    inc  si
    inc  si
    mov  bx,si
   mov  dx,si
no_new_disk:
; check to see if the default dir has changed
    lodsb
    cmp  al,0
    je   check_cdir
    stosb
    cmp  al,'\'
    jne  no_new_disk
    mov  bx,si
; this is where file name begins
    jmp  no_new_disk
check_cdir:
    cmp  bx,dx
    je   no_new_dir
; dx has the strg start of dir
; bx has the strg end of dir + 1
    push  bx
    sub  bx,dx
    dec  bx
; have a new dir
    mov  word ptr cdir[bx],0
    pop  bx
    jmp  done_new_dir
no_new_dir:
    mov  cdir,0
done_new_dir:
; rest is file spec
    lea  di,strg
    mov  si,bx
    cmp  byte ptr ds:[si],0
    jne  move_f10
    mov  ax,".*"
    stosw
    mov  ah,0
    stosw
    ret
move_f10:
    cld
    movsb
    cmp  byte ptr ds:[si],0
    jne  move_f10
    mov  ax,0
    stosw
    ret
d_dir2:
; display_dir2 (d_dir2) is a routine to show more information about the
; files. This will format a line with the file name (12), date (9) and
; size (8). We'll make it 32 bytes.
; this fills up the buffer with formatted strings
     MOV   CX,31
     mov   DI,0
     mov   al,0
     push  es
     mov   es,buffer
     mov   al,20h
REP     stosb
     mov   al,0
     stosb
     pop   es
     mov   dircount,0
     LEA   DX,strg
     MOV   CX,10h
     MOV   AH,4eh
     INT   21h
     JNC   good_dfirst0
     stc
     ret
good_dfirst0:
good_dfirst1:
     mov   di,-32
     cmp   file_name,'.'
     jne   good_dfirst
     jmp   got_dot_dir
good_dfirst:
     cmp   file_name,'.'
     je    got_dot_dir
     add   di,32
     inc   dircount
; have the first now format the line
got_dot_dir:
     push  di
     call  format_dir  ; formats the file from the contents of DTA
; get the next
     MOV   AH,4fh
     INT   21h
     pop   di
     JNC   good_dfirst
     clc
     RET

format_dir:
     cld
; this moves things into buffer:di
     push  es
     mov   es,buffer
     lea   si,file_name
     mov   cx,13
     mov   ah,0
fd_loop0:
     lodsb
     cmp  al,0
     je   fdloope
     cmp  al,'.'
     jne  fd_1
     mov   ah,1
fd_1:
     stosb
     loop  fd_loop0
     jmp   fdloop1
fdloope:
     cmp   ah,1
     je    fd_2
     test  fattrib,10h
     jnz fd_2
     mov   al,'.'
     stosb
     loop  fd_2
     jmp   fdloop1
fd_2:
     mov   al,20h
     stosb
     loop   fd_2
fdloop1:
; name is done, first 14 bytes is moved, now the date
;
     mov   ax,fdate
     push  ax
; month
     mov   cl,5
     shr   ax,cl
     and   ax,15
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     mov   al,'/'
     stosb
     pop   ax
     push  ax
; day
     and   ax,31
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     mov   al,'/'
     stosb
     pop   ax
; year
     mov   al,ah
     mov   ah,0
     shr   al,1
     add   al,80
     mov   cl,10
     div   cl
     or   ax,3030h
     stosw
     mov   ax,20h
     stosb
;
;  now the file size
;
     mov   al,fattrib
     and   al,10h
     cmp   al,10h
     jne   not_a_dir
     mov   ax,'  '
     stosw
     mov   ax,"D<"
     stosw
     mov   ax,'ri'
     stosw
     mov   ax,' >'
     stosw
     mov   al,' '
     stosw
     jmp   done_fdir
not_a_dir:
     push  di
     mov   ax,fsize
     mov   dx,fsize+2
     mov   cx,10000
     div   cx
; ax has the high order (over 10000), dx has the low order
     push  dx
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     mov   ax,dx
     div   cl
     or    ax,3030h
     stosw
     pop   ax
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     mov   ax,dx
     div   cl
     or    ax,3030h
     stosw
     mov   ax,20h
     stosw
     pop    di
; clean the zeroes up
     mov cx,7
     mov  al,20h
czero:
     cmp   byte ptr es:[di],'0'
     je    space_it
     jmp   done_fdir
space_it:
     stosb
     loop  czero
done_fdir:
     pop   es
     ret
;
;
crit_err:
; if a routine winds up here we have to issue the critical error
; message
     push  bx
     push  cx
     push  dx
     push  si
     push  di
     push  bp
     push  ds
     push  es
     call  reset_segs
     call  present
     call  reset_segs
     mov   left_margin,64
     mov   curx,64
     mov   cury,64
     lea   dx,crit_mess
     call  prbox
bad_key1:
     call  getkey
     cmp   al,'1'
     je    cancelit
     cmp   al,'2'
     je    retry
     cmp   al,'3'
     je    giveup
     jmp   bad_key1
cancelit:
     call  reset_dir
     call  ok_to_close
     call  present
     call  goback
retry:
     call  present
     pop    es
     pop   ds
     pop   bp
     pop   di
     pop   si
     pop   dx
     pop   cx
     pop   bx
     mov   ax,1
     clc
     iret
giveup:
     call  ok_to_close
     call  exit_prog
reset_dir:
     call  reset_segs
     lea   si,sdisk
     lea   di,cdisk
     mov   cx,65
     cld
rep  movsb
     ret

open_in:
; open_in  opens a file, returns with carry set if bad open
; ax register has error code if bad open
     PUSH  DX
     call  reset_segs
     CALL  close_file
     MOV   handle,0
     LEA   DX,strg     ; location of string of file name
     MOV   AL,2     ; i/o
     MOV   AH,3dh
     INT   21h
     JNC   good_in
     POP   DX
     RET
good_in:
; copy the good strg to last_open
     push  si
     push  di
     lea   si,strg
     lea   di,last_open
     mov   cx,63
     cld
rep  movsb
     pop   di
     pop   si
     MOV   handle,AX
     CLC
     POP   DX
     RET

write_file:
; write file
; cx has the number of records to write
; ds:dx has the location of stuff to write
; ax returns with actual number of bytes written
     PUSH  BX
     PUSH  CX
     PUSH  DX
     PUSH  ES
     cmp   cx,0
     je    bad_write
     MOV   AX,dseg
     MOV   ES,AX
     MOV   AH,40h
     MOV   BX,ES:handle
     INT   21h
     CMP   AX,CX
     JE    ok_write
; if we are here we have a bad write
; carry must be set
bad_write:
     STC
     POP   ES
     POP   DX
     POP   CX
     POP   BX
     RET
ok_write:
     CLC
     POP   ES
     POP   DX
     POP   CX
     POP   BX
     RET

read_file:
; cx has the number of records to read
; ds:dx has the location of stuff to read
; read_file reads the number of bytes in cx
; it returns number of bytes read in ax
; it sets the carry if it did not read the same number it
; was asked to read
     PUSH  BX
     PUSH  CX
     PUSH  DX
     PUSH  ES
     MOV   AX,dseg
     MOV   ES,AX
     MOV   AH,3fh
     MOV   BX,ES:handle
     INT   21h
     CMP   AX,CX
     JE    good_read
     STC
     POP   ES
     POP   DX
     POP   CX
     POP   BX
     RET
good_read:
     CLC
     POP   ES
     POP   DX
     POP   CX
     POP   BX
     RET

create_file:
; create_file assumes that DS is set correctly
; returns with carry set if unable to create the file
; error code is in ax
;
     PUSH  CX
     PUSH  DX
     call  reset_segs
     call  state_file
     jc    do_create
; got a bad file
     call  reset_segs
     call  present
     mov   left_margin,64
     mov   curx,64
     mov   cury,64
     lea   dx,strg
     call  print_string
     lea   dx,overwrite
     call  print_string
bad_ckey:
     call  getkey
     cmp   al,'Y'
     je   do_create1
     cmp   al,'y'
     je   do_create1
     cmp  al,'n'
     je   exit_create
     cmp  al,'N'
     je   exit_create
     jmp   bad_ckey
do_create1:
     call  present
do_create:
     MOV   handle,0
     MOV   AH,3ch
     LEA   DX,strg
     MOV   CX,0
     INT   21h
     JNC   goodcreate
exit_create:
     STC
     POP   DX
     POP   CX
     RET
goodcreate:
     MOV   handle,AX
     CLC
     POP   DX
     POP   CX
     RET

open_io:
; opens a file for reading and writing
;
; open_io  opens a file, returns with carry set if bad open
; ax register has error code if bad open
     PUSH  DX
     call  reset_segs
     MOV   handle,0
     LEA   DX,strg     ; location of string of file name
     MOV   AL,2     ; reading and writing
     MOV   AH,3dh
     INT   21h
     JNC   good_io
     POP   DX
     RET
good_io:
     MOV   handle,AX
     CLC
     POP   DX
     RET

close_file:
; check to see if there is indeed a file open
     call  reset_segs
     CMP   handle,0
     JNE   ok_to_close
     RET
ok_to_close:
     MOV   BX,handle
     MOV   AH,3eh
     INT   21h
     MOV   handle,0
     RET

state_file:
; this is a get_first call
; this routine "states" the presense of a file
; file is in str, if the file exists the carry is clear
; if the file does not exist then carry is set
;
     PUSH  CX
     PUSH  DX
; here we do a get first function
     LEA   DX,strg
     MOV   CX,0
     MOV   AH,4eh
     INT   21h
     pop   dx
     pop   cx
     RET

get_first:
; here we do a get first function
; returns with carry flag set or str having the file name in it
     call  reset_segs
     MOV   CX,13
     mov   DI,0
     mov   al,0
     push  es
     mov   es,buffer
REP     stosb
     pop   es
     mov   dircount,1
     CALL  state_file
     JNC   good_first
     RET
good_first:
     inc   dircount
; no longer any practical limit
;     cmp   dircount,200
;     jle   ok_dircount
;     stc
;     ret
ok_dircount:
; the file name is at 9eh of the DTA
     PUSH  CX
     push  dx
     PUSH  SI
     PUSH  DI
     lea   SI,file_name
     MOV   CX,12
     mov   ax,dircount
     dec   ax
     mul   cx
     mov   DI,0
     add  di,ax
     push  es
     mov   es,buffer
     CLD
REP     MOVSB
     pop   es
     lea   SI,file_name
     lea   di,strg
     mov   cx,13
rep     movsb
     POP   DI
     POP   SI
     pop   dx
     POP   CX
     CLC
     RET
get_next:
; get next function is same as get first with another dos call
     MOV   AH,4fh
     INT   21h
     JNC   good_first
     RET

cseg    ends
     end
