; OKPCR.ASM is the compress - decompress stuff for pcr files
;
include c:\ok\okfiles.asm
;Tom Pfau  (fixed up a bit by KPG)
;Digital Equipment Corporation
;Parsippany, NJ

hwrite macro  buff,sze
       push  ds
       push  es
       push  dx
       call  reset_segs
       mov   cx,sze
       mov   dx,buff
       mov   ax,buffer
       mov   ds,ax
       call  write_file
       pop   dx
       pop   es
       pop   ds
       endm
hread macro  buff,sze
       push  bx
       push  dx
       push  bp
       push  ds
       push  es
       call  reset_segs
       mov   ax,buffer
       mov   cx,sze
       mov  dx,buff
       mov   ds,ax
       call  read_file
       pop   es
       pop   ds
       pop   bp
       pop   dx
       pop   bx
       endm
hreadm macro  buff,sze
       push  bx
       push  dx
       push  bp
       push  ds
       push  es
       call  reset_segs
       mov   ax,buffer
       mov   cx,sze
       lea   dx,ds:buff
       mov   ds,ax
       call  read_file
       pop   es
       pop   ds
       pop   bp
       pop   dx
       pop   bx
       endm
;Hash table entry
hash_rec        struc
first   dw      ?                       ; First entry with this value
next    dw      ?                       ; Next entry along chain
char    db      ?                       ; Suffix char
hash_rec        ends

clear           equ     256
eof             equ     257
first_free      equ     258
maxmax          equ     4096
buffersize      equ     4096

;Hash table entry
hash_rec_d      struc
next_d  dw      ?                       ; prefix code
char_d  db      ?                       ; suffix char
hash_rec_d      ends

dseg segment public 'DATA'
        assume  cs:cseg,ds:dseg,es:dseg
;
extrn  buffer:word,pcr_header:byte
extrn  width_bytes:word,height_pix:word,pcr_headero:word
extrn  strg:byte,handle:word
; local data here

extrn hash_segment:word,debug:byte
pass   dw  0
cur_code        dw      0
old_code        dw      0
in_code         dw      0
free_code       dw      first_free
stack_count     dw      0
nbits           dw      9
max_code        dw      512
fin_char        db      0
k               db      0


input_buffer    equ     buffersize
output_buffer   equ     0
winput_buffer    equ    0
woutput_buffer   equ    4000h
masks           dw      1ffh,3ffh,7ffh,0fffh
bit_offset      dw      0
input_offset    dw      0
input_size      dw      0
output_offset   dw      0
output_size     dw      0
;


prefix_code     dw      0
countoff        dw      0
filecount       dw      0
filecount1      dw      0

dseg  ends



cseg    segment public 'CODE'
        assume  cs:cseg,ds:dseg,es:dseg
extrn   read_file:near,write_file:near,reset_segs:near,flush_buffer:near
extrn   reset_segs:near,calc_file_size:near,fill_buffer:near
public  pcr_read,pcr_write,pcr_in,pcr_out,pcr_write
pcr_in      PROC  NEAR
            CALL  reset_segs
; this is the area where the header info is read
            MOV   pass,0
; the first 10 bytes of the header are read already we can check the
; file type and version here
; read the file header information
            CMP   WORD  PTR   pcr_header.pcr_kpg,"PK"
            JNE   bad_read
            CMP   pcr_header.pcr_kpg+2,"G"
            JNE   bad_read
            CMP   pcr_header.pcr_vers,0201h
            JG    bad_version
; get by the name record
            CMP   pcr_header.pcr_rec10,10h
            JNE   bad_version
; got the header alright, now we have to read in the file name
            MOV   CX,pcr_header.pcr_10_len
            LEA   DX,pcr_header.pcr_name
            CALL  read_file
            CMP   AX,CX
            JNE   bad_read
; got past the name
            JMP   by_bad
bad_version:
bad_read:
            STC
            RET
by_bad:
; now the header stuff for reading the file
            LEA   DX,pcr_header.pcr_data_head
            MOV   CX,11
            CALL  read_file
            CMP   AX,11
            JNE   bad_read
            CMP   pcr_header.pcr_data_head,18
            JNE   bad_version
            MOV   AX,pcr_header.pcr_fcount
            SUB   AX,11
            JNC   good_fcount
            DEC   pcr_header.pcr_fcount1
good_fcount:
; set up the width_bytes and lenght_pix
            MOV   AX,pcr_header.pcr_x_in
            MOV   width_bytes,AX
            MOV   AX,pcr_header.pcr_y_in
            MOV   height_pix,AX
; initialize everyting from the last time it was used
       mov   cur_code,0
       mov   old_code,0
       mov   in_code,0
       mov   free_code,first_free
       mov   stack_count,0
       mov   nbits ,9
       mov   max_code,512
       mov   fin_char,0
       mov   k,0
       mov   bit_offset,0
       mov   input_offset,0
       mov   input_size,0
       mov   output_offset,0
       mov   output_size,0
       mov   prefix_code,0
            CLC
            RET
pcr_in      ENDP
pcr_out    proc  near
; we have to write out some id stuff to the file so it knows its us
        call  reset_segs
        call  calc_file_size
        mov   pass,0
; get the file name for the header
        lea   di,strg
        mov   al,0
        mov   cx,64
        cld
repne   scasb
        inc   cx
        neg   cx
        add   cx,64
; cx has the length of the file name
        mov   pcr_headero.pcr_10_len,cx
        mov   bx,cx
        add   bx,11    ; 5+5+1 added to namelen = filecount stuff
        mov   countoff,bx
        lea   di,pcr_headero.pcr_name
        lea   si,strg
        cld
rep     movsb        ; move in name
; write out this portion of the header
        mov   cx,bx
        dec   cx
        lea   dx,pcr_headero.pcr_kpg
        call  write_file
        jnc   no_pcr_cerr
        jmp     pcr_cerr
no_pcr_cerr:
        mov     filecount1,0
        mov     filecount,6  ;crc+x+y
; now do the  x and y
        mov   ax,width_bytes
        mov   pcr_headero.pcr_x_in,ax
        mov   ax,height_pix
        mov   pcr_headero.pcr_y_in,ax
; write out the pcr_data_head stuff
        mov   cx,11
        lea   dx,pcr_headero.pcr_data_head
        call  write_file
        jc    pcr_cerr
; initialize everyting from the last time it was used
       mov   cur_code,0
       mov   old_code,0
       mov   in_code,0
       mov   free_code,first_free
       mov   stack_count,0
       mov   nbits ,9
       mov   max_code,512
       mov   fin_char,0
       mov   k,0
       mov   bit_offset,0
       mov   input_offset,0
       mov   input_size,0
       mov   output_offset,0
       mov   output_size,0
       mov   prefix_code,0
        clc
        ret
pcr_cerr:
        stc
        ret
pcr_out     endp
;
pcr_write       proc    near
        call    reset_segs
l1:     call    init_table              ;Initialize the table and some vars
        mov     ax,clear                ;Write a clear code
        call    write_code
        call    read_char               ;Read first char
l4:     xor     ah,ah                   ;Turn char into code
l4a:    mov     prefix_code,ax          ;Set prefix code
        call    read_char               ;Read next char
        jc      l17                     ;Carry means eof
        mov     k,al                    ;Save char in k
        mov     bx,prefix_code          ;Get prefix code
        call    lookup_code             ;See if this pair in table
        jnc     l4a                     ;nc means yes, new code in ax
        call    add_code                ;Add pair to table
        push    bx                      ;Save new code
        mov     ax,prefix_code          ;Write old prefix code
        call    write_code
        pop     bx
        mov     al,k                    ;Get last char
        cmp     bx,max_code             ;Exceed code size?
        jl      l4                      ;less means no
        cmp     nbits,12                ;Currently less than 12 bits?
        jl      l14                     ;yes
        mov     ax,clear                ;Write a clear code
        call    write_code
        call    init_table              ;Reinit table
        mov     al,k                    ;get last char
        jmp     l4                      ;Start over
l14:    inc     nbits                   ;Increase number of bits
        shl     max_code,1              ;Double max code size
        jmp     l4                      ;Get next char
l17:    mov     ax,prefix_code          ;Write last code
        call    write_code
        mov     ax,eof                  ;Write eof code
        call    write_code
        mov     ax,output_offset                ;Make sure buffer is flushed to file
        cmp     ax,0
        je      l18
        mov     cx,8                    ;convert bits to bytes
        xor     dx,dx
        div     cx
        or      dx,dx                   ;If extra bits, make sure they get
        je      l17a                    ;written
        inc     ax
l17a:   call    flush
l18:
        call   fix_pcr_count
        clc
        ret
pcr_write       endp

init_table      proc    near
        mov     nbits,9                 ;Set code size to 9
        mov     max_code,512            ;Set max code to 512
        push    es                      ;Save seg reg
        mov     es,hash_segment         ;Address hash table
        mov     ax,-1                   ;Unused flag
        mov     cx,640                  ;Clear first 256 entries
        mov     di,0            ;Point to first entry
rep     stosw                           ;Clear it out
        pop     es                      ;Restore seg reg
        mov     free_code,first_free    ;Set next code to use
        ret                             ;done
init_table      endp

write_code      proc    near
        push    ds
        push    es
        push    ax                      ;Save code
        mov     ax,output_offset        ;Get bit offset
        mov     cx,nbits                ;Adjust bit offset by code size
        add     output_offset,cx
        mov     cx,8                    ;Convert bit offset to byte offset
        xor     dx,dx
        div     cx
        cmp     ax,buffersize-4         ;Approaching end of buffer?
        jl      wc1a                    ;less means no
        call    flush                   ;Write the buffer
        push    dx                      ;dx contains offset within byte
        add     dx,nbits                ;adjust by code size
        mov     output_offset,dx                ;new bit offset
        pop     dx                      ;restore dx
        add     ax,woutput_buffer ;Point to last byte
        mov     si,ax                   ;put in si
        push    ax
        mov     ax,buffer
        mov     ds,ax
        mov     es,ax
        pop     ax
        mov     al,byte ptr [si]        ;move byte to first position
        mov     byte ptr ds:[woutput_buffer],al
        xor     ax,ax                   ;Byte offset of zero
        jmp     short wc1
wc1a:
        push    ax
        mov     ax,buffer
        mov     ds,ax
        mov     es,ax
        pop     ax
wc1:    add     ax,woutput_buffer ;Point into buffer
        mov     di,ax                   ;Destination
        pop     ax                      ;Restore code
        mov     cx,dx                   ;offset within byte
        xor     dx,dx                   ;dx will catch bits rotated out
        jcxz    wc3                     ;If offset in byte is zero, skip shift
wc2:    shl     ax,1                    ;Rotate code
        rcl     dx,1
        loop    wc2
        or      al,byte ptr [di]        ;Grab bits currently in buffer
wc3:    stosw                           ;Save data
        mov     al,dl                   ;Grab extra bits
        stosb                           ;and save
        pop   es
        pop   ds
        ret
write_code      endp

flush           proc    near
        push    ax                      ;Save all registers
        push    bx                      ;AX contains number of bytes to write
        push    cx
        push    dx
        push    ds
        push    es
       call  reset_segs
        call   next_wait
       clc
       add   filecount,ax
       jnc   do_fb_2
       inc   filecount1
do_fb_2:
       pop   es
       pop   ds
        hwrite  woutput_buffer,ax  ;write output file
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
flush           endp

read_char       proc    near
        mov     di,input_offset         ;Anything left in buffer?
        cmp     di,input_size
        jl      rd1                     ;less means yes
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    bp
        push    ds
        push    es
        call    fill_buffer
        pop     es
        pop     ds
        pop     bp
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
;       hread   input_buffer,buffersize    ;Read next chunk of input
        cmp     ax,0                    ;Anything left?
        je      rd2                     ;equal means no, finished
        mov     input_size,ax           ;Save bytes read
        mov     input_offset,0          ;Point to beginning of buffer
        mov     di,0
rd1:
        lea     si,winput_buffer[di]     ;Point at character
        push    ds
        push    ax
        mov     ax,buffer
        mov     ds,ax
        pop     ax
        lodsb                           ;Read it in
        pop     ds
        inc     input_offset            ;Adjust pointer
        clc                             ;Success
        ret
rd2:    stc                             ;Nothing left
        ret
read_char       endp

lookup_code     proc    near
        push    ds                      ;Save seg reg
        push    ax
        mov     ax,hash_segment              ;point to hash table
        mov     ds,ax
        pop     ax
;;;;;   call    index   ;inline         ;convert code to address
        mov     si,bx                   ;si = bx * 5 (5 byte hash entries)
        shl     si,1                    ;si = bx * 2 * 2 + bx
        shl     si,1
        add     si,bx
;
        mov     di,0                    ;flag
        cmp     [si].first,-1           ;Has this code been used?
        je      gc4                     ;equal means no
        inc     di                      ;set flag
        mov     bx,[si].first           ;Get first entry
gc2:    ;all    index                   ;convert code to address
        mov     si,bx                   ;si = bx * 5 (5 byte hash entries)
        shl     si,1                    ;si = bx * 2 * 2 + bx
        shl     si,1
        add     si,bx
;
        cmp     [si].char,al            ;is char the same?
        jne     gc3                     ;ne means no
        clc                             ;success
        mov     ax,bx                   ;put found code in ax
        pop     ds                      ;restore seg reg
        ret                             ;done
gc3:    cmp     [si].next,-1            ;More left with this prefix?
        je      gc4                     ;equal means no
        mov     bx,[si].next            ;get next code
        jmp     gc2                     ;try again
gc4:    stc                             ;not found
        pop     ds                      ;restore seg reg
        ret                             ;done
lookup_code     endp

index           proc    near
        mov     si,bx                   ;si = bx * 5 (5 byte hash entries)
        shl     si,1                    ;si = bx * 2 * 2 + bx
        shl     si,1
        add     si,bx
        ret
index           endp

add_code        proc    near
        mov     bx,free_code            ;Get code to use
        push    ds                      ;point to hash table
        push    ax
        mov     ax,hash_segment
        mov     ds,ax
        pop     ax
        cmp     di,0                    ;First use of this prefix?
        je      ac1                     ;equal means yes
        mov     [si].next,bx            ;point last use to new entry
        jmp     short ac2
ac1:    mov     [si].first,bx           ;Point first use to new entry
ac2:    cmp     bx,maxmax               ;Have we reached code limit?
        je      ac3                     ;equal means yes, just return
        call    index                   ;get address of new entry
        mov     [si].first,-1           ;initialize pointers
        mov     [si].next,-1
        mov     [si].char,al            ;save suffix char
        inc     es:free_code            ;adjust next code
ac3:    pop     ds                      ;restore seg reg
        ret
add_code        endp
;
; this is the PCR_READ program called by OKFMAIN
;
; PCR_READ is the procedure which unpacks the pcr file
; this could also be used for unpacking ARC files
; it calls:
;     READ_CODE_D
;     INIT_TAB
;     WRITE_CHAR_D
;     ADD_CODE_C
;
pcr_read        proc    near
        call    reset_segs
        hread   input_buffer,buffersize    ;Read from input
; ax returns with amount in buffer
z1:
        call    read_code_d             ;Get a code
        jc     leave_early
        cmp     ax,eof                  ;End of file?
        jne     z2                      ;no
leave_early:
        cmp     output_offset,0         ;Data in output buffer?
        je      z1a                     ;no
        mov     cx,output_offset
        call    do_fb
z1a:
        mov    cx,0
        stc
        ret                             ;done
z2:     cmp     ax,clear                ;Clear code?
        jne     z7                      ;no
        call    init_tab                ;Initialize table
        call    read_code_d             ;Read next_d code
        jc      leave_early
        mov     cur_code,ax             ;Initialize variables
        mov     old_code,ax
        mov     k,al
        mov     fin_char,al
        call    write_char_d            ;Write char_dacter
        jc      z1a
        jmp     z1                      ;Get next_d code
z7:     mov     cur_code,ax             ;Save new code
        mov     in_code,ax
        mov     es,hash_segment         ;Point to hash table
        cmp     ax,free_code            ;Code in table? (k<w>k<w>k)
        jl      z11                     ;yes
        mov     ax,old_code             ;get previous code
        mov     cur_code,ax             ;make current
        mov     al,fin_char             ;get old last char_d
        push    ax                      ;push it
        inc     stack_count
z11:    cmp     cur_code,255            ;Code or char_dacter?
        jle     z15                     ;Char
        mov     bx,cur_code             ;Convert code to address
;       call    index_d
        mov     bp,bx                   ;bx = bx * 3 (3 byte entries)
        shl     bx,1                    ;bp = bx
        add     bx,bp                   ;bx = bx * 2 + bp
        mov     al,es:2[bx]             ;Get suffix char_d
        push    ax                      ;push it
        inc     stack_count
        mov     ax,es:[bx]              ;Get prefix code
        mov     cur_code,ax             ;Save it
        jmp     z11                     ;Translate again
z15:    push    ds                      ;Restore seg reg
        pop     es
        mov     ax,cur_code             ;Get code
        mov     fin_char,al             ;Save as final, k
        mov     k,al
        push    ax                      ;Push it
        inc     stack_count
        mov     cx,stack_count          ;Pop stack
        jcxz    z18                     ;If anything there
z17:    pop     ax
        call    write_char_d
        jc      z24a
        loop    z17
z18:    mov     stack_count,cx          ;Clear count on stack
        call    add_code_c              ;Add new code to table
        mov     ax,in_code              ;Save input code
        mov     old_code,ax
        mov     bx,free_code            ;Hit table limit?
        cmp     bx,max_code
        jl      z23                     ;Less means no
        cmp     nbits,12                ;Still within twelve bits?
        je      z23                     ;no (next_d code should be clear)
        inc     nbits                   ;Increase code size
        shl     max_code,1              ;Double max code
z23:    jmp     z1                      ;Get next_d code
z24: ; here we have to run out the stack and exit
        pop    ax
z24a:   loop   z24
z25:
;       int   3
        stc
        ret
pcr_read        endp

read_code_d     proc    near
        push    ds
        push    es
        mov     ax,bit_offset           ;Get bit offset
        add     ax,nbits                ;Adjust by code size
        xchg    bit_offset,ax           ;Swap
        mov     cx,8                    ;Calculate byte offset
        xor     dx,dx
        div     cx
        cmp     ax,buffersize-3         ;Approaching end of buffer?
        jl      rd0a                    ;no
        push    dx                      ;Save offset in byte
        add     dx,nbits                ;Calculate new bit offset
        mov     bit_offset,dx
        mov     cx,buffersize           ;1k buffer
        mov     bp,ax                   ;save byte offset
        sub     cx,ax                   ;Calculate bytes left
        add     ax,input_buffer ;Point to char_d
        mov     si,ax
        mov     di,input_buffer         ;Point to beginning of buffer
        push    ax
       mov      ax,buffer
       mov      ds,ax
       mov      es,ax
        pop     ax
rep     movsb                           ;Move last char_ds down
        hreadm  [di],bp    ;Fill rest of buffer
        cmp     ax,0
        jne     g_pcr_read
        pop     dx
        pop     es
        pop     ds
        stc
        ret
g_pcr_read:
        xor     ax,ax                   ;Clear ax
        pop     dx                      ;Restore offset in byte
        jmp     rd0
rd0a:
       push     ax
       mov      ax,buffer
       mov      ds,ax
       mov      es,ax
       pop      ax
rd0:    add     ax,input_buffer  ;Point to char_d
        mov     si,ax
        lodsw                           ;Get word
        mov     bx,ax                   ;Save in AX
        lodsb                           ;Next byte
        mov     cx,dx                   ;Offset in byte
        jcxz    rd2c                    ;If zero, skip shifts
rd1c:   shr     al,1                    ;Put code in low (code size) bits of BX
        rcr     bx,1
        loop    rd1c
rd2c:   mov     ax,bx                   ;put code in ax
        pop     es
        pop     ds
        mov     bx,nbits                ;mask off unwanted bits
        sub     bx,9
        shl     bx,1
        and     ax,masks[bx]
        clc
        ret
read_code_d     endp

init_tab        proc    near
        mov     nbits,9                 ;Initialize variables
        mov     max_code,512
        mov     free_code,first_free
        ret
init_tab        endp

write_char_d    proc    near
        mov     di,output_offset        ;Get offset in buffer
        cmp     di,buffersize           ;Full?
        jl      wc4                     ;no
        push    cx
        mov     cx,di
        call    do_fb
        jnc     cont_pcr1
        pop   cx
         stc
         ret
cont_pcr1:
        pop     cx
        mov     di,0                    ;Point to beginning of buffer
        mov     output_offset,di
wc4:
        lea     di,output_buffer[di]    ;Point into buffer
        push    es
        mov     es,buffer
        stosb                           ;Store char_d
        pop     es
        inc     output_offset           ;Increment number of char_ds in buffer
        clc
        ret
write_char_d    endp


add_code_c      proc    near
        mov     bx,free_code            ;Get new code
        mov     bp,bx                   ;bx = bx * 3 (3 byte entries)
        shl     bx,1                    ;bp = bx
        add     bx,bp                   ;bx = bx * 2 + bp
        push    es                      ;point to hash table
        mov     es,hash_segment
        mov     al,k                    ;get suffix char_d
        mov     es:[bx].char_d,al               ;save it
        mov     ax,old_code             ;get prefix code
        mov     es:[bx].next_d,ax               ;save it
        pop     es
        inc     free_code               ;set next_d code
        ret
add_code_c      endp

do_fb  proc near
       push  ax
       push  bx
       push  cx
       push  dx
       push  si
       push  di
       push  bp
       push  ds
       push  es
extrn next_wait:near
       call  next_wait
       call  flush_buffer
       pop   es
       pop   ds
       pop   bp
       pop   di
       pop   si
       pop   dx
       pop   cx
       pop   bx
       pop   ax
       ret
do_fb  endp
fix_pcr_count  proc  near
        call  reset_segs
; we have to relocate and write out the actual length of the file
        mov   cx,0
        mov   dx,countoff   ; how many bytes in the pcr_fcount begins
        mov   ah,42h
        mov   al,0
        mov   bx,handle
        int   21h
        lea   dx,filecount
        mov   cx,6
        call  write_file
          ret
fix_pcr_count  endp
;

cseg    ends

        end
