; OKSCAN2.ASM an attempt a more organized approach to scanning
DSEG segment public 'DATA'
extrn lcol:word,lrow:word,scol:word,srow:word
extrn left_margin:word,curx:word,cury:word
extrn width_bytes:word,pass:word
extrn buffer:word,height_pix:word,sneg:byte
;
;
scan_index dw  0   ; this is which of the scan routines we are using
;
;
;
;IX-12 stuff
;
sred   db  0
sres   db  0
smod   db  0
sden   db  0
;
princeton  db  0   ; princeton only flag
;
;
;
;
err1   db  "ͻ",13,10
       db  " You must specify a range and starting  ",13,10
       db  " position before you can scan or print. ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
;
err2   db  "ͻ",13,10
       db  "   The Scanner is not responding        ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
;
err3   db  "ͻ",13,10
       db  "   No device driver could be found   ",13,10
       db  "     PRESS ANY KEY TO CONTINUE       ",13,10
       db  "ͼ",0
;
;
;
; the following is for default setting informational messages
;
; =186 =187 =188 =200 =201 =205
line1  db  "ͻ",13,10
       db  " The default IX-12/Jlaser Data has been ",13,10
line3  db  " changed to:                            ",13,10
deftype equ line3+14
line4  db  "                                        ",13,10
defmess equ line4+2
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
;
mess1  db  "ͻ",13,10
       db  " Prepare the paper and the scanner ",13,10
       db  "     PRESS ANY KEY TO CONTINUE     ",13,10
       db  "ͼ",0
;
;
mess2  db  "ͻ",13,10
       db  " Move the pointer to the start location ",13,10
       db  "   (Alt-C to clear, Alt-I for Index)    ",13,10
       db  "ͼ",0
;
;
;
;
;
sredm    db  ' Horizontal Reduction Setting',0
sred1    db  'None',0
sred2    db  'One Half',0
sred3    db  'One Quarter',0
;
;
sresm    db  '      RESOLUTION',0
sres1    db  '75 DPI',0
sres2    db  '150 DPI',0
sres3    db  '200 DPI',0
sres4    db  '300 DPI',0
;
;
smodm    db  '   SCAN MODE',0
smod1    db  '2-value normal',0
smod2    db  '2-value or',0
smod3    db  'Dither',0
;
;
jsmodm    db  '   SCAN MODE',0
jsmod1    db  '2-value normal',0
jsmod2    db  '2-value or',0
jsmod3    db  'Bayer Dither',0
jsmod4    db  'Fatting Dither',0
;
;
sdenm    db  '  DENSITY CONTROL',0
sden1    db  'standard',0
sden2    db  'Dark',0
sden3    db  'Light',0
;
ux   dw  0
uy   dw  0
sx   dw  0
sy   dw  0
lx   dw  0
ly   dw  0
;
;
;
;
;
;
dseg ends
;
;
cseg segment public 'CODE'
  assume cs:cseg,ds:dseg,es:dseg
extrn reset_segs:near,cc_setup:near,calc_file_size:near,cc_setup:near
extrn flush_buffer:near,print_string:near,get_key:near,blip:near
extrn present:near,goback:near,getkey:near,set_range:near
extrn do_wait:near,first_range:near,blop:near,next_wait:near
;
scans proc near
;
scan_init dw  init_c,init_p,init_j,init_r
scan_get  dw  get_c,get_p,get_j,get_r
scan_close dw close_c,close_p,close_j,close_r
;
do_c_scan:
public do_c_scan
     call reset_segs
    mov  princeton,0
     mov  scan_index,0
     jmp  do_scans
do_p_scan:   ;panasonic
public do_p_scan
     call reset_segs
     mov  scan_index,2
     jmp  do_scans
do_j_scan:
public do_j_scan
     call reset_segs
     mov  scan_index,4
     jmp  do_scans
do_r_scan:  ;princeton
public do_r_scan
     call reset_segs
    mov  princeton,1
     mov  scan_index,6
     jmp  do_scans
;
;
;
do_scans:
; set up inital parameters
    call  reset_segs
    call present
     mov   ax,sy
     mov   srow,ax
     mov   ax,sx
     mov   scol,ax
     mov   ax,lx
     mov   lcol,ax
     mov   ax,ly
     mov   lrow,ax
;
;
;
    mov  ax,sx
    cmp  ax,lx
    jne  good_range
bad_range:
     call   present
     call   reset_segs
    lea   dx,err1
error_ent:
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     call   print_string
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
good_range:
    mov  ax,sx
    cmp  ax,lx
    je   bad_range
    mov  ax,sy
    cmp  ax,ly
    je   bad_range
    call  calc_file_size   ; sets up width and height
    call  cc_setup         ; initializes window for flush buffer
; do initialization
    mov   bx,scan_index
    call  cs:scan_init[bx]
    jnc   good_init
     call   present
     call   reset_segs
    lea   dx,err2
    jmp   error_ent
good_init:
;  here we must setup the cyle to get lines into buffer and
; and prepare to call flush buffer
      lea   dx,mess1
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     call   print_string
     call   getkey
;
     cmp    al,27
     jne    next_phase
     call   goback
next_phase:
     call   reset_segs
     call   do_wait
     mov    pass,0
; now advance the paper a few lines
     cmp    uy,0
     je     start_scanning
     mov    cx,uy
skip_loop:
     push   cx
     mov    ah,3
     mov    al,0
     int    7fh
     pop    cx
     loop   skip_loop
start_scanning:
; scan loop
;
     call   reset_segs
     mov    cx,height_pix
     mov    es,buffer
     mov    di,0
     mov    bp,0
scan_loop:
     push   bp
     push   cx
     push   di
     mov    bx,scan_index
     call   scan_get[bx]   ; get one line of graphics into buffer
     jc     end_scan
     pop    di
     add    di,width_bytes
     call   do_negate
     cmp    di,6000h
     jl     by_flush1
     push   di
     push   es
     call   next_wait
;
c_flush:
     mov    cx,di
     call   flush_buffer
;
by_cflush:
;
;
     pop    es
     pop    di
     jnc    by_flush1a
     mov    di,0
     call   reset_segs
     pop   cx
     pop     bp
     jmp    end_scan
by_flush1a:
     call   reset_segs
     mov    di,0
by_flush1:
; check for a keystroke
;
     mov   ah,1
     int   16h
     jz    no_key_pressed
     mov   ah,0
     int   16h   ; get the key
     cmp   al,27
     jne   by_flush1
     pop   cx
     pop     bp
     call  blip
     call  blop
     call  blip
     jmp   end_scan
no_key_pressed:
;
     pop    cx
     pop     bp
     inc     bp
     loop   scanloopx
     jmp    end_scan
scanloopx:
     jmp    scan_loop
end_scan:
; this is the close up shop stuff
;
;
; initialization routines
init_c: ;initialize canon
init_r: ; initialize princeton graphics
; initialize and check and see if the scanner is present
;
; check to see if the 7f interrupt really does exist
;
    push  es
    mov   ax,0
    mov   es,ax
    mov   bx,(7fh*4)+2
    cmp   word ptr es:[bx],0
    pop   es
    jne   ok_int
     call   present
     call   reset_segs
    lea   dx,err3
    jmp error_ent
ok_int:
    mov  pass,0
    mov  ah,0
    mov  al,-1
    int  7fh
    cmp  al,0
    jge  got_board
    stc
    ret
got_board:
    cmp  princeton,1
    je   got_board2
    mov  ah,10
    mov  al,0
    int  7fh
    cmp  al,0
    jge  got_board2
    stc
    ret
got_board2:
; the board answered
;
;  set the input parameter settings
    mov  ah,1
    mov  al,sred
    or   al,sres
    or   al,smod
    or   al,sden
    mov  dx,3
    mov  cx,width_bytes
    shl  cx,1
    shl  cx,1
    shl  cx,1
    mov  bx,ux
    shl  bx,1
    shl  bx,1
    shl  bx,1
    int  7fh
    cmp  al,0
    jge  got_settings
    stc
    ret
got_settings:
     clc
     ret
init_j: ; initialize jlaser
init_p: ; init panasonic
    clc
    ret
;
; get line routines
get_c:
get_r:
; this is the get_a_line routine for canaon scanners
     mov    ah,2
     mov    al,1
    mov  cx,0
    mov  bx,0
     mov    dx,3
     int    7fh
     cmp    ax,0
     jl     no_cont_scan
     clc
     ret
no_cont_scan:
     stc
     ret
get_p:
get_j:
;
;
;close out routines
close_c:
close_r:
     cmp    di,0
     je     by_flush2
     mov    cx,di
c_flush2:
     call   flush_buffer
by_flush2:
     call   blip
     call   blip
     call   present
     call   goback
close_p:
close_j:
;
;
scans  endp
;
; these are utility routines for setting stuff for the scan
;
;
do_srange  proc  near
 public do_srange
     call  set_range
     cmp   al,27
     jne   ok_srange
     call  present
     ret
ok_srange:
     mov   ax,srow
     mov   sy,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,lcol
     mov   lx,ax
     mov   ax,lrow
     mov   ly,ax
     call  present
     ret
do_srange endp
;
;
scan_procs proc  near
set_sred1:
    mov  sred,0
    lea  si,sredm
    lea  di,sred1
    jmp  pmess
set_sred2:
    mov  sred,40h
    lea  si,sredm
    lea  di,sred2
    jmp  pmess
set_sred3:
    mov  sred,80h
    lea  si,sredm
    lea  di,sred3
    jmp  pmess
set_sres1:
    mov  sres,00h
    lea  si,sresm
    lea  di,sres1
    jmp  pmess
set_sres2:
    mov  sres,10h
    lea  si,sresm
    lea  di,sres2
    jmp  pmess
set_sres3:
    mov  sres,20h
    lea  si,sresm
    lea  di,sres3
    jmp  pmess
set_sres4:
    mov  sres,30h
    lea  si,sresm
    lea  di,sres4
    jmp  pmess
set_smod1:
    mov  smod,00h
    lea  si,smodm
    lea  di,smod1
    jmp  pmess
set_smod2:
    mov  smod,04h
    lea  si,smodm
    lea  di,smod2
    jmp  pmess
set_smod3:
    mov  smod,08h
    lea  si,smodm
    lea  di,smod3
    jmp  pmess
set_jsmod1:
    mov  smod,00h
    lea  si,smodm
    lea  di,smod1
    jmp  pmess
set_jsmod2:
    mov  smod,04h
    lea  si,jsmodm
    lea  di,jsmod2
    jmp  pmess
set_jsmod3:
    mov  smod,08h
    lea  si,jsmodm
    lea  di,jsmod3
    jmp  pmess
set_jsmod4:
    mov  smod,12h
    lea  si,jsmodm
    lea  di,jsmod4
    jmp  pmess
set_sden1:
    mov  sden,00h
    lea  si,sdenm
    lea  di,sden1
    jmp  pmess
set_sden2:
    mov  sden,01h
    lea  si,sdenm
    lea  di,sden2
    jmp  pmess
set_sden3:
    mov  sden,02h
    lea  si,sdenm
    lea  di,sden3
    jmp  pmess
    ret
public set_jsmod1
public set_jsmod2
public set_jsmod3
public set_jsmod4
public set_sres1,set_sden1,set_smod1,set_sred1
public set_sres2,set_sden2,set_smod2,set_sred2
public set_sres3,set_sden3,set_smod3,set_sred3
public set_sres4
scan_procs endp
;
;
pmess  proc near
; the pmess proc prints out the message that the default has been
; changed.
; the change message is in si, the type change is in di
     push   si
     push   di
; clear out the message
     lea    di,defmess
     mov    cx,38
     cld
     mov    al,' '
rep  stosb
     lea    di,deftype
     mov    cx,25
     cld
     mov    al,' '
rep  stosb
; now move in the type change
     pop    si
     lea    di,deftype
     mov    cx,28
dt_loop:
     lodsb
     cmp    al,0
     je     end_dt
     stosb
     loop   dt_loop
end_dt:
; now move in the defmess
     pop    si
     lea    di,defmess
     mov    cx,38
dm_loop:
     lodsb
     cmp    al,0
     je     end_dm
     stosb
     loop   dm_loop
end_dm:
; print the message
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     lea    dx,line1
     call   print_string
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
     ret
pmess  endp
;
do_negate:
; this assumes that es:di points to the end of the area just scanned
     push   ds
     push   di
     push   cx
     push   ax
     push   es
     call   reset_segs
     cmp    sneg,1
     jne    exit_negate
     pop    es
     push   es
     sub    di,width_bytes
     mov    cx,width_bytes
neg_loop:
     xor    byte ptr es:[di],0ffh
     inc   di
     loop  neg_loop
exit_negate:
     pop   es
     pop   ax
     pop   cx
     pop   di
     pop   ds
     ret
do_sstart proc near
 public do_sstart
     call  present
     mov    left_margin,64
     mov    curx,64
     mov    cury,40
     lea    dx,mess2
     call   print_string
     call  first_range
     cmp   al,27
     jne   got_first_range
     call  present
     ret
got_first_range:
     mov   ax,scol
     mov   ux,ax
     mov   ax,srow
     mov   uy,ax
     call  present
     ret
do_sstart endp
;
;
cseg  ends
      end
; OKSCAN has the IX12, Princeton and JLASER routines in it
;
;LSEG  SEGMENT PUBLIC 'DATA'
;assume cs:cseg,ds:lseg,es:lseg
;ems_map1  dw 128 dup(0)
;ems_map2  dw 128 dup(0)
;LSEG  ENDS
;
EMS macro x
    mov   ah,x
    int  67h
    or   ah,ah
    endm
DSEG  SEGMENT PUBLIC 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn left_margin:word,curx:word,cury:word,buffer:word,pass:word
extrn width_bytes:word,height_pix:word,vwid:word,scol:word,srow:word
extrn lcol:word,lrow:word,maxlines:word
extrn ems_free:word,ems_frame:word
extrn jres:word,jorig:word,jpaper:word,jtray:word
extrn sneg:byte,ems_handle:word,work_seg:word,work2_seg:word
;
; this is the CAPCard bytes
capcard equ this byte
cap_x dw 0
cap_y dw 0
cap_width dw 0
cap_length dw 0
cap_di dw 0
cap_ds dw 0
cap_width1 dw 0
;
;--beginning of jlaser communication vector
;--both jlaser driver & application pgm must reserved comsiz space

        even
combeg  equ     $

iotype  dw      2       ;0=emsorg+i/o @ec - preferred/fastest
         ;1=emsorg+i/o @ioadr
         ;2=2nd window index
emsorg  dw      0       ;jboot offset for at4 i/o
ioadr   dw      0ech    ;i/o adr to use if iotype=1
procid  dw      0       ;jlaser process id
pagcnt  dw      62d     ;image pages for 300x300 11" mode
afseg   dw      0d00h   ;application frame segment

tray    dw      1       ;0=manual feed/1=top/2=bottom
repeat  dw      1       ;no of pages to print

lnspag  dw      51d     ;lines per 16k page
bytsln  dw      320d    ;bytes per line reserved in buffer
bytspag dw      16320d  ;bytes per 16k page
lnoff   dw      0       ;byt offset for 2 pages on 1 line

bytcnt  dw      302d    ;printer bytes/line
maxdot  dw      2416d   ;printer dots/line
skipdot dw      144d    ;printer horz offset
scskipln   dw      112d    ;printer lines to blank at top of page
maxln   dw      3160d   ;printer lines to print
endln   dw      132d    ;printer lines to blank at end of page

scanbyt dw      317d    ;scanner bytes/line
scandot dw      2544d   ;scanner dots/line
skipscn dw      1       ;scanner horz offset
skipln dw      1       ;scanner lines to skip at top page
scmaxln dw      3160d   ;scanner lines to scan

;--application could change these but probably won't

tvsw    db      0       ;error msgs to console
beepsw  db      0       ;error msgs to speaker
prntarg dw      20      ;leave on -prnt for this num of lines

        dw      0,0,0,0,0,0,0   ;room for growth

;--beginning of jlaser ask/rcv selection vector

ask     db      0       ;0=ask for printer/1=ask for scanner
rcv     db      0       ;0=request accepted/1=changed/2=rejected

;--then rest of the ask/rcv vector can be changed by the jlaser
;--driver to closest fit posible, or rejected

xres    dw      300d    ;resolution wanted/accepted
yres    dw      300d
xdotsiz db      1       ;dot width 1,2
ydotsiz db      1
xmax    dw      2416d   ;dots in maximum printable page
ymax    dw      3200d

; note: jlaser+ currently supports 300,300,1,1 & 600,300,2,1
;       application must allocate enuf mem for request

ncolor  db      1       ;number of colors
lcolor  db      0       ;0=colors contiguous/1=separate planes
nshade  db      1       ;bits for each color
lshade  db      0       ;0=shades contiguous/1=separate planes

; Tall Tree does not expect to ever change firstb or white

firstb  db      7       ;bit # of 1st bit to be shifted out
white   db      0       ;if 0 white=0, if 1 white=1

        dw      0,0,0,0,0,0,0   ;max room for growth

asksiz  equ     $-ask      ;fixed forever at 32d!

; end of scanner/printer ask/receive selection vector

comsiz  equ     $-combeg        ;fixed forever at 96d!

;--end of application communication vector
; comsave is the original jlaser sector which must be saved
; in order to restore it at end of scan or print
;
comsav  db      comsiz dup (0)  ;restore to original setting

;
; local data
;
;Jlaser only stuff
jhandle  dw  0
ems_flag db  0  ; to see if ems state is saved
jlaser_flag db 0 ; to see if jlaser memory has been allocated
pgmode  db      '0'
dmaln   dw   0  ; maximum number of lines?
;
;
;IX-12 stuff
;
sred   db  0
sres   db  0
smod   db  0
sden   db  0
;
princeton  db  0   ; princeton only flag
;
; the following is for default setting informational messages
;
; =186 =187 =188 =200 =201 =205
line1  db  "ͻ",13,10
       db  " The default IX-12/Jlaser Data has been ",13,10
line3  db  " changed to:                            ",13,10
deftype equ line3+14
line4  db  "                                        ",13,10
defmess equ line4+2
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
err1   db  "ͻ",13,10
       db  "   The Scanner is not responding        ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
;
err2   db  "ͻ",13,10
       db  " An error occurred while scanning       ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
mess1  db  "ͻ",13,10
       db  " Prepare the paper and the scanner ",13,10
       db  "     PRESS ANY KEY TO CONTINUE     ",13,10
       db  "ͼ",0
;
mess2  db  "ͻ",13,10
       db  " Move the pointer to the start location ",13,10
       db  "   (Alt-C to clear, Alt-I for Index)    ",13,10
       db  "ͼ",0
;
err3   db  "ͻ",13,10
       db  "   No device driver could be found   ",13,10
       db  "     PRESS ANY KEY TO CONTINUE       ",13,10
       db  "ͼ",0
;
err4   db  "ͻ",13,10
       db  "  Insufficent EMS memory for JLASER   ",13,10
       db  "     PRESS ANY KEY TO CONTINUE        ",13,10
       db  "ͼ",0
;
err5   db  "ͻ",13,10
       db  " Jlaser failure setting density and mode",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
err5a  db  "ͻ",13,10
       db  " Insufficient memory to satisy Jlaser  ",13,10
       db  "      allocation request               ",13,10
       db  "     PRESS ANY KEY TO CONTINUE         ",13,10
       db  "ͼ",0
;
err5b  db  "ͻ",13,10
       db  "  JLASER build index failed  ",13,10
       db  "  PRESS ANY KEY TO CONTINUE  ",13,10
       db  "ͼ",0
;
err5c  db  "ͻ",13,10
       db  " JLASER Communications transfer failed ",13,10
       db  "    PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
err6   db  "ͻ",13,10
e6line db  "                                        ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
err7   db  "ͻ",13,10
       db  " You must specify a range and starting  ",13,10
       db  " position before you can scan or print. ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
err8   db  "ͻ",13,10
       db  "    Wrong version Driver for IX-12.     ",13,10
       db  "    You must use the IXHND2 driver.     ",13,10
       db  "     PRESS ANY KEY TO CONTINUE          ",13,10
       db  "ͼ",0
;
; =186 =187 =188 =200 =201 =205
help equ this byte
 db  "ͻ",13,10
 db  " SPECIAL SCANNING/PRINTING INSTRUCTIONS FOR IX-12/JLASER ",13,10
 db  " You can scan images from the IX-12 Scanner if you have  ",13,10
 db  " the Canon Interface board and software or the JLASER    ",13,10
 db  " board and EMS driver. With the JLASER you can also print",13,10
 db  " or have your scanner+laser printer act as a copier.     ",13,10
 db  " For scanning and printing you must specify a range. This",13,10
 db  " will tell OPTIKS how much of the picture to scan and    ",13,10
 db  " where to put it. You must also indicate an upper left   ",13,10
 db  " hand corner. This is not related to where the picture   ",13,10
 db  " will go in OPTIKS. The upper left hand corner is the    ",13,10
 db  " relative starting point of the scan on the page that    ",13,10
 db  " you are scanning. If you want to scan the page starting ",13,10
 db  " at the 40th line and 24th column, move the pointer to   ",13,10
 db  " that position. The range and starting position are saved",13,10
 db  " from scan to scan and don't have to be reset. All of the",13,10
 db  " above applies to JLASER printing as well.               ",13,10
 db  "   Use Alt-I to display the current pointer location.    ",13,10
 db  "                PRESS ANY KEY TO CONTINUE                ",13,10
 db  "ͼ",0
msgparity   db 'Printer parity error      '
msgnocart   db 'Printer cartridge missing '
msgjam      db 'Printer jam     '
msgtest     db 'Printer busy test printing'
msgpaper    db 'Printer out of paper      '
msgnoprint  db 'Printer error - reprint   '
;
m1  db ' No Board error on scan   '
m2  db ' Time out on scanner      '
m4  db ' Overheat error on scan   '
m5  db ' Excessive paper length   '
m6  db ' Bad data length error    '
;
sredm    db  ' Horizontal Reduction Setting',0
sred1    db  'None',0
sred2    db  'One Half',0
sred3    db  'One Quarter',0
;
;
sresm    db  '      RESOLUTION',0
sres1    db  '75 DPI',0
sres2    db  '150 DPI',0
sres3    db  '200 DPI',0
sres4    db  '300 DPI',0
;
;
smodm    db  '   SCAN MODE',0
smod1    db  '2-value normal',0
smod2    db  '2-value or',0
smod3    db  'Dither',0
;
;
jsmodm    db  '   SCAN MODE',0
jsmod1    db  '2-value normal',0
jsmod2    db  '2-value or',0
jsmod3    db  'Bayer Dither',0
jsmod4    db  'Fatting Dither',0
;
;
sdenm    db  '  DENSITY CONTROL',0
sden1    db  'standard',0
sden2    db  'Dark',0
sden3    db  'Light',0
;
ux   dw  0
uy   dw  0
sx   dw  0
sy   dw  0
lx   dw  0
ly   dw  0
;
DSEG ENDS
;
;
CSEG SEGMENT PUBLIC 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn print_string:near,blip:near,blop:near,present:near,goback:near
extrn getkey:near,flush_buffer:near,do_wait:near,next_wait:near
extrn reset_segs:near,first_range:near,set_range:near
extrn fill_buffer:near,calc_file_size:near,get_curr_seg:near
extrn get_curr2_seg:near
extrn cc_setup:near
;
do_sstart proc near
 public do_sstart
     call  present
     mov    left_margin,64
     mov    curx,64
     mov    cury,40
     lea    dx,mess2
     call   print_string
     call  first_range
     cmp   al,27
     jne   got_first_range
     call  present
     ret
got_first_range:
     mov   ax,scol
     mov   ux,ax
     mov   ax,srow
     mov   uy,ax
     call  present
     ret
do_sstart endp
;
do_srange  proc  near
 public do_srange
     call  set_range
     cmp   al,27
     jne   ok_srange
     call  present
     ret
ok_srange:
     mov   ax,srow
     mov   sy,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,lcol
     mov   lx,ax
     mov   ax,lrow
     mov   ly,ax
     call  present
     ret
do_srange endp
;
do_shelp  proc  near
public do_shelp
     call   present
     call   reset_segs
     mov    left_margin,40
     mov    curx,40
     mov    cury,8
     lea    dx,help
     call   print_string
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
     ret
do_shelp   endp
;
jlocate proc near
; this procedure sets a pointer to a line
; the line number is in BP
; if the ems page is "KG" then this is a test
;    cmp   ems_frame,"KG"
;     jne  more_jlocate
; get the address of a scan line from fake
;     mov   ax,"KG"
;     int   67h
; line returns in dx:si
;     pop  ds
;     pop  es
;     ret
;ore_jlocate:
     push  es
     push  ds
     call  reset_segs
     push  bx
     mov   bx,bp    ; has line number
     mov   si,bx
     mov   es,ems_frame
     mov   dx,es
     mov   dx,es:[bx+si+4000h]
     mov   ax,es:[bx+si+6000h]
     out   dx,al
     mov   bh,ah
     mov   bl,0
     shr   bx,1
     shr   bx,1
     mov   si,bx
     pop   bx
     pop   ds
     pop   es
;  dx:si has the start of line #BP
     ret
jlocate endp
do_xerox  proc  near
public do_xerox
; check to see if the guy is there
    call reset_segs
    call  check_ems
;
; set up xerox parms
    mov   ax,skipdot
    shr   ax,1
    shr   ax,1
    shr   ax,1
    mov   ux,ax
    mov   ax,skipdot
    add   ax,maxdot
    shr   ax,1
    shr   ax,1
    shr   ax,1
    mov   lx,ax
    mov   ax,skipln
    mov   uy,ax
    add   ax,maxln
    mov   ly,ax
    mov   ax,maxdot
    add   ax,7
    shr   ax,1
    shr   ax,1
    shr   ax,1
    mov   width_bytes,ax
;
;
    call  jscan
;
    call  jprint
;
    call  unallocate
    ret
jprint:
; prints out whats in the jlaser buffer

;--print image in buffer

     EMS 3fh ; print using jlaser
     jz     thru
     cmp     ah,91h     ;parity error code
     mov     si,offset msgparity
     je     doer
     cmp     ah,92h     ;no cartridge
     mov     si,offset msgnocart
     je     doer
     cmp     ah,93h     ;toast & jam
     mov     si,offset msgjam
     je     doer
     cmp     ah,94h     ;test printing
     mov     si,offset msgtest
     je     doer
     cmp     ah,90h     ;paper out
     mov     si,offset msgpaper
     je     doer
doer:
     lea     di,e6line+8
     mov     cx,26
     cld
rep     movsb
     lea     di,err6
    jmp error1
thru:
     ret
; check_EMS verifies that the EMS memory is available for the scan
;
check_ems:
; verifies that the ems driver exists and that there is enough
; space for jlaser to operate, it then allocates the space
; and builds the index
    call reset_segs
;   push es
;   mov  ax,0
;   mov  bx,67h*4
;   mov  es,ax
;   les  di,es:[bx]
;   cmp  word ptr es:[di+3],"KG"
;   pop  es
;   jne  checkframe
; have a fake ems
;   mov   ems_frame,"KG"
;   mov   ems_free,4096
;heckframe:
    cmp   ems_frame,0
    jne   good_frame
    lea   dx,err3
    jmp error1
good_frame:
; save the current ems state, this is in case the ems mem is
; is being used by the page sets
     mov     dx,ems_handle ; the main system ems_handle
     EMS 47h
     mov     ems_flag,1  ; means restore state on exit
;    call    save_ems_map
     clc
     ret
;
;
setup_jlaser:
; setup jlaser sets up jlaser for scans and prints
; calculate the maximum page count needed
     call   reset_segs
     mov    cx,51   ; lines per 16k page
     mov    ax,height_pix ; height of scan range
     cmp    ax,4096
     jle    ok_jheight
     mov    ax,4096
ok_jheight:
     add    ax,cx
     dec    ax
     mov    dx,0
     div    cx
     add    ax,3
; ax has the maximum number of pages to allocate, 62 is normal
     mov    pagcnt,65
     cmp    ax,65
     jle    valid_page
     mov    pagcnt,ax
valid_page:
; set up the scanner memory
     mov     bx,pagcnt
     inc     bx
; have to cmp if the page count is ok
     cmp    bx,ems_free   ; is there enough
    jle     gmem20     ;yes
    lea   dx,err4
    jmp error1
gmem20:
; allocate the jlaser pages, bx has count to allocate
     EMS 43h  ; allocate bx bytes
     jz     gmem30
     lea     dx,err5a
     jmp     error1
gmem30:
     mov     jlaser_flag,1   ; remember that we have allocated jlaser
     mov     jhandle,dx     ;process id
; build index for old method
;
;
     mov     al,0h     ;map logical page
     mov     bx,1      ; page 1
     mov     dx,jhandle
     EMS 44h     ;
     jz   gmem32
     lea     dx,err5a
     jmp     error1
gmem32:
; force the other pages also
     mov     al,2h     ;map logical page
     mov     bx,2      ; page 2
     mov     dx,jhandle
     EMS 44h     ;
     jz   gmem33
     lea     dx,err5a
     jmp     error1
gmem33:
;
     mov     al,3h     ;map logical page
     mov     bx,3      ; page 3
     EMS 44h
     jz   gmem34
     lea     dx,err5a
     jmp     error1
gmem34:
     mov     al,1h     ;map logical page
     mov     bx,0      ; used for index
     mov     dx,jhandle
     EMS 44h     ; located in 2nd phy page
     jz   gmem31
     lea     dx,err5a
     jmp     error1
gmem31:
;
;
;
;--build index for all lines in image

     mov     dx,jhandle
     mov     bx,pagcnt
     sub     bx,3
     EMS     3dh
     jz     gmem40
     lea     dx,err5b
     jmp     error1
gmem40:
     mov     dmaln,bx     ;ret value
; the old method stuff is set up for scan or print
;
; density and mode must be set
    mov  al,sred  ; these 2 are guesses
    or   al,sres  ;
    or   al,smod
    or   al,sden
; mode values:  00 - 2 val normal
;     01 - 2 val or
;     10 - bayer dithering
;     11 - fatting dithering

     mov     bx,ux
     mov     cx,width_bytes
     shl     cx,1
     shl     cx,1
     shl     cx,1
     mov     dx,uy
; 3bh is the old way of setting up scan parameters
;
     EMS 3bh
    jz     gmem0
    lea   dx,err5
    jmp error1
gmem0:
;
     ret
;
;
;
;
;
jscan:
    call reset_segs
;--scan paper into image buffer
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     lea    dx,mess1
     call   print_string
     call   getkey
     cmp    al,27
     jne    contscan1
     call   blip
     call   goback
contscan1:
     call   blip
     call   present
     call   do_wait
     mov    left_margin,0
; clear the scanner image out
;
    EMS 3eh
    jz     gmem1
    lea   dx,err2
    jmp error1
gmem1:
;
    EMS 3ch
    jz     gmem1a
    lea   dx,err2
    jmp error1
gmem1a:
; image must have scanned
     ret
;
unallocate:
     call    reset_segs
; check to see if we are in a new method or old method
;
;
; temprorary old mehtod force
;
;    jmp     old_method
;
old_method:
; frees up the pages that we used
     mov     dx,jhandle
     EMS 45h
;     EMS 38h  ; this is supposed to destroy definitions
;     cmp    ems_flag,1
;     jne    by_rest1
     call   restore_ems
by_rest1:
     mov    jlaser_flag,0
     mov    jhandle,0
     ret
restore_ems:
; restore the page map
     mov     dx,ems_handle
     EMS 48h
     ret
do_xerox  endp
;
;
setup_scan  proc  near
; begin the scan
; first set the scan mode and check to see if the scanner is there
;
;
    call  reset_segs
    call present
     mov   ax,sy
     mov   srow,ax
     mov   ax,sx
     mov   scol,ax
     mov   ax,lx
     mov   lcol,ax
     mov   ax,ly
     mov   lrow,ax
;
;
;
    mov  ax,sx
    cmp  ax,lx
    jne  good_range
bad_range:
    lea   dx,err7
    jmp error1
good_range:
    mov  ax,lx
    mov  ax,sy
    cmp  ax,ly
    je   bad_range
    call  calc_file_size
    call  cc_setup
    mov  ax,79
    mov  bx,877
    cmp  sres,10h
    jne  not_sres10
    mov  ax,159
    mov  bx,1754
not_sres10:
    cmp  sres,20h
    jne  not_sres20
    mov  ax,212
    mov  bx,2339
not_sres20:
    cmp  sres,30h
    jne  not_sres30
    mov  ax,318
    mov  bx,3508
not_sres30:
; now  set up the height_pix and width_bytes
     cmp  ax,width_bytes
     jle  ok_width_bytes
     mov  width_bytes,ax
ok_width_bytes:
     cmp  bx,height_pix
     jle  ok_height_pix
     mov  height_pix,bx
ok_height_pix:
     ret
setup_scan  endp
;
;
;
;
setup_jscan  proc  near
; begin the scan
; first set the scan mode and check to see if the scanner is there
;
    call  reset_segs
    call  setup_scan
    ret   ; this rest is the new stuff
;
    mov  ax,302  ; max width in bytes
    mov  bx,62   ; page count
    mov  cl,'0'  ; page mode
    cmp  jres,0
    jne  not_res_0
    cmp  jpaper,0
    je   got_jresx
; 300 dpi but another mode, perhaps 14 inches
    mov  cl,'1'
    mov  bx,80
    jmp  short got_jresx
not_res_0:
    mov  ax,604
    cmp  jres,1
    jne  not_res_1
; 600x300 dpi, check paper size
    mov  bx,127
    mov  cl,'2'
    cmp  jpaper,0
    je   got_jresx
    mov  cl,'3'
    mov  bx,162
got_jresx: jmp short got_jres
not_res_1:
    cmp  jres,2
    jne  not_res_2
; 600x600 dpi - no printers as of this writing support it, but
    mov   bx,244
    mov   cl,'4'
    cmp  jpaper,0
    je   got_jres
    mov   bx,310
    mov   cl,'5'
; check legal
    cmp  jpaper,1
    je   got_jres
; what else in 600x600?
    mov  bx,429
    mov  cl,'t'   ; tabloid
    cmp  jpaper,2
    je   got_jres
    mov  bx,429
    mov  cl,'n'   ; newspaper
    jmp  short got_jres
not_res_2:
; must be 1200x600
; check for letter first
    cmp  jres,3
    jne  not_res_3
    mov  bx,512
    mov  cl,'6'
    cmp  jpaper,0
    je   got_jres
    mov  bx,651
    mov  cl,'7'
    jmp  short got_jres
not_res_3:
; has to be 1200 by 1200
    mov  bx,1024
    mov  cl,'8'
    cmp  jpaper,0
    je   got_jres
    mov  bx,1303
    mov  cl,'9'
got_jres:
; now  set up the height_pix and width_bytes
     cmp  ax,width_bytes
     jle  jok_width_bytes
     mov  width_bytes,ax
jok_width_bytes:
     mov  pagcnt,bx
     mov  pgmode,cl  ; mode for new method
     ret
setup_jscan  endp
;
;
do_scan  proc near
public do_scan
     mov   princeton,0
     jmp   begin_scan
do_princeton:
public do_princeton
     mov   princeton,1
     jmp   begin_scan
do_jscant:
     mov   princeton,2
     call  check_ems
;    jmp   begin_scan
begin_scan:
     call  setup_scan
     cmp   princeton,2
     jne   not_jl1
     call  setup_jlaser
     call  jscan
     jmp   next_phase
not_jl1:
; check to see if the 7f interrupt really does exist
;
    push  es
    mov   ax,0
    mov   es,ax
    mov   bx,(7fh*4)+2
    cmp   word ptr es:[bx],0
    pop   es
    jne   ok_int
    lea   dx,err3
    jmp error1
ok_int:
    mov  pass,0
    mov  ah,0
    mov  al,-1
    int  7fh
    cmp  al,0
    jge  got_board
    lea  dx,err1
    jmp  error1
got_board:
    cmp  princeton,1
    je   got_board2
    mov  ah,10
    mov  al,0
    int  7fh
    cmp  al,0
    jge  got_board2
    lea  dx,err8
    jmp  error1
got_board2:
; the board answered
;
;  set the input parameter settings
    mov  ah,1
    mov  al,sred
    or   al,sres
    or   al,smod
    or   al,sden
    mov  dx,3
    mov  cx,width_bytes
    shl  cx,1
    shl  cx,1
    shl  cx,1
    mov  bx,ux
    shl  bx,1
    shl  bx,1
    shl  bx,1
    int  7fh
    cmp  al,0
    jge  got_settings
    lea  dx,err1
    jmp  error1
got_settings:
; now we have to set up a loop to read the data
;
    lea   dx,mess1
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     call   print_string
     call   getkey
;
     cmp    al,27
     jne    next_phase
     call   goback
next_phase:
     call   reset_segs
     call   do_wait
    mov  pass,0
     cmp    princeton,2
     je     start_scanning
; now advance the paper a few lines
     cmp    uy,0
     je     start_scanning
     mov    cx,uy
skip_loop:
     push   cx
     mov    ah,3
     mov    al,0
     int    7fh
     pop    cx
     loop   skip_loop
start_scanning:
; scan loop
     call   reset_segs
     mov    cx,height_pix
     mov    es,buffer
     mov    di,0
     mov    bp,0
scan_loop:
     push   bp
     push   cx
     push   di
     cmp    princeton,2
     jne    do_cscan
     call   jinput
     jmp    cont_scan
do_cscan:
     call   cinput
     jc     end_scan
cont_scan:
     pop    di
     add    di,width_bytes
     call   do_negate
     cmp    di,6000h
     jl     by_flush1
     push   di
     push   es
     call   next_wait
     mov    cx,di
;
     cmp    princeton,2
     jne    c_flush
     call   flush_bufferj
     jmp    by_cflush
c_flush:
     call   flush_buffer
by_cflush:
;
;
     pop    es
     pop    di
     jnc    by_flush1a
     mov    di,0
     call   reset_segs
     pop   cx
     pop     bp
     jmp    end_scan
by_flush1a:
     call   reset_segs
     mov    di,0
by_flush1:
; check for a keystroke
;
     mov   ah,1
     int   16h
     jz    no_key_pressed
     mov   ah,0
     int   16h   ; get the key
     cmp   al,27
     jne   by_flush1
     pop   cx
     pop     bp
     call  blip
     call  blop
     call  blip
     jmp   end_scan
no_key_pressed:
;
     pop    cx
     pop     bp
     inc     bp
     loop   scanloopx
     jmp    end_scan
scanloopx:
     jmp    scan_loop
end_scan:
     cmp    di,0
     je     by_flush2
     mov    cx,di
     cmp    princeton,2
     jne    c_flush2
     call   flush_bufferj
     call   unallocate
     jmp    by_flush2
c_flush2:
     call   flush_buffer
by_flush2:
     call   blip
     call   blip
     call   present
     call   goback
bad_scan:
    lea  dx,err2
    jmp  error1
;
;  canon scanner input routine
;
cinput:
     mov    ah,2
     mov    al,1
    mov  cx,0    ; isn't cx how many bytes?
    mov  bx,0
     mov    dx,3
     int    7fh
     cmp    ax,0
     jl     no_cont_scan
     clc
     ret
no_cont_scan:
     cmp    ax,-3
     jne    con_scan_error
     stc
     ret
con_scan_error:
; an error occured
;
     mov     si,offset m1
     cmp     ax,-1  ; no board
     je     doer1
     cmp     ax,-2  ;
     mov     si,offset m2
     je     doer1
     cmp     ax,-4  ;
     mov     si,offset m4
     je     doer1
     cmp     ax,-5  ;
     mov     si,offset m5
     je     doer1
     cmp     ax,-6  ;
     mov     si,offset m6
     je     doer1
doer1:
     lea     di,e6line+8
     mov     cx,26
     cld
rep     movsb
     lea     di,err6
;   jmp error1
error1:
; print the message
     push   dx
     call   present
     call   reset_segs
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     pop    dx
     call   print_string
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     cmp    jhandle,0
     je     go_go
     call   unallocate
go_go:
     call   goback
do_negate:
; this assumes that es:di points to the end of the area just scanned
     push   ds
     push   di
     push   cx
     push   ax
     push   es
     call   reset_segs
     cmp    sneg,1
     jne    exit_negate
     pop    es
     push   es
     sub    di,width_bytes
     mov    cx,width_bytes
neg_loop:
     xor    byte ptr es:[di],0ffh
     inc   di
     loop  neg_loop
exit_negate:
     pop   es
     pop   ax
     pop   cx
     pop   di
     pop   ds
     ret
do_scan  endp
;
;
;
;
do_jprint proc near
public do_jprint
; this is really the same as writing out a file
; we need to get the output data set up
     call  setup_scan
;
; now we have to set up a loop to read the data
;
     call   do_wait
; scan loop
; get a buffer full of data
     call  fill_jp     ; get a buffer from the screen
     jnc   good_wread
     jmp   end_jprint
good_wread:
     call  reset_segs
; ax and cx return with the amount of data in the buffer
     mov   bp,ax
     mov   dx,width_bytes
     mov   cx,height_pix
     mov   di,0     ; really si, from fill
     cld
jp_loop:
     push  cx
     push  dx
     push  bp
     push  di
     mov   bp,height_pix
     sub   bp,cx
; bp now has the line number we are working on
     mov   cx,dx
; get the data from the scanner
; the line to get must be in bp
     push   cx
; set up the correct guy in 01
;
;
     call   jlocate
     pop    cx
; data returns in dx:si
     push  ds
     push  es
     mov   ds,buffer    ; the from guy
     mov   es,dx     ; to guy
     xchg  si,di     ; si moves to di
; cx has the count of lines to move
rep   movsb
     pop   es
     pop   ds
     pop   di
     pop   bp
     pop   dx
     push  dx
     add   di,dx     ; next line in buffer
     sub   bp,dx     ; reduce count of bytes left
     cmp   bp,0
     jg    good_bp
     call  fill_jp
     jc    end_jprint
good_bp:
     pop   dx
     pop   cx
     loop  jp_loop
end_jprint:
     call  reset_segs
     call  jprint
     call   unallocate
     call   blip
     call   blip
     call   present
     call   goback
fill_jp:
; get some more lines for the loop
     push  dx
     push  di
     push  ds
     push  es
     call  reset_segs
; save our own memory
     mov     dx,jhandle
     EMS 47h
; restore the page map for the flush guy
     mov     dx,ems_handle
     EMS 48h
     call   fill_buffer
     push    ax
     call    reset_segs
; save flush buffers page map
     mov     dx,ems_handle
     EMS 47h
; restore the jlaser memory
     mov     dx,jhandle
     EMS 48h
;
     call   next_wait
     pop   ax
     pop   es
     pop   ds
     pop   di
     pop   dx
     mov   di,0
     cmp   ax,0
     je    fill_bad
     mov   bp,ax
     clc
     ret
fill_bad:
     stc
     ret
do_jprint endp
;
;
jinput:
; get the data from the scanner
;
;
     push   ds
     push   es
     push   di
     call   reset_segs
     call   jlocate
; data returns in dx:si
     pop    di
     pop    es
     pop    ds
     push   ds
     mov    cx,width_bytes
     mov    ds,dx
     cld
rep  movsb
     pop    ds
     ret
;
;
do_jscan  proc near
public do_jscan
     call  reset_segs
    mov  pass,0
     jmp   do_jscant
;
     call  check_ems
    call setup_scan
    call setup_jlaser
     call  jscan   ; scans the data into the buffer
;
; now we have to set up a loop to read the data
;
     call   do_wait
     call  reset_segs
; scan loop
     mov    cx,height_pix
     mov    es,buffer
     mov    di,0
     mov    bp,0   ; scan line
jscan_loop:
     push   cx
     push   bp
     push   di
     call   jinput
     call  do_negate
     pop    di
     add    di,width_bytes
     cmp    di,6000h
     jl     jby_flush1
     push   di
     push   es
     call   next_wait
     call   flush_bufferj
     pop    es
     pop    di
     jnc    jby_flush1a
     mov    di,0
     pop    bp
     pop    cx
     jmp    jend_scan
jby_flush1a:
     mov    di,0
jby_flush1:
     pop    bp
     inc    bp
     pop    cx
     loop   jscan_loop
jend_scan:
     cmp    di,0
     je     jby_flush2
     call   flush_bufferj
jby_flush2:
     call   unallocate
     call   blip
     call   blip
     call   present
     call   goback
do_jscan  endp
;
;
flush_bufferj proc  near
     push  bp
     push  di
     push   ds
     push   es
     call  reset_segs
; save our own memory
     mov     dx,jhandle
     EMS 47h
; restore the page map for the flush guy
     mov     dx,ems_handle
     EMS 48h
;
     pop   es
     pop   ds
     pop   di
     mov    cx,di
     call   flush_buffer
;
     jc     bad_jflush
     call   reset_segs
; save flush buffers page map
     mov     dx,ems_handle
     EMS 47h
; restore the jlaser memory
     mov     dx,jhandle
     EMS 48h
     pop  bp
     clc
     ret
bad_jflush:
     call    reset_segs
     mov     dx,ems_handle
     mov     ah,47h
     EMS 47h
     mov     ah,48h
     mov     dx,jhandle
     EMS 48h
     pop  bp
     stc
     ret
;
flush_bufferj  endp
;
scan_procs proc  near
set_sred1:
    mov  sred,0
    lea  si,sredm
    lea  di,sred1
    jmp  pmess
set_sred2:
    mov  sred,40h
    lea  si,sredm
    lea  di,sred2
    jmp  pmess
set_sred3:
    mov  sred,80h
    lea  si,sredm
    lea  di,sred3
    jmp  pmess
set_sres1:
    mov  sres,00h
    lea  si,sresm
    lea  di,sres1
    jmp  pmess
set_sres2:
    mov  sres,10h
    lea  si,sresm
    lea  di,sres2
    jmp  pmess
set_sres3:
    mov  sres,20h
    lea  si,sresm
    lea  di,sres3
    jmp  pmess
set_sres4:
    mov  sres,30h
    lea  si,sresm
    lea  di,sres4
    jmp  pmess
set_smod1:
    mov  smod,00h
    lea  si,smodm
    lea  di,smod1
    jmp  pmess
set_smod2:
    mov  smod,04h
    lea  si,smodm
    lea  di,smod2
    jmp  pmess
set_smod3:
    mov  smod,08h
    lea  si,smodm
    lea  di,smod3
    jmp  pmess
set_jsmod1:
    mov  smod,00h
    lea  si,smodm
    lea  di,smod1
    jmp  pmess
set_jsmod2:
    mov  smod,04h
    lea  si,jsmodm
    lea  di,jsmod2
    jmp  pmess
set_jsmod3:
    mov  smod,08h
    lea  si,jsmodm
    lea  di,jsmod3
    jmp  pmess
set_jsmod4:
    mov  smod,12h
    lea  si,jsmodm
    lea  di,jsmod4
    jmp  pmess
set_sden1:
    mov  sden,00h
    lea  si,sdenm
    lea  di,sden1
    jmp  pmess
set_sden2:
    mov  sden,01h
    lea  si,sdenm
    lea  di,sden2
    jmp  pmess
set_sden3:
    mov  sden,02h
    lea  si,sdenm
    lea  di,sden3
    jmp  pmess
    ret
public set_jsmod1
public set_jsmod2
public set_jsmod3
public set_jsmod4
public set_sres1,set_sden1,set_smod1,set_sred1
public set_sres2,set_sden2,set_smod2,set_sred2
public set_sres3,set_sden3,set_smod3,set_sred3
public set_sres4
scan_procs endp
;
;
pmess  proc near
; the pmess proc prints out the message that the default has been
; changed.
; the change message is in si, the type change is in di
     push   si
     push   di
; clear out the message
     lea    di,defmess
     mov    cx,38
     cld
     mov    al,' '
rep  stosb
     lea    di,deftype
     mov    cx,25
     cld
     mov    al,' '
rep  stosb
; now move in the type change
     pop    si
     lea    di,deftype
     mov    cx,28
dt_loop:
     lodsb
     cmp    al,0
     je     end_dt
     stosb
     loop   dt_loop
end_dt:
; now move in the defmess
     pop    si
     lea    di,defmess
     mov    cx,38
dm_loop:
     lodsb
     cmp    al,0
     je     end_dm
     stosb
     loop   dm_loop
end_dm:
; print the message
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     lea    dx,line1
     call   print_string
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
     ret
pmess  endp
;
;
;
do_cap proc near
public do_cap
; this is really the same as writing out a file
; we need to get the output data set up
     call  reset_segs
     mov   sres,30h
     call  setup_scan
     mov    ax,ux
     mov   cap_x,ax
     mov    ax,uy
     mov   cap_y,ax
;
; now we have to set up a loop to read the data
;
     call   do_wait
; get a buffer full of data
     call  fill_capp     ; get a buffer from the screen
     jnc   good_cread
     jmp   end_cap
good_cread:
     call  reset_segs
; ax and cx return with the amount of data in the buffer
     mov   bp,ax
     mov   cx,height_pix
     mov   di,0     ; really si, from fill
     cld
capp_loop:
     push  cx
     push  bp
     push  di
; bp now has the line number we are working on
     mov   cx,width_bytes
; the line to get must be in bp
;  do the thing
; data returns in dx:si
     mov   ax,buffer
     mov   cap_ds,ax
     mov   cap_di,di
     mov   cap_width,cx
     mov   cap_width1,cx
     mov   cap_length,1
     mov    ax,ux
     mov   cap_x,ax
     inc   cap_y
     mov   cx,ds
     lea   bx,capcard
     mov   ah,10h
     mov   al,47
     mov   dx,-1
     int   17h
;
     pop   di
     pop   bp
     add   di,width_bytes
     sub   bp,width_bytes ; reduce count of bytes left
     cmp   bp,0
     jg    good_cbp
     call  fill_capp
     jc    end_cap
good_cbp:
     pop   cx
     loop  capp_loop
end_cap:
     call  reset_segs
     call   blip
     call   present
     call   goback
fill_capp:
; get some more lines for the loop
     push  di
     push  ds
     push  es
     call   fill_buffer
     call  reset_segs
;
; get the page map back for us
     push  ax
     call   next_wait
     pop  ax
     pop   es
     pop   ds
     pop   di
     mov   di,0
     cmp   ax,0
     je    fill_badc
     mov   bp,ax
     clc
     ret
fill_badc:
     stc
     ret
do_cap endp
;
;
;
;
CSEG ENDS
     END
