; OKTREAD.ASM
;
; this is supposed to read in text, either into teh whole picture
; or just a portion of it
;
LSEG	SEGMENT PARA PUBLIC 'DATA'
lseg    ends
DSEG	SEGMENT PARA PUBLIC 'DATA'
	ASSUME CS:CSEG,DS:dSEG,ES:dSEG
extrn tx:word,ty:word,font:word,width_bytes:word,height_pix:word
extrn scol:word,srow:word,buffer:word
extrn save_font:word,scale:word,lscale:word
;
buffcount dw 0   ; count of guys left in buffer
buffloc   dw 0   ; location in buffer
cwidth    dw 0   ; local heigth of character
stx       dw 0   ; starting column
;
;
dseg    ends
CSEG	SEGMENT PARA PUBLIC 'CODE'
	ASSUME CS:CSEG,DS:dSEG,ES:dSEG
extrn reset_segs:near,do_rchar:near,do_font0:near,do_font1:near
extrn do_font2:near,do_font3:near,do_font4:near,calc_file_size:near
extrn read_file:near
;
;
txt_in proc near
public txt_in
; this is the setup for reading text. Since text has no header
; we just initialize the guy and leave
        call  reset_segs
        call  calc_file_size ; returns width and height
        call  get_buff
        clc
        ret
txt_in endp
;
;
;
txt_read proc near
public txt_read
; this reads in the text buffer by buffer until it is all on the
; the screen. It does not use flush buffer
;
; initialize the tx and ty
         mov  ax,srow
         mov  ty,ax
         mov  stx,ax
         mov  ax,scol
         mov  cl,3
         shl  ax,cl
         mov  tx,ax
         mov  stx,ax
; set up the current font stuff
        mov  ax,save_font
        mov  font,ax
        mov  ax,lscale
        mov  scale,ax
; get the lseg and font height
        push  es
        mov   si,font
        mov   ax,lseg
        mov   es,ax
        mov   cl,es:[si]
        pop   es
        mov  ch,0
        inc   cx
        mov   ax,scale
        mul   cx
        mov   cx,ax
        dec   cx
        mov   cwidth,cx
;
; set up stuff to loop through the data
;
        mov   ax,height_pix
        mov   dx,0
        add   ax,cx
        dec   ax
        div   cx    ; height of a character
; ax has the number of lines of text
        mov   cx,ax
tread_loop:
        push  cx
; do each line
        mov   cx,width_bytes
line_loop:
        push  cx
        call  get_byte
        jc    exit_tread1
        cmp   al,26
        je    exit_tread1
        cmp   al,10
        je    new_line
        cmp   al,13
        jne   not_cr
        mov   ax,cwidth
        add   ty,ax
        jmp   by_cr
not_cr:
        call  do_rchar
        add   tx,8  ; character width in all cases
by_cr:
        pop   cx
        loop  line_loop
        push  cx
; if we reach here we have extra things in the buffer
;
run_line:
        call  get_byte
        jc    exit_tread1
        cmp   al,10
        je    new_line
        cmp   al,13
        jne   not_cr2
        mov   ax,cwidth
        add   ty,ax
not_cr2:
        jmp   run_line
new_line:
        pop   cx
        mov   ax,stx
        mov   tx,ax
        pop   cx
        loop  tread_loop
; we are done
        mov  scale,1
          stc
          ret
exit_tread1:
; clean up the stack
          pop   cx
          pop   cx
          stc
          ret
txt_read  endp
get_byte  proc near
; reads a byte from the input stream
;
     cmp   buffcount,0
     jg    get_the_byte
     call  get_buff
     jnc   get_the_byte
     stc
     ret
get_the_byte:
     push   ds
     mov    ax,buffer
     mov    si,buffloc
     mov    ds,ax
     cld
     lodsb
     pop    ds
     mov    buffloc,si
     dec    buffcount
     clc
     ret
get_byte  endp
get_buff proc near
; gets a buffer
        mov   ax,buffer
        push  ds
        mov   ds,buffer
        mov   dx,0
        mov   cx,7fffh
        call  read_file
        pop   ds
        mov   buffcount,ax
        cmp   ax,0
        jle   bad_tread
        mov   buffloc,0
        clc
        ret
bad_tread:
        stc
        ret
get_buff  endp
CSEG	ENDS
	END
